"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.betterBtnRole=void 0;const discord_js_1=require("discord.js"),misc_1=require("./misc"),error_1=require("./error");
// ------------------------------
// ------ F U N C T I O N -------
// ------------------------------
/**
 * ## betterBtnRole
 * ### A **Button Role builder** that lets **admins create** button roles. | *Requires: [**manageBtnRole()**](https://simplyd.js.org/docs/handler/manageBtnRole)*
 *
 * @async
 * @param {ExtendedInteraction} interaction [`ExtendedInteraction`](https://simplyd.js.org/docs/typedef/extendedinteraction)
 * @param {betterbtnOptions} options [`betterbtnOptions`](https://simplyd.js.org/docs/systems/betterbtnrole#betterbtnoptions)
 * @returns {Promise<void>} `void`
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/systems/betterBtnRole)
 * @example simplydjs.betterBtnRole(interaction)
 */
async function betterBtnRole(interaction,options={strict:!1}){return new Promise(async()=>{var e=interaction["client"],t=(interaction.deferred||await interaction.deferReply({fetchReply:!0}),options?.channel||interaction.options.get("channel",!0)?.channel),o=options?.messageId||String(interaction.options.get("message")?.value),n=options?.button?.role||interaction.options.get("role")?.role,s=await t.messages.fetch(o).catch(()=>{}).then();
// If there is no message throw error (if strict)
if(!s){if(!0===options?.strict)throw new error_1.SimplyError({title:"Cannot find any messages with that message id in the channel you specified",tip:"Please check if the provided channel and messageId is correct",function:"betterBtnRole"});return interaction.followUp({content:options?.contents?.invalidMessage||"Cannot find any messages with that message id in the channel you specified",ephemeral:!0})}
// If condition to check if the message is sent by the bot
if(s.author.id!==e.user.id){if(!0===options?.strict)throw new error_1.SimplyError({title:"Cannot make other user's message a button role",tip:"Provide a message which I sent.",function:"betterBtnRole"});return interaction.followUp({content:options?.contents?.otherUserMessage||"Cannot make other user's message a button role ! Provide a message which I sent.",ephemeral:!0})}
// The "Add" type
if("Add"===options?.type)try{
// Get all button properties from CommandInteraction (a.k.a) slash command
var r=options?.button?.label||String(interaction.options.get("label")?.value)||n.name;let e=options?.button?.style||String(interaction.options.get("style")?.value)||discord_js_1.ButtonStyle.Secondary;var i=options?.button?.emoji||interaction.options.get("emoji")?.value;if(s.components)for(let t=0;s.components.length>t;t++)for(let e=0;s.components[t].components.length>e;e++)if(s.components[t].components[e].customId==="role-"+n.id)return s.components[t].components.splice(e,1),s.edit({content:s.content||"​",embeds:s.embeds,components:s.components}),interaction.followUp({content:options?.contents?.update||"Found a button with same role. Updating the existing button role.",ephemeral:!0});e=e&&(0,misc_1.toButtonStyle)(e);var c=(new discord_js_1.ButtonBuilder).setLabel(r).setStyle(e||discord_js_1.ButtonStyle.Secondary).setCustomId("role-"+n.id);if(s.components&&0!==s.components.length&&s.components[0]){if(5===s.components.length)return interaction.followUp({content:options?.contents?.overload||"Sorry.. I have no space to send buttons in that message.."});
// Get the available space in the message
var a,l=discord_js_1.ActionRowBuilder.from(s.components[s.components.length-1]);l.components.length<5?(i&&c.setEmoji(i),l.addComponents(c),await s.edit({content:s.content||"​",embeds:s.embeds,components:[l]}).then(async m=>{m=(new discord_js_1.ButtonBuilder).setLabel("View Message").setStyle(discord_js_1.ButtonStyle.Link).setURL(m.url),m=(new discord_js_1.ActionRowBuilder).addComponents([m]);interaction.followUp({content:options?.contents?.update||"Found a button with same role. Updating the existing button role.",components:[m],ephemeral:!0})}).catch(err=>{interaction.followUp({content:`\`${err.stack}\``})})):5===l.components.length&&(a=(new discord_js_1.ActionRowBuilder).addComponents([c]),await s.edit({content:s.content||"​",embeds:s.embeds,components:[l,a]}).then(async m=>{m=(new discord_js_1.ButtonBuilder).setLabel("View Message").setStyle(discord_js_1.ButtonStyle.Link).setURL(m.url),m=(new discord_js_1.ActionRowBuilder).addComponents([m]);return interaction.followUp({content:options?.contents?.success||"Done.. Added the button to the message",components:[m],ephemeral:!0})}).catch(err=>{interaction.followUp({content:`\`${err.stack}\``})}))}else{i&&c.setEmoji(i);var d=(new discord_js_1.ActionRowBuilder).addComponents([c]);await s.edit({content:s.content||"​",embeds:s.embeds,components:[d]}).then(m=>{m=(new discord_js_1.ButtonBuilder).setLabel("View Message").setStyle(discord_js_1.ButtonStyle.Link).setURL(m.url),m=(new discord_js_1.ActionRowBuilder).addComponents([m]);interaction.followUp({content:options?.contents?.success||"Done.. Added the button to the message.",components:[m],ephemeral:!0})}).catch(err=>{interaction.followUp({content:`\`${err.stack}\``})})}}catch(e){if(options?.strict)throw new error_1.SimplyError({function:"betterBtnRole (Add)",title:"An Error occured when running the function ",tip:e.stack});console.log("SimplyError - betterBtnRole (Add) | Error: "+e.stack)}else{if("Remove"!==options?.type){if(!0===options?.strict)throw new error_1.SimplyError({title:"Provide a valid type",tip:`We recognised that you are not using the correct type option.
Received: ${options?.type}. Expected: "Add"/"Remove"`,function:"betterBtnRole"});return console.log(`SimplyError - betterBtnRole (Add) | Error: Provide a valid type

We recognised that you are not using the correct type option.
Received: ${options?.type}. Expected: "Add"/"Remove"`)}try{if(!s.components||0===s.components.length||!s.components[0])return interaction.followUp({content:options?.contents?.noButton||"There is no button role in that message.. Try using correct message ID that has button roles",ephemeral:!0});if(s.components)for(let t=0;s.components.length>t;t++)for(let e=0;s.components[t].components.length>e;e++)if(s.components[t].components[e].customId==="role-"+n.id)s.components[t].components.splice(e,1),s.components[0].components&&0!==s.components[0].components.length&&s.components[0].components[0]?await s.edit({content:s.content||"​",embeds:s.embeds,components:s.components}).then(async m=>{m=(new discord_js_1.ButtonBuilder).setLabel("View Message").setStyle(discord_js_1.ButtonStyle.Link).setURL(m.url),m=(new discord_js_1.ActionRowBuilder).addComponents([m]);return interaction.followUp({content:options?.contents?.success||"Done.. Removed the button from the message.",components:[m],ephemeral:!0})}):await s.edit({content:s.content||"​",embeds:s.embeds,components:[]}).then(async m=>{m=(new discord_js_1.ButtonBuilder).setLabel("View Message").setStyle(discord_js_1.ButtonStyle.Link).setURL(m.url),m=(new discord_js_1.ActionRowBuilder).addComponents([m]);return interaction.followUp({content:options?.contents?.success||"Done.. Removed the button from the message",components:[m],ephemeral:!0})});else if(t===s.components.length-1&&e===s.components[t].components.length-1)return interaction.followUp({content:options?.contents?.noButton||"I cant identify a button role with that role in that message.",ephemeral:!0})}catch(e){if(options?.strict)throw new error_1.SimplyError({function:"betterBtnRole (Remove)",title:"An Error occured when running the function ",tip:e.stack});console.log("SimplyError - betterBtnRole (Remove) | Error: "+e.stack)}}})}exports.betterBtnRole=betterBtnRole;