"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.btnRole=void 0;const discord_js_1=require("discord.js"),error_1=require("./error"),misc_1=require("./misc");
// ------------------------------
// ------ F U N C T I O N -------
// ------------------------------
/**
 * ## btnRole
 * ### A **Button Role System** that lets you create button roles with your own message. | *Requires: [**manageBtnRole()**](https://simplyd.js.org/docs/handler/manageBtnRole)*
 *
 * @async
 * @param {ExtendedMessage|ExtendedInteraction} msgOrint [`ExtendedMessage`](https://simplyd.js.org/docs/typedef/extendedmessage) | [`ExtendedInteraction`](https://simplyd.js.org/docs/typedef/extendedinteraction)
 * @param {btnRoleOptions} options [`btnRoleOptions`](https://simplyd.js.org/docs/general/btnrole#btnroleoptions)
 * @returns {Promise<boolean>} `boolean`
 *
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/general/btnRole)
 * @example simplydjs.btnRole(message, { data: [{...}] })
 */
async function btnRole(msgOrint,options={strict:!1}){return new Promise(async resolve=>{try{if(!options?.data){if(options?.strict)throw new error_1.SimplyError({function:"btnRole",title:"Expected data object in options",tip:"Received "+(options.data||"undefined")});console.log("SimplyError - btnRole | Error:  Expected data object in options.. Received "+(options?.data||"undefined"))}const l=msgOrint,d=msgOrint;if(msgOrint.commandId)d.deferred||await d.deferReply({fetchReply:!0}),d.member.permissions.has(discord_js_1.PermissionFlagsBits.Administrator)||await d.followUp({content:"You need `ADMINISTRATOR` permission to use this command"});else{if(!msgOrint.customId&&!l.member.permissions.has(discord_js_1.PermissionFlagsBits.Administrator))return await l.reply({content:"You need `ADMINISTRATOR` permission to use this command"});var e=[],o=options.data;if(o.length<=5)t(o,[[]],e);else if(5<o.length&&o.length<=10){const button=[[],[]];t(o,button,e)}else if(11<o.length&&o.length<=15){const button=[[],[],[]];t(o,button,e)}else if(16<o.length&&o.length<=20){const button=[[],[],[],[]];t(o,button,e)}else if(21<o.length&&o.length<=25){const button=[[],[],[],[],[]];t(o,button,e)}else if(25<o.length){if(options?.strict)throw new error_1.SimplyError({function:"btnRole",title:"Reached the limit of 25 buttons..",tip:"Discord allows only 25 buttons in a message. Send a new message with more buttons."});console.log(`SimplyError - btnRole | Error: Reached the limit of 25 buttons..

Discord allows only 25 buttons in a message. Send a new message with more buttons.`)}
// Generates buttons from the data provided
}async function t(data,button,row){let t=0;for(let o=0;o<data.length;o++){5===button[t].length&&t++;var n=data[o].emoji||null;let e=data[o].style||discord_js_1.ButtonStyle.Secondary;e=e&&(0,misc_1.toButtonStyle)(e);var i=msgOrint.guild.roles.cache.find(r=>r.id===(data[o].role?.id?data[o].role.id:data[o].role));if(!i){if(options.strict)throw new error_1.SimplyError({function:"btnRole",title:"Role not found",tip:"Expected a Role or Role Id. Received "+data[o].role});console.log("SimplyError - btnRole | Error:  Role not found. Expected a Role or Role Id. Received "+data[o].role)}var s=data[o].label||i?.name;i||e!==discord_js_1.ButtonStyle.Link?button[t].push(function(label,role,color,emoji){color=color&&(0,misc_1.toButtonStyle)(color);var e=new discord_js_1.ButtonBuilder;e.setLabel(label).setStyle(color||discord_js_1.ButtonStyle.Secondary).setCustomId("role-"+role),emoji&&null!==emoji&&e.setEmoji(emoji);return e}(s,i.id,e,n)):(i=data[o].url,button[t].push(function(label,url,emoji){var e=new discord_js_1.ButtonBuilder;emoji&&null!==emoji?emoji&&null!==emoji&&e.setLabel(label).setStyle(discord_js_1.ButtonStyle.Link).setURL(url).setEmoji(emoji):e.setLabel(label).setStyle(discord_js_1.ButtonStyle.Link).setURL(url);return e}(s,i,n))),
// push the row into array (So you can add more than a row of buttons)
o===data.length-1&&(s=button[t],i=void 0,(i=new discord_js_1.ActionRowBuilder).addComponents(s),n=i,row.push(n))}if(!options.embed&&!options.content){if(options.strict)throw new error_1.SimplyError({function:"btnRole",title:"Provide an embed (or) content in the options.",tip:"Expected embed (or) content options to send. Received "+(options.embed||void 0)});console.log("SimplyError - btnRole | Error:  Provide an embed (or) content in the options. Expected embed (or) content options to send. Received "+(options.embed||void 0))}var e=(new discord_js_1.EmbedBuilder).setFooter(options?.embed?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"}).setColor(options?.embed?.color||(0,misc_1.toRgb)("#406DBC"));options?.embed?.description&&e.setDescription(options.embed?.description),options?.embed?.fields&&e.setFields(options.embed?.fields),options?.embed?.author&&e.setAuthor(options.embed?.author),options?.embed?.image&&e.setImage(options.embed?.image),options?.embed?.thumbnail&&e.setThumbnail(options.embed?.thumbnail),options?.embed?.timestamp&&e.setTimestamp(options.embed?.timestamp),options?.embed?.title&&e.setTitle(options.embed?.title),options?.embed?.url&&e.setURL(options.embed?.url),d?.commandId?(options.embed?d.followUp({content:options.content||"** **",embeds:[e],components:row}):d.followUp({content:options?.content||"** **",components:row}),resolve(!0)):d?.commandId||(options.embed?l.channel.send({content:options.content||"** **",embeds:[e],components:row}):l.channel.send({content:options.content||"** **",components:row}),resolve(!0))}}catch(e){if(resolve(!1),options?.strict)throw new error_1.SimplyError({function:"btnRole",title:"An Error occured when running the function ",tip:e.stack});console.log("SimplyError - btnRole | Error: "+e.stack)}})}exports.btnRole=btnRole;