"use strict";var __importDefault=this&&this.__importDefault||function(mod){return mod&&mod.__esModule?mod:{default:mod}};Object.defineProperty(exports,"__esModule",{value:!0}),exports.bumpReminder=void 0;const discord_js_1=require("discord.js"),bumpReminder_1=__importDefault(require("./model/bumpReminder")),misc_1=require("./misc"),error_1=require("./error");
// ------------------------------
// ------ F U N C T I O N -------
// ------------------------------
/**
 * ## bumpReminder
 * ### A Very cool bump reminder system that reminds when a bump is necessary [Only Disboard].
 *
 * **Requires you to have this in `messageCreate` and `ready` event**
 *
 * @async
 * @param {Client} client
 * @param {Message|bumpOptions} message `Message` | [`bumpOptions`](https://simplyd.js.org/docs/systems/bumpreminder#bumpoptions)
 * @param {bumpOptions} options [`bumpOptions`](https://simplyd.js.org/docs/systems/bumpreminder#bumpoptions)
 * @returns {Promise<boolean>} `boolean`
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/systems/bumpReminder)
 * @example simplydjs.bumpReminder(client, message)
 */
async function bumpReminder(client,message,options){try{if((options=!options&&message?message:options)==message||!options&&!message)return new Promise(async resolve=>{setInterval(async()=>{(await bumpReminder_1.default.find({})).forEach(async dt=>{var e;dt.nextBump&&dt.nextBump<Date.now()&&(dt.nextBump=void 0,await dt.save().catch(()=>{}),dt=await client.channels.fetch(dt.channel,{force:!0}),e=(new discord_js_1.EmbedBuilder).setTitle(options.embed?.remind?.title||"Bump Reminder !").setDescription(options.embed?.remind?.description||"Its been 2 hours since last bump. Reminding the server members to bump again.\nDo /bump to bump the server ;)").setTimestamp().setColor(options.embed?.remind?.color||(0,misc_1.toRgb)("#406DBC")).setFooter(options.embed?.remind?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"}),options?.embed?.remind?.fields&&e.setFields(options.embed?.remind?.fields),options?.embed?.remind?.author&&e.setAuthor(options.embed?.remind?.author),options?.embed?.remind?.image&&e.setImage(options.embed?.remind?.image),options?.embed?.remind?.thumbnail&&e.setThumbnail(options.embed?.remind?.thumbnail),options?.embed?.remind?.timestamp&&e.setTimestamp(options.embed?.remind?.timestamp),options?.embed?.remind?.title&&e.setTitle(options.embed?.remind?.title),options?.embed?.remind?.url&&e.setURL(options.embed?.remind?.url),await dt.send({content:message.content||"​",embeds:[e]}),resolve(!0))})},(0,misc_1.ms)("10s"))});if(0!=options?.toggle){let n=[];return options&&message.channel?new Promise(async resolve=>{if(Array.isArray(options?.channelId)?n=options?.channelId:Array.isArray(options?.channelId)||n.push(options?.channelId),"302050872383242240"===message.author.id)for(let t=0;t<n.length;t++)if(message.channel.id===n[t]&&message.embeds[0]&&message.embeds[0].description&&message.embeds[0].description.includes("Bump done")){var i=(0,misc_1.ms)("2h"),i=Date.now()+i;let e=await bumpReminder_1.default.findOne({channel:n[t]});e||await(e=new bumpReminder_1.default({counts:[],guild:message.guild.id,channel:n[t],nextBump:i})).save().catch(()=>{}),e.nextBump=i,await e.save().catch(()=>{});i=(new discord_js_1.EmbedBuilder).setTitle(options.embed?.thank?.title||"Thank you for bump!").setDescription(options.embed?.thank?.description||"Thank you for bumping the server. This means a lot. Will notify everyone after 2 hours (120 minutes)").setTimestamp().setColor(options.embed?.thank?.color||(0,misc_1.toRgb)("#209120")).setFooter(options.embed?.thank?.footer||{text:" ©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"});options?.embed?.thank?.fields&&i.setFields(options.embed?.thank?.fields),options?.embed?.thank?.author&&i.setAuthor(options.embed?.thank?.author),options?.embed?.thank?.image&&i.setImage(options.embed?.thank?.image),options?.embed?.thank?.thumbnail&&i.setThumbnail(options.embed?.thank?.thumbnail),options?.embed?.thank?.timestamp&&i.setTimestamp(options.embed?.thank?.timestamp),options?.embed?.thank?.title&&i.setTitle(options.embed?.thank?.title),options?.embed?.thank?.url&&i.setURL(options.embed?.thank?.url),await message.channel.send({content:options?.content||"​",embeds:[i]}),resolve(!0)}}):void 0}}catch(e){if(options?.strict)throw new error_1.SimplyError({function:"bumpReminder",title:"An Error occured when running the function ",tip:e.stack});console.log("SimplyError - bumpReminder | Error: "+e.stack)}}exports.bumpReminder=bumpReminder;