"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.calculator=void 0;const discord_js_1=require("discord.js"),misc_1=require("./misc"),error_1=require("./error");
// ------------------------------
// ------ F U N C T I O N -------
// ------------------------------
/**
 * ## calculator
 * ### An Unique **calculator** which can be *used inside Discord*
 *
 * @async
 * @param {ExtendedMessage | ExtendedInteraction} msgOrint [`ExtendedMessage`](https://simplyd.js.org/docs/typedef/extendedmessage) | [`ExtendedInteraction`](https://simplyd.js.org/docs/typedef/extendedinteraction)
 * @param {calculatorOptions} options [`calculatorOptions`](https://simplyd.js.org/docs/general/calculator#calculatoroptions)
 * @returns {Promise<void>} `void`
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/general/calculator)
 * @example simplydjs.calculator(interaction)
 */
async function calculator(msgOrint,options={strict:!1,buttons:{numbers:discord_js_1.ButtonStyle.Secondary,symbols:discord_js_1.ButtonStyle.Primary,delete:discord_js_1.ButtonStyle.Danger}}){return new Promise(async()=>{try{var n=[[],[],[],[],[]];const m=[];var i=["Clear","(",")","/","Back","7","8","9","*","%","4","5","6","-","^","1","2","3","+","π",".","0","00","=","Delete"];let e=0;options.embed||(options.embed={footer:{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"},color:(0,misc_1.toRgb)("#406DBC")});const a={numbers:options?.buttons?.numbers||discord_js_1.ButtonStyle.Secondary,symbols:options?.buttons?.symbols||discord_js_1.ButtonStyle.Primary,delete:options?.buttons?.delete||discord_js_1.ButtonStyle.Danger};a.delete&&(a.delete=(0,misc_1.toButtonStyle)(a.delete)),a.numbers&&(a.numbers=(0,misc_1.toButtonStyle)(a.numbers)),a.symbols&&(a.symbols=(0,misc_1.toButtonStyle)(a.symbols));let t;msgOrint.commandId||(t=msgOrint),msgOrint.commandId&&!msgOrint.deferred&&await msgOrint.deferReply({fetchReply:!0});for(let t=0;t<i.length;t++)if(5===n[e].length&&e++,n[e].push(function(label,style=a.numbers){"Clear"===label||"Delete"===label||"Back"===label?style=a.delete:"π"===label||"%"===label||"^"===label?style=a.numbers:"."===label?style=a.symbols:"="===label?style=discord_js_1.ButtonStyle.Success:isNaN(Number(label))&&(style=a.symbols);style=(new discord_js_1.ButtonBuilder).setLabel(label.toString()).setStyle(style).setCustomId("cal-"+label);return style}
// Regex for calculation to avoid any malicious code injection at eval()
(i[t])),t===i.length-1)for(const p of n)m.push(function(btns){var t=new discord_js_1.ActionRowBuilder;for(const e of btns)t.addComponents(e);return t}(p));const u=(new discord_js_1.EmbedBuilder).setColor(options?.embed?.color||(0,misc_1.toRgb)("#406DBC")).setFooter(options?.embed?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"}).setDescription("```js\n0\n// Result: 0\n```"+(options?.embed?.description?`
`+options?.embed?.description:""));options?.embed?.fields&&u.setFields(options.embed?.fields),options?.embed?.author&&u.setAuthor(options.embed?.author),options?.embed?.image&&u.setImage(options.embed?.image),options?.embed?.thumbnail&&u.setThumbnail(options.embed?.thumbnail),options?.embed?.timestamp&&u.setTimestamp(options.embed?.timestamp),options?.embed?.title&&u.setTitle(options.embed?.title),options?.embed?.url&&u.setURL(options.embed?.url);let o;var r=msgOrint,l=msgOrint;t?t&&(o=await l.reply({embeds:[u],components:m})):(await r.followUp({embeds:[u],components:m}),o=await r.fetchReply());let s="0";o.createMessageComponentCollector({filter:buttons=>buttons.user?.id===msgOrint.member.user.id&&buttons.customId.startsWith("cal-"),componentType:discord_js_1.ComponentType.Button,time:(0,misc_1.ms)("5m")}).on("collect",async buttons=>{await buttons.deferUpdate();buttons=buttons.customId.replace("cal-","");"0"===s&&(s=""),"="===buttons?(u.setDescription(`\`\`\`js
${c(s,!0)}
\`\`\``+(options.embed?.description?`
`+options.embed?.description:"")),s=c(s)):("Back"===buttons?s=s.slice(0,-1):s+=buttons.toString(),"Delete"===buttons?await o.delete().catch(()=>{}):"Clear"===buttons&&(s="0"),isNaN(Number(buttons))&&"Back"!==buttons?u.setDescription(`\`\`\`js
${s.replaceAll("+"," + ").replaceAll("*"," * ")}
	
\`\`\``+(options?.embed?.description?`
`+options?.embed?.description:"")):u.setDescription(`\`\`\`js
${s.replaceAll("+"," + ").replaceAll("*"," * ")}
// Result: ${c(s).replaceAll("^","**").replaceAll("%","/100").replace(" ","")}
\`\`\``+(options.embed?.description?`
`+options.embed?.description:""))),await o.edit({embeds:[u],components:m}).catch(()=>{})}),setTimeout(async()=>{o&&o.editable&&o&&o.editable&&(u.setDescription("Your Time for using the calculator ran out (5 minutes)"),u.setColor((0,misc_1.toRgb)("#c90000")),await o.edit({embeds:[u],components:[]}).catch(()=>{}))},(0,misc_1.ms)("5m"));const d=/^[0-9π\+\%\^\-*\/\.\(\)]*$/;function c(input,result=!1){try{return d.exec(input)?!1===result?""+Function(`"use strict";let π=Math.PI;return (${input})`)():input.replaceAll("**","^").replaceAll("/100","%")+" = "+Function(`"use strict";let π=Math.PI;return (${input})`)():"Invalid Expression"}catch{return"Wrong Input"}}}catch(t){if(options?.strict)throw new error_1.SimplyError({function:"calculator",title:"An Error occured when running the function ",tip:t.stack});console.log("SimplyError - calculator | Error: "+t.stack)}})}exports.calculator=calculator;