"use strict";var __createBinding=this&&this.__createBinding||(Object.create?function(o,m,k,k2){void 0===k2&&(k2=k),Object.defineProperty(o,k2,{enumerable:!0,get:function(){return m[k]}})}:function(o,m,k,k2){o[k2=void 0===k2?k:k2]=m[k]}),__setModuleDefault=this&&this.__setModuleDefault||(Object.create?function(o,v){Object.defineProperty(o,"default",{enumerable:!0,value:v})}:function(o,v){o.default=v}),__importStar=this&&this.__importStar||function(mod){if(mod&&mod.__esModule)return mod;var e={};if(null!=mod)for(var t in mod)"default"!==t&&Object.prototype.hasOwnProperty.call(mod,t)&&__createBinding(e,mod,t);return __setModuleDefault(e,mod),e};Object.defineProperty(exports,"__esModule",{value:!0}),exports.chatbot=void 0;const misc_1=require("./misc"),error_1=require("./error");
// ------------------------------
// ------ F U N C T I O N -------
// ------------------------------
/**
 * ## chatbot
 * ### A chatbot system that is both technically advanced and intelligent, and is your buddy.
 *
 * Implements a chatbot feature using an external API to generate responses to user messages.
 *
 * @async
 * @param {Message} message `Message`
 * @param {chatbotOptions} options [`chatbotOptions`](https://simplyd.js.org/docs/fun/chatbot#chatbotoptions)
 * @returns {Promise<void>} `void`
 *
 * ----
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/fun/chatbot)
 * @example simplydjs.chatbot(client, message)
 */
async function chatbot(message,options={strict:!1}){return new Promise(async()=>{var n=message["client"];if(!(message.author.bot||options&&!1===options?.toggle)){let t=[];Array.isArray(options.channelId)?t=options.channelId:t.push(options.channelId);try{for(const p of t)if(!await n.channels.cache.get(p)){if(options?.strict)throw new error_1.SimplyError({function:"chatbot",title:"Invalid Channel (or) No VIEW_CHANNEL permission",tip:`Check the permissions (or) Try using another Channel ID.
Received `+(options.channelId||"undefined")});console.log(`SimplyError - chatbot | Invalid Channel (or) No VIEW_CHANNEL permission

Check the permissions (or) Try using another Channel ID.
Received `+(options.channelId||"undefined"))}
//Return if the channel of the message is not a chatbot channel
if(!t.includes(message.channel.id))return null;var o=["\ud83c[\udf00-\udfff]","\ud83d[\udc00-\ude4f]","\ud83d[\ude80-\udeff]"];
// Remove such content
let e=message.cleanContent.replace(new RegExp(o.join("|"),"g"),".");
// For ChatGPT integration.
if(options?.gptToken){var{Configuration:r,OpenAIApi:a}=await Promise.resolve().then(()=>__importStar(require("openai"))).catch(()=>{throw new error_1.SimplyError({function:"chatbot",title:"Cannot find the module 'openai'",tip:"To use the chatbot with gpt, you need to install openai package. Use\n\nnpm install openai\n"})}),u=(await message.channel.sendTyping(),new r({apiKey:options?.gptToken}));const f=new a(u);return await message.reply({content:await(await f.createCompletion({model:"text-davinci-003",prompt:e})).data.choices[0].text,allowedMentions:{repliedUser:!1}})}var i=/(?:[\u2700-\u27bf]|(?:\ud83c[\udde6-\uddff]){2}|[\ud800-\udbff][\udc00-\udfff]|[\u0023-\u0039]\ufe0f?\u20e3|\u3299|\u3297|\u303d|\u3030|\u24c2|\ud83c[\udd70-\udd71]|\ud83c[\udd7e-\udd7f]|\ud83c\udd8e|\ud83c[\udd91-\udd9a]|\ud83c[\udde6-\uddff]|\ud83c[\ude01-\ude02]|\ud83c\ude1a|\ud83c\ude2f|\ud83c[\ude32-\ude3a]|\ud83c[\ude50-\ude51]|\u203c|\u2049|[\u25aa-\u25ab]|\u25b6|\u25c0|[\u25fb-\u25fe]|\u00a9|\u00ae|\u2122|\u2139|\ud83c\udc04|[\u2600-\u26FF]|\u2b05|\u2b06|\u2b07|\u2b1b|\u2b1c|\u2b50|\u2b55|\u231a|\u231b|\u2328|\u23cf|[\u23e9-\u23f3]|[\u23f8-\u23fa]|\ud83c\udccf|\u2934|\u2935|[\u2190-\u21ff])/g;
//Replacing Emojis
if((e=(e=e.replace(/<a?:.+:\d+>/gm,"")).replace(i,""))&&""!=e){options.name??="Nelly",options.developer??="Rahuletto";var d=new URL("https://simplyapi.js.org/api/chatbot"),s=d.searchParams,c=(new Date).getFullYear()-n.user.createdAt.getFullYear();s.set("message",e),s.set("developer",options.developer),s.set("name",options.name??n.user.username),s.set("age",c.toString()),s.set("year",n.user.createdAt.getFullYear().toString()),s.set("bday",n.user.createdAt.toLocaleDateString()),s.set("birthplace","Simply-Develop"),s.set("uid",message.author.id),await message.channel.sendTyping();var l=(await(0,misc_1.https)(`simplyapi.js.org${d.pathname}?`+s.toString())).reply.replace(/@everyone/g,"`@everyone`").replace(/@here/g,"`@here`");if(""===l)return message.reply({content:"That message is beyond my intelligence. I can't understand.",allowedMentions:{repliedUser:!1}});await message.reply({content:l,allowedMentions:{repliedUser:!1}})}}catch(e){if(options?.strict)throw new error_1.SimplyError({function:"chatbot",title:"An Error occured when running the function",tip:e.stack});console.log("SimplyError - chatbot | Error: "+e.stack)}}})}exports.chatbot=chatbot;