"use strict";var __importDefault=this&&this.__importDefault||function(mod){return mod&&mod.__esModule?mod:{default:mod}};Object.defineProperty(exports,"__esModule",{value:!0}),exports.connect=void 0;const mongoose_1=__importDefault(require("mongoose")),error_1=require("./error"),misc_1=require("./misc"),simplydjs_1=require("../simplydjs");
// ------------------------------
// ------ F U N C T I O N -------
// ------------------------------
/**
 * ## connect
 * ### Connect to a mongo database to access some of the simply-djs functions ! *Requires* [MongoDB](https://mongodb.com/)
 *
 * @param {string} db
 * @param {connectOptions} options [`connectOptions`](https://simplyd.js.org/docs/genera/connect#connectoptions)
 *
 * @returns {Promise<boolean>} `boolean` - A Promise that resolves to a boolean value indicating whether the database connection was
 * successful or not.
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/general/connect)
 * @example simplydjs.connect('mongoURI')
 */
async function connect(db,options={strict:!1}){return new Promise(async(resolve,reject)=>{if(!db){if(options?.strict)throw new error_1.SimplyError({function:"connect",title:"Provide an valid mongodb uri string.",tip:"Expected an MongoDB URI. Received "+(db||"undefined")});console.log("SimplyError - connect | Provide an valid mongodb uri string.\n\nExpected an MongoDB URI. Received "+(db||"undefined"))}mongoose_1.default.connect(db).then(async()=>{var e;!1!==options?.notify&&((e=(await(0,misc_1.https)("registry.npmjs.org/simply-djs"))["dist-tags"].latest).toString()!=simplydjs_1.version&&console.log(`
		Update available | ${simplydjs_1.version} >>> ${e}
		Run 'npm i simply-djs@latest' to update
`),console.log("[Simply-DJS] Database connected ✨")),resolve(!0)}).catch(err=>{reject(err.stack)})})}exports.connect=connect;