"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.manageBtnRole=void 0;const error_1=require("../error");
// ------------------------------
// ------ F U N C T I O N -------
// ------------------------------
/**
 * ## manageBtnRole
 * ### A Button Role Handler for **simplydjs button role system.**
 *
 * @async
 * @param {ButtonInteraction} button [`ButtonInteraction`](https://old.discordjs.dev/#/docs/discord.js/main/class/ButtonInteraction)
 * @param {manageBtnRoleOptions} options [`manageBtnRoleOptions`](https://simplyd.js.org/docs/handler/manageBtnRole#manageBtnRoleoptions)
 * @returns {Promise<boolean>} `boolean`
 *
 * ---
 *
 * @link `Documentation:` https://simplyd.js.org/docs/hhandler/manageBtnRole
 * @example simplydjs.manageBtnRole(interaction)
 */async function manageBtnRole(button,options={}){return new Promise(async resolve=>{if(button.isButton())try{var e=button.member;if(button.customId.startsWith("role-")){var t=button.customId.replace("role-","");const o=await button.guild.roles.fetch(t,{force:!0});o&&(await button.deferReply({ephemeral:!0}),e.roles.cache.find(r=>r.id===o.id)?e.roles.cache.find(r=>r.id===o.id)&&(e.roles.remove(o).catch(err=>{if(resolve(!1),options?.strict)throw new error_1.SimplyError({function:"manageBtnRole",title:"Role is higher than the bot. Missing Permissions",tip:err.stack});button.channel.send({content:"ERROR: Role is higher than me. `Missing Permissions`"})}),await button.editReply({content:options?.reply?.remove||`❌ Removed the ${o.toString()} role from you.`}),resolve(!0)):(e.roles.add(o).catch(err=>{if(resolve(!1),options?.strict)throw new error_1.SimplyError({function:"manageBtnRole",title:"Role is higher than the bot. Missing Permissions",tip:err.stack});button.channel.send({content:"ERROR: Role is higher than me. `Missing Permissions`"})}),await button.editReply({content:options?.reply?.add||`✅ Added the ${o.toString()} role to you.`}),resolve(!0)))}}catch(e){if(options?.strict)throw new error_1.SimplyError({function:"manageBtnRole",title:"An Error occured when running the function ",tip:e.stack});console.log("SimplyError - manageBtnRole | Error: "+e.stack)}})}exports.manageBtnRole=manageBtnRole;