"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.meme=void 0;const discord_js_1=require("discord.js"),misc_1=require("./misc"),SimplyError_1=require("./error/SimplyError");
// ------------------------------
// ------ F U N C T I O N -------
// ------------------------------
/**
 * ## meme
 * ### The memes are sent automatically, so others will able to laugh at the jokes without having to do anything !
 *
 * @async
 * @param {Client} client
 * @param {memeOptions} options [`memeOptions`](https://simplyd.js.org/docs/systems/meme#memeoptions)
 * @returns {Promise<void>} `void`
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/systems/meme)
 * @example simplydjs.meme(client, { channelId: '1234567890123' })
 * @example simplydjs.meme(channel, { sub: ["coding", "memes"] })
 */
async function meme(client,options={strict:!1}){return new Promise(async()=>{try{
// Get a channel from option or its Id
var i=options.channelId;if(!i){
// If user is strict, throw an error or just console log.
if(options?.strict)throw new SimplyError_1.SimplyError({function:"meme",title:"Channel/channelId is not specified",tip:"Expected channelId as string in options.. | Received "+(i+` (${typeof i})`||"undefined")});console.log(`SimplyError - meme | Channel/channelId is not specified


					Expected channelId as string in options.. | Received `+(i+` (${typeof i})`||"undefined"))}
// Default subreddits. Can override by array of strings in sub option
let s=["meme","me_irl","memes","dankmeme","dankmemes","ComedyCemetery","terriblefacebookmemes","funny"];Array.isArray(options.sub)?s=options.sub:Array.isArray(options.sub)||s.push(options.sub);
// Getting random subreddit
let e;if(options?.interval){if(options?.interval<6e4){if(options?.strict)throw new SimplyError_1.SimplyError({function:"meme",title:"Provide an interval time above 60000ms",tip:"Expected Interval time above 60000ms (1 minute) | Received "+(options.interval||"undefined")});console.log(`SimplyError - meme | Provide an interval time above 60000ms

Expected Interval time above 60000ms (1 minute) | Received `+(options.interval||"undefined"))}e=options.interval}else e=(0,misc_1.ms)("10m");// 600k ms (10 minutes)
function t(ch){setInterval(async()=>{var e=Math.floor(Math.random()*s.length),i=await client.channels.fetch(ch,{force:!0});
// Getting the channel from Discord
// If its unavailable, throw an error.
if(!i){if(options?.strict)throw new SimplyError_1.SimplyError({function:"meme",title:"Invalid Channel (or) No VIEW_CHANNEL permission",tip:`Check the permissions (or) Try using another Channel ID.
Received `+(options.channelId||"undefined")});console.log(`SimplyError - meme | Invalid Channel (or) No VIEW_CHANNEL permission

Check the permissions (or) Try using another Channel ID.
Received `+(options.channelId||"undefined"))}let t=s[e];t=t||"meme";
// Get a random reddit post from the subreddit
var o,n,r,e=await(0,misc_1.https)("https://meme-api.com/gimme/"+t);e&&!e.nsfw&&(o=e.postLink,n=e.url||e.preview[3],r=e.title,e=e.ups,r=(new discord_js_1.EmbedBuilder).setTitle(options.embed?.title||""+r).setURL(""+o).setImage(n).setColor(options.embed?.color||(0,misc_1.toRgb)("#406DBC")).setFooter({text:"🔺 "+e}),options?.embed?.fields&&r.setFields(options.embed?.fields),options?.embed?.author&&r.setAuthor(options.embed?.author),options?.embed?.thumbnail&&r.setThumbnail(options.embed?.thumbnail),options?.embed?.timestamp&&r.setTimestamp(options.embed?.timestamp),options?.embed?.title&&r.setTitle(options.embed?.title),options?.embed?.url&&r.setURL(options.embed?.url),await i.send({embeds:[r]}))},e)}Array.isArray(i)?i.forEach(async c=>{t(c)}):Array.isArray(i)||t(i)}catch(e){if(options?.strict)throw new SimplyError_1.SimplyError({function:"meme",title:"An Error occured when running the function ",tip:e.stack});console.log("SimplyError - meme | Error: "+e.stack)}})}exports.meme=meme;