"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.menuPages=void 0;const discord_js_1=require("discord.js"),SimplyError_1=require("./error/SimplyError"),misc_1=require("./misc");
// ------------------------------
// ------ F U N C T I O N -------
// ------------------------------
/**
 * ## menuPages
 * ### An Embed paginator using Select Menus
 *
 * @async
 * @param {ExtendedMessage | ExtendedInteraction} msgOrint [`ExtendedMessage`](https://simplyd.js.org/docs/typedef/extendedmessage) | [`ExtendedInteraction`](https://simplyd.js.org/docs/typedef/extendedinteraction)
 * @param {menuPagesOptions} options [`menuPagesOptions`](https://simplyd.js.org/docs/general/menuPages#menuPagesOptions)
 * @returns {Promise<void>} `void`
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/general/menuPages)
 * @example simplydjs.menuPages(interaction, { data: [{...}] })
 */
async function menuPages(msgOrint,options={strict:!1}){return new Promise(async()=>{try{const c=options.type||"Send";if("Send"!==c&&"Receive"!==c){if(options?.strict)throw new SimplyError_1.SimplyError({function:"menuPages",title:"There are only two types. You have provided a type which doesnt exist",tip:'There are only "Send" and "Edit" where "Send" sends a ephemeral message but "Edit" edits the original message'});console.log(`SimplyError - menuPages | Error:  There are only two types. You have provided a type which doesnt exist.

There are only "Send" and "Edit" where "Send" sends a ephemeral message but "Edit" edits the original message`)}const u=options.data;var o,n,s,r=options.rows,i=[];for(let e=0;e<u.length;e++)u[e].emoji?(o={label:u[e].label,description:u[e].description,value:u[e].label,emoji:u[e].emoji},i.push(o)):u[e].emoji||(n={label:u[e].label,description:u[e].description,value:u[e].label},i.push(n));void 0!==options.delete?.enable&&!0!==options.delete?.enable||(s={label:options?.delete?.label||"Delete",description:options.delete?.description||"Delete the Select Menu Embed",value:"delete_menuPages",emoji:options?.delete?.emoji||"❌"},i.push(s));var l=(new discord_js_1.StringSelectMenuBuilder).setMaxValues(1).setCustomId("menuPages").setPlaceholder(options.placeHolder||"Dropdown Pages").addOptions(i),a=(new discord_js_1.ActionRowBuilder).addComponents(l),d=[];if(d.push(a),r)for(let e=0;e<r.length;e++)d.push(r[e]);let e;!msgOrint.commandId||(e=msgOrint).deferred||await e.deferReply({fetchReply:!0});var m=msgOrint,p=msgOrint;let t;e?t=await m.followUp({embeds:[options.embed],components:d,fetchReply:!0}):e||(t=await p.reply({embeds:[options.embed],components:d}));const h=t.createMessageComponentCollector({componentType:discord_js_1.ComponentType.StringSelect,idle:(0,misc_1.ms)("10m")});h.on("collect",async menu=>{var t=menu.values[0];if("Edit"===c)msgOrint.member.user.id!==menu.user.id&&await menu.reply({content:"You cannot access other's pagination.",ephemeral:!0});else{"delete_menuPages"===t&&(msgOrint.member.user.id!==menu.user.id?await menu.reply({content:"You cannot access other's pagination.",ephemeral:!0}):h.stop("delete"));for(let e=0;e<u.length;e++)t===u[e].label&&("Send"===c?await menu.reply({embeds:[u[e].embed],ephemeral:!0}):"Edit"===c&&menu.message.edit({embeds:[u[e].embed]}))}}),h.on("end",async(collected,reason)=>{"delete"===reason&&await t.delete(),0===collected.size&&t.edit({embeds:[options.embed],components:[]})})}catch(e){if(options?.strict)throw new SimplyError_1.SimplyError({function:"menuPages",title:"An Error occured when running the function ",tip:e.stack});console.log("SimplyError - menuPages | Error: "+e.stack)}})}exports.menuPages=menuPages;