"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.disableButtons=void 0;const discord_js_1=require("discord.js");
/**
 * ## disableButtons
 * ### Disable all buttons in a row
 *
 * @param {ActionRowBuilder<ButtonBuilder>[]} components [`ActionRowBuilder`](https://old.discordjs.dev/#/docs/discord.js/main/class/ActionRowBuilder)
 * @returns {ActionRowBuilder<ButtonBuilder>[]}
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/misc/disableButtons)
 * @example simplydjs.disableButtons(row)
 */function disableButtons(components){
// Take all components in for loop
for(let e=0;e<components.length;e++)for(let o=0;o<components[e].components.length;o++)
// Make then into ButtonBuilder
components[e].components[o]=discord_js_1.ButtonBuilder.from(components[e].components[o]),
// Disable the button
components[e].components[o].setDisabled(!0);return components}exports.disableButtons=disableButtons;