"use strict";
/**
 * ## toRgb
 * ### Transforms Hex code into RGB Array (or) RGB String. This makes it easy to convert from discord.js v13 to v14.
 *
 * @export
 * @param {string} hex `string`
 * @returns {ColorResolvable} [`ColorResolvable`](https://discord.js.org/#/docs/discord.js/stable/typedef/ColorResolvable)
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/misc/toRgb)
 * @example simplydjs.toRgb('#406DBC')
 *
 */
function toRgb(hex){return[parseInt(hex.slice(1,3),16),parseInt(hex.slice(3,5),16),parseInt(hex.slice(5,7),16)]}Object.defineProperty(exports,"__esModule",{value:!0}),exports.toRgb=void 0,exports.toRgb=toRgb;