"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.starboard=void 0;const discord_js_1=require("discord.js"),SimplyError_1=require("./error/SimplyError");
// ------------------------------
// ------ F U N C T I O N -------
// ------------------------------
/**
 * ## starboard
 * ### Efficient yet Simplest starboard system ever existed !
 *
 * `NOTE:` **Only Use it in `messageReactionAdd`, `messageReactionRemove` and `messageDelete` events.**
 *
 * @async
 * @param {(MessageReaction|ExtendedMessage)} reactionOrMessage [`MessageReaction`](https://discord.js.org/#/docs/discord.js/stable/class/MessageReaction) | [`ExtendedMessage`](https://simplyd.js.org/docs/typedef/extendedmessage)
 * @param {starboardOptions} options [`starboardOptions`](https://simplyd.js.org/docs/systems/starboard#starboardoptions)
 * @returns {Promise<void>} `void`
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/systems/starboard)
 * @example simplydjs.starboard(reaction, { channelId: '1234567890123' })
 */
async function starboard(reactionOrMessage,options={strict:!1}){return new Promise(async()=>{var t=reactionOrMessage["client"],o=options.min||2;let e,i;if(reactionOrMessage.emoji?i=reactionOrMessage:reactionOrMessage.author&&(e=reactionOrMessage),!o||Number.isNaN(o)||0==o){if(options?.strict)throw new SimplyError_1.SimplyError({function:"starboard",title:"Minimum number of stars [min] option is not a number.",tip:`Expected an Integer/Number. Received ${o||"undefined"}.`});console.log(`SimplyError - starboard | Minimum number of stars [min] option is not a number.

Expected an Integer/Number. Received ${o||"undefined"}.`)}if(!options.channelId){if(options?.strict)throw new SimplyError_1.SimplyError({function:"starboard",title:"Provide an Channel ID to set the starboard channel"});console.log("SimplyError - starboard | Provide an Channel ID to set the starboard channel")}try{if(e&&!reactionOrMessage.message){if(e.guild){var r=await t.channels.fetch(options.channelId,{force:!0,cache:!0});if(!r){if(options?.strict)throw new SimplyError_1.SimplyError({function:"starboard",title:"Invalid Channel (or) No VIEW_CHANNEL permission",tip:`Check the permissions (or) Try using another Channel ID.
Received `+(options.channelId||"undefined")});console.log(`SimplyError - starboard | Invalid Channel (or) No VIEW_CHANNEL permission

Check the permissions (or) Try using another Channel ID.
 Received `+(options.channelId||"undefined"))}var n=(await r?.messages.fetch({limit:100})).find(msg=>msg.embeds[0]?.footer?.text=="⭐ | ID: "+e.id);return n?await n.delete():void 0}}else if(i&&(i.emoji.id==options.emoji||"⭐"==i.emoji.name||"🌟"==i.emoji.name)){var s=i.count,a=await t.channels.fetch(options.channelId,{force:!0,cache:!0});if(s<o){var d=(await a?.messages.fetch({limit:100})).find(msg=>msg.embeds[0]?.footer?.text=="⭐ | ID: "+i.message.id);if(d)return await d.delete()}if(i.message.guild&&a.guild.id===i.message.guild.id){if(!a){if(options?.strict)throw new SimplyError_1.SimplyError({function:"starboard",title:"Invalid Channel (or) No VIEW_CHANNEL permission",tip:`Check the permissions (or) Try using another Channel ID.
Received `+(options.channelId||"undefined")});console.log(`SimplyError - starboard | Invalid Channel (or) No VIEW_CHANNEL permission

Check the permissions (or) Try using another Channel ID.
 Received `+(options.channelId||"undefined"))}const g=await i.message.fetch(!0);var m=g.attachments.first();let e=m?m.url:null;g.content.match(/\bhttps?:\/\/\S+/gi)&&(e=g.content.match(/\bhttps?:\/\/\S+/gi)[0]),g.embeds[0]?.data?.thumbnail&&(e=g.embeds[0]?.data?.thumbnail?.url),g.embeds[0]?.image&&(e=g.embeds[0].image.url);var c=(new discord_js_1.EmbedBuilder).setAuthor(options?.embed?.author||{name:g.author.username,iconURL:g.author.displayAvatarURL({forceStatic:!1})}).setColor(options.embed?.color||"#FFC83D").setDescription(options.embed?.description||g.content||"** **").setTitle(options.embed?.title||"Jump to message").setURL(g.url).setFooter({text:"⭐ | ID: "+g.id}),l=(e&&c.setImage(e),options?.embed?.fields&&c.setFields(options.embed?.fields),options?.embed?.thumbnail&&c.setThumbnail(options.embed?.thumbnail),options?.embed?.timestamp&&c.setTimestamp(options.embed?.timestamp),await a?.messages.fetch({limit:100})),p=options.emoji&&t.emojis.cache.get(options?.emoji)||"⭐",u=(new discord_js_1.ButtonBuilder).setLabel((i.count||1).toString()).setEmoji(p).setCustomId("starboard").setDisabled(!0).setStyle(discord_js_1.ButtonStyle.Primary),h=(new discord_js_1.ButtonBuilder).setLabel("Jump to message").setStyle(discord_js_1.ButtonStyle.Link).setURL(g.url),b=(new discord_js_1.ActionRowBuilder).addComponents([u,h]),f=l.find(msg=>msg.embeds[0]?.footer?.text=="⭐ | ID: "+g.id);if(f){if(i.count<o)return await f.delete();await f.edit({content:`**${p} ${i.count}${m?.contentType?.startsWith("video")?`
`+e:""}**`,embeds:[c],components:[b]})}else await a.send({content:`**${p} ${i.count}${m?.contentType?.startsWith("video")?`
`+e:""}**`,embeds:[c],components:[b]})}}}catch(e){if(options?.strict)throw new SimplyError_1.SimplyError({function:"starboard",title:"An Error occured when running the function ",tip:e.stack});console.log("SimplyError - starboard | Error: "+e.stack)}})}exports.starboard=starboard;