"use strict";var __importDefault=this&&this.__importDefault||function(mod){return mod&&mod.__esModule?mod:{default:mod}};Object.defineProperty(exports,"__esModule",{value:!0}),exports.suggest=void 0;const discord_js_1=require("discord.js"),SimplyError_1=require("./error/SimplyError"),suggest_1=__importDefault(require("./model/suggest")),misc_1=require("./misc");
// ------------------------------
// ------ F U N C T I O N -------
// ------------------------------
/**
 * ## suggest
 * ### An **Beautiful** suggestion system with buttons ;D | *Requires: [**manageSuggest()**](https://simplyd.js.org/docs/handler/manageSuggest)*
 *
 * @async
 * @param {ExtendedMessage | ExtendedInteraction} msgOrint [`ExtendedMessage`](https://simplyd.js.org/docs/typedef/extendedmessage) | [`ExtendedInteraction`](https://simplyd.js.org/docs/typedef/extendedinteraction)
 * @param {suggestOptions} options [`suggestOptions`](https://simplyd.js.org/docs/systems/suggest#suggestoptions)
 * @returns {Promise<SuggestResolve>} [`SuggestResolve`](https://simplyd.js.org/docs/systems/suggest#suggestresolve)
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/systems/suggest)
 * @example simplydjs.suggest(interaction, { channelId: '1234567890123' })
 */
async function suggest(msgOrint,options={strict:!1}){return new Promise(async resolve=>{try{var o=msgOrint["client"];let n,e;if(msgOrint.commandId||!msgOrint.content){if((e=msgOrint).deferred||await e.deferReply({fetchReply:!0}),!(n=options.suggestion||String(e.options.get("suggestion").value)))return e.followUp({content:"Provide a suggestion to post.",ephemeral:!0})}else if(!msgOrint.commandId&&msgOrint.content){var s,i=msgOrint.attachments?.first(),r=i?i.url:"";if(options?.suggestion&&(n=options?.suggestion),r&&(n=n+" "+r),!options.suggestion&&msgOrint&&([...s]=msgOrint.content.split(/ +/g),n=s.slice(1).join(" ")),""===n||!n)return msgOrint.reply({content:"Provide a suggestion to post."})}options.embed||(options.embed={footer:{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"},color:(0,misc_1.toRgb)("#406DBC"),title:"New Suggestion"});const p={upvote:{style:options.buttons?.upvote?.style||discord_js_1.ButtonStyle.Primary,emoji:options.buttons?.upvote?.emoji||"☑️"},downvote:{style:options.buttons?.downvote?.style||discord_js_1.ButtonStyle.Danger,emoji:options.buttons?.downvote?.emoji||"🇽"},votedInfo:{style:options.buttons?.votedInfo?.style||discord_js_1.ButtonStyle.Success,emoji:options.buttons?.votedInfo?.emoji||"❓"}},a=(p?.upvote.style&&(p.upvote.style=(0,misc_1.toButtonStyle)(p?.upvote.style)),p?.downvote.style&&(p.downvote.style=(0,misc_1.toButtonStyle)(p?.downvote.style)),p?.votedInfo.style&&(p.votedInfo.style=(0,misc_1.toButtonStyle)(p?.votedInfo.style)),o.channels.cache.get(options?.channelId)||options?.channelId);if(!a){if(options?.strict)throw new SimplyError_1.SimplyError({function:"suggest",title:"Invalid Channel (or) No VIEW_CHANNEL permission",tip:`Check the permissions (or) Try using another Channel ID.
Received `+(options.channelId||"undefined")});console.log(`SimplyError - suggest | Invalid Channel (or) No VIEW_CHANNEL permission

Check the permissions (or) Try using another Channel ID.
 Received `+(options.channelId||"undefined"))}var m=(new discord_js_1.ButtonBuilder).setStyle(discord_js_1.ButtonStyle.Success).setLabel("Suggest").setCustomId("send-suggestion"),d=(new discord_js_1.ButtonBuilder).setStyle(discord_js_1.ButtonStyle.Danger).setLabel("Cancel").setCustomId("cancel-suggestion"),l=(new discord_js_1.ActionRowBuilder).addComponents([m,d]),u=(new discord_js_1.EmbedBuilder).setTitle(options.embed?.title||"Are you sure?").setDescription(options.embed?.description||`Is this your suggestion ? \`\`\`${n}\`\`\``).setTimestamp().setColor(options.embed?.color||(0,misc_1.toRgb)("#406DBC")).setFooter(options.embed?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"});options?.embed?.fields&&u.setFields(options.embed?.fields),options?.embed?.author&&u.setAuthor(options.embed?.author),options?.embed?.image&&u.setImage(options.embed?.image),options?.embed?.thumbnail&&u.setThumbnail(options.embed?.thumbnail),options?.embed?.timestamp&&u.setTimestamp(options.embed?.timestamp),options?.embed?.title&&u.setTitle(options.embed?.title),options?.embed?.url&&u.setURL(options.embed?.url);let t;e?t=await e.followUp({embeds:[u],components:[l],ephemeral:!0}):e||(t=await msgOrint.reply({embeds:[u],components:[l]}));var c=t.createMessageComponentCollector({filter:m=>m.user.id===msgOrint.member.user.id||(m.reply({content:`Only <@!${msgOrint.member.user.id}> can use these buttons!`,ephemeral:!0}),!1),max:1,componentType:discord_js_1.ComponentType.Button,time:(0,misc_1.ms)("15s")});c.on("collect",async b=>{var e,t,o,s;"send-suggestion"===b.customId?(await b.reply({content:"Ok, Posted. :+1:",ephemeral:!0}),await b.message.delete(),e=(new discord_js_1.EmbedBuilder).setDescription(n).setAuthor({name:msgOrint.member.user.username,iconURL:msgOrint.member.user.displayAvatarURL({forceStatic:!1})}).setColor(options.embed?.color||(0,misc_1.toRgb)("#406DBC")).setFooter(options.embed?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"}).addFields({name:"Status",value:"```\nWaiting for the response..\n```"},{name:"Percentage",value:(options?.progress?.blank||"⬛").repeat(10)+" [0% - 0%]"}),s=(new discord_js_1.ButtonBuilder).setEmoji(p?.upvote?.emoji).setLabel("0").setStyle(p?.upvote?.style||discord_js_1.ButtonStyle.Primary).setCustomId("plus-suggestion"),t=(new discord_js_1.ButtonBuilder).setEmoji(p?.downvote?.emoji).setLabel("0").setStyle(p?.downvote?.style||discord_js_1.ButtonStyle.Danger).setCustomId("minus-suggestion"),o=(new discord_js_1.ButtonBuilder).setEmoji(p?.votedInfo?.emoji).setLabel("Who Voted?").setStyle(p?.votedInfo?.style||discord_js_1.ButtonStyle.Success).setCustomId("who-voted-suggestion"),s=(new discord_js_1.ActionRowBuilder).addComponents([s,t,o]),await a.send({embeds:[e],components:[s]}).then(async ms=>{await new suggest_1.default({message:ms.id,author:msgOrint.member.user.id,progress:options?.progress||{blank:"⬛",up:"🟩",down:"🟥"}}).save(),resolve({user:msgOrint.member,suggestion:n,channel:a})})):"cancel-suggestion"===b.customId&&b.message.delete()}),c.on("end",async collected=>{0==collected.size&&t.edit({content:"Timeout.. Didn't post the suggestion.",embeds:[],components:[]})})}catch(e){if(options?.strict)throw new SimplyError_1.SimplyError({function:"suggest",title:"An Error occured when running the function",tip:e.stack});console.log("SimplyError - suggest | Error: "+e.stack)}})}exports.suggest=suggest;