"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.ticketSetup=void 0;const discord_js_1=require("discord.js"),SimplyError_1=require("./error/SimplyError"),misc_1=require("./misc");
// ------------------------------
// ------ F U N C T I O N -------
// ------------------------------
/**
 * ## ticketSetup
 * ### A Flexible yet Powerful Ticket System | *Requires: [**manageTicket()**](https://simplyd.js.org/docs/handler/manageTicket)*
 *
 * @async
 * @param {ExtendedMessage | ExtendedInteraction} msgOrint [`ExtendedMessage`](https://simplyd.js.org/docs/typedef/extendedmessage) | [`ExtendedInteraction`](https://simplyd.js.org/docs/typedef/extendedinteraction)
 * @param {ticketSetupOptions} options [`ticketSetupOptions`](https://simplyd.js.org/docs/systems/ticketsetup#ticketsetupoptions)
 * @returns {Promise<void>} `void`
 *
 * ---
 *
 * @link `Documentation:` https://simplyd.js.org/docs/systems/ticketSetup
 * @example simplydjs.ticketSetup(interaction, { channelId: '0123456789012' })
 */
async function ticketSetup(msgOrint,options={strict:!1}){return new Promise(async()=>{try{var n=msgOrint["client"];let e,t;msgOrint.commandId?(t=msgOrint,e=n.channels.cache.get(options?.channelId)||t.options.get("channel").channel,t.deferred||await t.deferReply({fetchReply:!0})):!msgOrint.commandId&&msgOrint.content&&(e=n.channels.cache.get(options?.channelId)||msgOrint.mentions.channels.first());var o=msgOrint,i=msgOrint;if(!e||!e.id){if(options?.strict)throw new SimplyError_1.SimplyError({function:"ticketSetup",title:"Provide an channel id to send the system panel.",tip:"Expected channelId as string in options.. | Received "+(options.channelId||"undefined")});console.log("SimplyError - ticketSetup | Provide an channel id to send the system panel.\n\nExpected channelId as string in options.. | Received "+(options.channelId||"undefined"))}if(!(e=e)){if(options?.strict)throw new SimplyError_1.SimplyError({function:"ticketSetup",title:"Invalid Channel (or) No VIEW_CHANNEL permission",tip:`Check the permissions (or) Try using another Channel ID.
Received `+(options.channelId||"undefined")});console.log(`SimplyError - ticketSetup | Invalid Channel (or) No VIEW_CHANNEL permission

Check the permissions (or) Try using another Channel ID.
 Received `+(options.channelId||"undefined"))}if(!msgOrint.member.permissions.has(discord_js_1.PermissionFlagsBits.Administrator)){if(t)return await o.followUp({content:"You are not an admin to create a Ticket Panel",ephemeral:!0});if(!t)return await i.reply({content:"You are not an admin to create a Ticket Panel"})}options?.button?.style&&(options.button.style=(0,misc_1.toButtonStyle)(options?.button?.style));var s=(new discord_js_1.ButtonBuilder).setStyle(options?.button?.style||discord_js_1.ButtonStyle.Primary).setEmoji(options?.button?.emoji||"🎫").setLabel(options?.button?.label||"Open a Ticket").setCustomId("create_ticket"),r=(options.embed||(options.embed={footer:{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"},color:(0,misc_1.toRgb)("#406DBC"),title:"Ticket Support"}),(new discord_js_1.ActionRowBuilder).addComponents([s])),c=(new discord_js_1.EmbedBuilder).setTitle(options.embed?.title||"Ticket Support").setColor(options.embed?.color||(0,misc_1.toRgb)("#406DBC")).setDescription(options.embed?.description||"🎫 Open a ticket by interacting with the button 🎫").setThumbnail(msgOrint.guild.iconURL()).setTimestamp().setFooter(options.embed?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"});options?.embed?.fields&&c.setFields(options.embed?.fields),options?.embed?.author&&c.setAuthor(options.embed?.author),options?.embed?.image&&c.setImage(options.embed?.image),options?.embed?.thumbnail&&c.setThumbnail(options.embed?.thumbnail),options?.embed?.timestamp&&c.setTimestamp(options.embed?.timestamp),options?.embed?.title&&c.setTitle(options.embed?.title),options?.embed?.url&&c.setURL(options.embed?.url),t?(o.followUp({content:"Done. Setting Ticket to that channel"}),e.send({embeds:[c],components:[r]})):t||(i.reply({content:"Done. Setting Ticket to that channel"}),e.send({embeds:[c],components:[r]}))}catch(e){if(options?.strict)throw new SimplyError_1.SimplyError({function:"ticketSetup",title:"An Error occured when running the function",tip:e.stack});console.log("SimplyError - ticketSetup | Error: "+e.stack)}})}exports.ticketSetup=ticketSetup;