import { Role } from 'discord.js';
import { ExtendedInteraction, ExtendedMessage, CustomizableEmbed, CustomizableButton } from './typedef';
/**
 * **Documentation Url** of the type: https://simplyd.js.org/docs/general/btnRole#buttons
 */
export declare type BtnRoleButtons = {
    role?: string | Role;
    url?: `https://${string}`;
} & CustomizableButton;
/**
 * **Documentation Url** of the options: https://simplyd.js.org/docs/general/btnRole#btnroleoptions
 */
export declare type btnRoleOptions = {
    embed?: CustomizableEmbed;
    content?: string;
    data?: BtnRoleButtons[];
    strict?: boolean;
};
/**
 * ## btnRole
 * ### A **Button Role System** that lets you create button roles with your own message. | *Requires: [**manageBtnRole()**](https://simplyd.js.org/docs/handler/manageBtnRole)*
 *
 * @async
 * @param {ExtendedMessage|ExtendedInteraction} msgOrint [`ExtendedMessage`](https://simplyd.js.org/docs/typedef/extendedmessage) | [`ExtendedInteraction`](https://simplyd.js.org/docs/typedef/extendedinteraction)
 * @param {btnRoleOptions} options [`btnRoleOptions`](https://simplyd.js.org/docs/general/btnrole#btnroleoptions)
 * @returns {Promise<boolean>} `boolean`
 *
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/general/btnRole)
 * @example simplydjs.btnRole(message, { data: [{...}] })
 */
export declare function btnRole(msgOrint: ExtendedMessage | ExtendedInteraction, options?: btnRoleOptions): Promise<boolean>;
