import { Client, Message } from 'discord.js';
import { CustomizableEmbed } from './typedef';
/**
 * **Documentation Url** of the type: https://simplyd.js.org/docs/systems/bumpReminder#bumpreminderembeds
 */
export interface BumpReminderEmbeds {
    thank?: CustomizableEmbed;
    remind?: CustomizableEmbed;
}
/**
 * **Documentation Url** of the options: https://simplyd.js.org/docs/systems/bumpReminder#bumpoptions
 */
export declare type bumpOptions = {
    strict: boolean;
    content?: string;
    embed?: BumpReminderEmbeds;
    toggle?: boolean;
    channelId?: string[];
};
/**
 * ## bumpReminder
 * ### A Very cool bump reminder system that reminds when a bump is necessary [Only Disboard].
 *
 * **Requires you to have this in `messageCreate` and `ready` event**
 *
 * @async
 * @param {Client} client
 * @param {Message|bumpOptions} message `Message` | [`bumpOptions`](https://simplyd.js.org/docs/systems/bumpreminder#bumpoptions)
 * @param {bumpOptions} options [`bumpOptions`](https://simplyd.js.org/docs/systems/bumpreminder#bumpoptions)
 * @returns {Promise<boolean>} `boolean`
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/systems/bumpReminder)
 * @example simplydjs.bumpReminder(client, message)
 */
export declare function bumpReminder(client: Client, message: Message | bumpOptions, options?: bumpOptions): Promise<boolean>;
