import { Message } from 'discord.js';
/**
 * **Documentation Url** of the options: https://simplyd.js.org/docs/fun/chatbot#chatbotoptions
 */
export declare type chatbotOptions = {
    strict?: boolean;
    channelId?: string | string[];
    toggle?: boolean;
    name?: string;
    developer?: string;
    gptToken?: string;
};
/**
 * ## chatbot
 * ### A chatbot system that is both technically advanced and intelligent, and is your buddy.
 *
 * Implements a chatbot feature using an external API to generate responses to user messages.
 *
 * @async
 * @param {Message} message `Message`
 * @param {chatbotOptions} options [`chatbotOptions`](https://simplyd.js.org/docs/fun/chatbot#chatbotoptions)
 * @returns {Promise<void>} `void`
 *
 * ----
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/fun/chatbot)
 * @example simplydjs.chatbot(client, message)
 */
export declare function chatbot(message: Message, options?: chatbotOptions): Promise<void>;
