/**
 * **Documentation Url** of the options: https://simplyd.js.org/docs/general/connect#connectoptions
 */
export declare type connectOptions = {
    strict?: boolean;
    notify?: boolean;
};
/**
 * ## connect
 * ### Connect to a mongo database to access some of the simply-djs functions ! *Requires* [MongoDB](https://mongodb.com/)
 *
 * @param {string} db
 * @param {connectOptions} options [`connectOptions`](https://simplyd.js.org/docs/genera/connect#connectoptions)
 *
 * @returns {Promise<boolean>} `boolean` - A Promise that resolves to a boolean value indicating whether the database connection was
 * successful or not.
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/general/connect)
 * @example simplydjs.connect('mongoURI')
 */
export declare function connect(db: string, options?: connectOptions): Promise<boolean>;
