import { APIEmbed } from 'discord.js';
import { ExtendedInteraction, ExtendedMessage, CustomizableEmbed } from './typedef';
/**
 * **Documentation Url** of the options: https://simplyd.js.org/docs/general/embedCreator#embedcreatoroptions
 */
export declare type embedCreatorOptions = {
    strict?: boolean;
    embed?: CustomizableEmbed;
};
/**
 * ## embedCreator
 * ### Lets you create embeds with **an interactive builder**
 *
 * @async
 * @param {ExtendedMessage | ExtendedInteraction} msgOrint [`ExtendedMessage`](https://simplyd.js.org/docs/typedef/extendedmessage) | [`ExtendedInteraction`](https://simplyd.js.org/docs/typedef/extendedinteraction)
 * @param {embedCreatorOptions} options [`embedCreatorOptions`](https://simplyd.js.org/docs/general/embedCreator#embedcreatoroptions)
 * @returns {Promise<APIEmbed>} [`APIEmbed`](https://discord-api-types.dev/api/discord-api-types-v10/interface/APIEmbed)
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/general/embedCreator)
 * @example simplydjs.embedCreate(interaction)
 */
export declare function embedCreator(msgOrint: ExtendedMessage | ExtendedInteraction, options?: embedCreatorOptions): Promise<APIEmbed>;
