import { Message, User } from 'discord.js';
import { CustomizableEmbed } from './typedef';
/**
 * **Documentation Url** of the options: https://simplyd.js.org/docs/general/ghostPing#ghostoptions
 */
export declare type ghostOptions = {
    strict: boolean;
    embed?: CustomizableEmbed;
};
/**
 * ## ghostPing
 * ### A Great system to see **who ghost pinged**
 *
 * **Important!**: Use it in `messageDelete` event
 *
 * @async
 * @param {Message} message `Message`
 * @param {ghostOptions} options [`ghostOptions`](https://simplyd.js.org/docs/general/ghostPing#ghostoptions)
 * @returns {Promise<User>} [`User`](https://discord.js.org/#/docs/discord.js/stable/class/User)
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/general/ghostPing)
 * @example simplydjs.ghostPing(message)
 */
export declare function ghostPing(message: Message, options?: ghostOptions): Promise<User>;
