import { ButtonInteraction } from 'discord.js';
/**
 * **Documentation Url** of the type: *https://simplyd.js.org/docs/handler/manageBtnRole#btnrolereplies*
 */
export interface BtnRoleReplies {
    add: string;
    remove: string;
}
/**
 * **Documentation Url** of the options: https://simplyd.js.org/docs/handler/manageBtnRole#managebtnroleoptions
 */
export declare type manageBtnRoleOptions = {
    reply?: BtnRoleReplies;
    strict?: boolean;
};
/**
 * ## manageBtnRole
 * ### A Button Role Handler for **simplydjs button role system.**
 *
 * @async
 * @param {ButtonInteraction} button [`ButtonInteraction`](https://old.discordjs.dev/#/docs/discord.js/main/class/ButtonInteraction)
 * @param {manageBtnRoleOptions} options [`manageBtnRoleOptions`](https://simplyd.js.org/docs/handler/manageBtnRole#manageBtnRoleoptions)
 * @returns {Promise<boolean>} `boolean`
 *
 * ---
 *
 * @link `Documentation:` https://simplyd.js.org/docs/hhandler/manageBtnRole
 * @example simplydjs.manageBtnRole(interaction)
 */
export declare function manageBtnRole(button: ButtonInteraction, options?: manageBtnRoleOptions): Promise<boolean>;
