import { ButtonInteraction, GuildMember } from 'discord.js';
/**
 * **Documentation Url** of the options: *https://simplyd.js.org/docs/handler/manageGiveaway#managegiveawayoptions*
 */
export declare type manageGiveawayOptions = {
    strict?: boolean;
};
/**
 * **Documentation Url** of the resolve: https://simplyd.js.org/docs/handler/manageGiveaway#rerollresolve
 */
export declare type RerollResolve = {
    type?: 'Reroll';
    user?: GuildMember[];
    url?: string;
};
/**
 * **Documentation Url** of the resolve: https://simplyd.js.org/docs/handler/manageGiveaway#endresolve
 */
export declare type EndResolve = {
    type?: 'End';
    user?: GuildMember[];
    url?: string;
};
/**
 * ## manageGiveaway
 * ### A Giveaway Handler for **simplydjs giveaway system.**
 *
 * @async
 * @param {ButtonInteraction} button [`ButtonInteraction`](https://old.discordjs.dev/#/docs/discord.js/main/class/ButtonInteraction)
 * @param {manageGiveawayOptions} options [`manageGiveawayOptions`](https://simplyd.js.org/docs/handler/managegiveaway#managegiveawayoptions)
 * @returns {Promise<RerollResolve|EndResolve>} [`RerollResolve`](https://simplyd.js.org/docs/handler/managegiveaway#rerollresolve) | [`EndResolve`](https://simplyd.js.org/docs/handler/managegiveaway#endresolve)
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/handler/manageGiveaway)
 * @example simplydjs.manageGiveaway(interaction)
 */
export declare function manageGiveaway(button: ButtonInteraction, options?: manageGiveawayOptions): Promise<RerollResolve | EndResolve>;
