import { Client } from 'discord.js';
import { CustomizableEmbed } from './typedef';
/**
 * **Documentation Url** of the options: https://simplyd.js.org/docs/systems/meme#memeoptions
 */
export declare type memeOptions = {
    embed?: CustomizableEmbed;
    channelId?: string[] | string;
    interval?: number;
    sub?: string[] | string;
    strict?: boolean;
};
/**
 * ## meme
 * ### The memes are sent automatically, so others will able to laugh at the jokes without having to do anything !
 *
 * @async
 * @param {Client} client
 * @param {memeOptions} options [`memeOptions`](https://simplyd.js.org/docs/systems/meme#memeoptions)
 * @returns {Promise<void>} `void`
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/systems/meme)
 * @example simplydjs.meme(client, { channelId: '1234567890123' })
 * @example simplydjs.meme(channel, { sub: ["coding", "memes"] })
 */
export declare function meme(client: Client, options?: memeOptions): Promise<void>;
