/// <reference types="node" />
import { OutgoingHttpHeaders } from 'http2';
/**
 * **Documentation Url** of the options: https://simplyd.js.org/docs/misc/https#httpsoptions
 */
export declare type httpsOptions = {
    method: 'GET' | 'POST' | 'PUT' | 'PATCH' | 'DELETE' | 'HEAD' | 'CONNECT' | 'OPTIONS' | 'TRACE';
    headers: OutgoingHttpHeaders;
    body?: object;
    url?: string;
    host?: string;
    endpoint?: string;
    debug?: boolean;
};
/**
 * ## https
 * ### Https function to replace your good ol' node-fetch and axios.
 *
 * @param {string | httpsOptions} url `string` | [`httpsOptions`](https://simplyd.js.org/docs/misc/https#httpsoptions)
 * @param {httpsOptions} options [`httpsOptions`](https://simplyd.js.org/docs/misc/https#httpsoptions)
 * @returns {Promise<any>} `any`
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/misc/https)
 * @example simplydjs.https("postman-echo.com/get") // An Echo endpoint
 */
export declare function https(url: string | httpsOptions, options?: httpsOptions): Promise<any>;
