import { ColorResolvable } from 'discord.js';
/**
 * ## toRgb
 * ### Transforms Hex code into RGB Array (or) RGB String. This makes it easy to convert from discord.js v13 to v14.
 *
 * @export
 * @param {string} hex `string`
 * @returns {ColorResolvable} [`ColorResolvable`](https://discord.js.org/#/docs/discord.js/stable/typedef/ColorResolvable)
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/misc/toRgb)
 * @example simplydjs.toRgb('#406DBC')
 *
 */
export declare function toRgb(hex: string): ColorResolvable;
