import { MessageReaction } from 'discord.js';
import { ExtendedMessage, CustomizableEmbed } from './typedef';
/**
 * **Documentation Url** of the type: https://simplyd.js.org/docs/systems/starboard#starboardoptions
 */
export declare type starboardOptions = {
    embed?: CustomizableEmbed;
    channelId?: string;
    min?: number;
    emoji?: string;
    strict?: boolean;
};
/**
 * ## starboard
 * ### Efficient yet Simplest starboard system ever existed !
 *
 * `NOTE:` **Only Use it in `messageReactionAdd`, `messageReactionRemove` and `messageDelete` events.**
 *
 * @async
 * @param {(MessageReaction|ExtendedMessage)} reactionOrMessage [`MessageReaction`](https://discord.js.org/#/docs/discord.js/stable/class/MessageReaction) | [`ExtendedMessage`](https://simplyd.js.org/docs/typedef/extendedmessage)
 * @param {starboardOptions} options [`starboardOptions`](https://simplyd.js.org/docs/systems/starboard#starboardoptions)
 * @returns {Promise<void>} `void`
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/systems/starboard)
 * @example simplydjs.starboard(reaction, { channelId: '1234567890123' })
 */
export declare function starboard(reactionOrMessage: MessageReaction | ExtendedMessage, options?: starboardOptions): Promise<void>;
