import { ExtendedInteraction, ExtendedMessage, CustomizableEmbed, CustomizableButton } from './typedef';
/**
 * **Documentation Url** of the options: https://simplyd.js.org/docs/systems/ticketSetup#ticketsetupoptions
 */
export declare type ticketSetupOptions = {
    embed?: CustomizableEmbed;
    button?: CustomizableButton;
    channelId?: string;
    strict: boolean;
};
/**
 * ## ticketSetup
 * ### A Flexible yet Powerful Ticket System | *Requires: [**manageTicket()**](https://simplyd.js.org/docs/handler/manageTicket)*
 *
 * @async
 * @param {ExtendedMessage | ExtendedInteraction} msgOrint [`ExtendedMessage`](https://simplyd.js.org/docs/typedef/extendedmessage) | [`ExtendedInteraction`](https://simplyd.js.org/docs/typedef/extendedinteraction)
 * @param {ticketSetupOptions} options [`ticketSetupOptions`](https://simplyd.js.org/docs/systems/ticketsetup#ticketsetupoptions)
 * @returns {Promise<void>} `void`
 *
 * ---
 *
 * @link `Documentation:` https://simplyd.js.org/docs/systems/ticketSetup
 * @example simplydjs.ticketSetup(interaction, { channelId: '0123456789012' })
 */
export declare function ticketSetup(msgOrint: ExtendedMessage | ExtendedInteraction, options?: ticketSetupOptions): Promise<void>;
