import { User } from 'discord.js';
import { CustomizableEmbed, ExtendedInteraction, ExtendedMessage, CustomizableButton } from './typedef';
/**
 * **Documentation Url** of the type: https://simplyd.js.org/docs/fun/tictactoe#tictactoebuttons
 */
export interface TictactoeButtons {
    X?: CustomizableButton;
    O?: CustomizableButton;
    blank?: CustomizableButton;
}
/**
 * **Documentation Url** of the type: https://simplyd.js.org/docs/fun/tictactoe#tictactoeembeds
 */
export interface TictactoeEmbeds {
    request?: CustomizableEmbed;
    win?: CustomizableEmbed;
    draw?: CustomizableEmbed;
    game?: CustomizableEmbed;
    timeout?: CustomizableEmbed;
    decline?: CustomizableEmbed;
}
/**
 * **Documentation Url** of the options: https://simplyd.js.org/docs/fun/tictactoe#tictactoeoptions
 */
export declare type tictactoeOptions = {
    embed?: TictactoeEmbeds;
    user?: User;
    type?: 'Button' | 'Embed';
    max: number;
    buttons?: TictactoeButtons;
    strict?: boolean;
    hard?: boolean;
};
/**
 * ## tictactoe
 * ### One line implementation of a super enjoyable **tictactoe game**.
 *
 * @async
 * @param {ExtendedMessage | ExtendedInteraction} msgOrint [`ExtendedMessage`](https://simplyd.js.org/docs/typedef/extendedmessage) | [`ExtendedInteraction`](https://simplyd.js.org/docs/typedef/extendedinteraction)
 * @param {tictactoeOptions} options [`tictactoeOptions`](https://simplyd.js.org/docs/fun/tictactoe#tictactoeoptions)
 * @returns {Promise<User>} [`User`](https://discord.js.org/#/docs/discord.js/stable/class/User)
 *
 * ---
 *
 * @link `Documentation:` https://simplyd.js.org/docs/Fun/tictactoe
 * @example simplydjs.tictactoe(interaction)
 */
export declare function tictactoe(msgOrint: ExtendedMessage | ExtendedInteraction, options?: tictactoeOptions): Promise<User>;
