"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.buttonPages=void 0;const discord_js_1=require("discord.js"),error_1=require("./error"),misc_1=require("./misc");
// ------------------------------
// ------ F U N C T I O N -------
// ------------------------------
/**
 * ## buttonPages
 * ### An *powerful yet customizable* **Embed Paginator**
 *
 * @async
 * @param {ExtendedMessage|ExtendedInteraction} msgOrint [`ExtendedMessage`](https://simplyd.js.org/docs/typedef/extendedmessage) | [`ExtendedInteraction`](https://simplyd.js.org/docs/typedef/extendedinteraction)
 * @param {pagesOptions} options [`pagesOptions`](https://simplyd.js.org/docs/general/buttonpages#pagesoptions)
 * @returns {Promise<void>} `void`
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/general/buttonPages)
 * @example simplydjs.buttonPages(interaction, [embed1, embed2] )
 */
async function buttonPages(msgOrint,options={strict:!1}){return new Promise(async()=>{try{if(options.skips??=!0,options.delete??=!0,options.dynamic??=!1,options.count??=!1,options.disable||="Label",!options.embeds){if(options.strict)throw new error_1.SimplyError({function:"buttonPages",title:"Provide an array for the pages option",tip:"Expected an array of MessageEmbed. Received "+(options.embeds||"undefined")});console.log("SimplyError - buttonPages | Error:  Provide an array for the pages option. Expected an array of MessageEmbed. Received "+(options.embeds||"undefined"))}let o;if(options?.rows){if(!Array.isArray(options.rows)){if(options?.strict)throw new error_1.SimplyError({function:"buttonPages",title:"Provide an array for the rows",tip:"Expected an array of MessageActionRows. Received "+(options?.rows||"undefined")});console.log("SimplyError - buttonPages | Provide an array for the rows\n\nExpected an array of MessageActionRows. Received "+(options?.rows||"undefined"))}o=options?.rows}else o=[];var l={first:{style:options?.buttons?.first?.style||discord_js_1.ButtonStyle.Primary,emoji:options?.buttons?.first?.emoji||"⏪",label:options?.buttons?.first?.label||"First"},next:{style:options?.buttons?.next?.style||discord_js_1.ButtonStyle.Success,emoji:options?.buttons?.next?.emoji||"▶️",label:options?.buttons?.next?.label||"Next"},back:{style:options?.buttons?.back?.style||discord_js_1.ButtonStyle.Success,emoji:options?.buttons?.back?.emoji||"◀️",label:options?.buttons?.back?.label||"Back"},last:{style:options?.buttons?.last?.style||discord_js_1.ButtonStyle.Primary,emoji:options?.buttons?.last?.emoji||"⏩",label:options?.buttons?.last?.label||"Last"},delete:{style:options?.buttons?.delete?.style||discord_js_1.ButtonStyle.Danger,emoji:options?.buttons?.delete?.emoji||"🗑",label:options?.buttons?.delete?.label||"Delete"}},r=(l.first?.style&&(l.first.style=(0,misc_1.toButtonStyle)(l.first?.style)),l.next?.style&&(l.next.style=(0,misc_1.toButtonStyle)(l?.next?.style)),l.back?.style&&(l.back.style=(0,misc_1.toButtonStyle)(l.back?.style)),l.last?.style&&(l.last.style=(0,misc_1.toButtonStyle)(l.last?.style)),l.delete?.style&&(l.delete.style=(0,misc_1.toButtonStyle)(l.delete?.style)),(new discord_js_1.ButtonBuilder).setCustomId("first_embed").setStyle(l.first?.style||discord_js_1.ButtonStyle.Primary)),d=("Label"===options?.disable||"None"===options?.disable?r.setEmoji(l.first?.emoji||"⏪"):"Emoji"!==options?.disable&&"None"!==options?.disable||r.setLabel(l.first?.label||"First"),(new discord_js_1.ButtonBuilder).setCustomId("forward_button_embed").setStyle(l.next?.style||discord_js_1.ButtonStyle.Success)),a=("Label"===options?.disable||"None"===options?.disable?d.setEmoji(l?.next?.emoji||"▶️"):"Emoji"!==options?.disable&&"None"!==options?.disable||d.setLabel(l?.next?.label||"Next"),(new discord_js_1.ButtonBuilder).setCustomId("back_button_embed").setStyle(l?.back?.style||discord_js_1.ButtonStyle.Success)),p=("Label"===options?.disable||"None"===options?.disable?a.setEmoji(l?.back?.emoji||"◀️"):"Emoji"!==options?.disable&&"None"!==options?.disable||a.setLabel(l?.back?.label||"Back"),(new discord_js_1.ButtonBuilder).setCustomId("last_embed").setStyle(l.last?.style||discord_js_1.ButtonStyle.Primary)),c=("Label"===options?.disable||"None"===options?.disable?p.setEmoji(l.last?.emoji||"⏩"):"Emoji"!==options?.disable&&"None"!==options?.disable||p.setLabel(l.last?.label||"Last"),options?.dynamic&&(r.setDisabled(!0),a.setDisabled(!0)),(new discord_js_1.ButtonBuilder).setCustomId("delete_embed").setStyle(l?.delete?.style||discord_js_1.ButtonStyle.Danger));"Label"===options?.disable||"None"===options?.disable?c.setEmoji(l?.delete?.emoji||"🗑"):"Emoji"!==options?.disable&&"None"!==options?.disable||c.setLabel(l?.delete?.label||"Delete");let t=[],s=new discord_js_1.ActionRowBuilder,n=(t=1==options?.skips?options?.delete?[r,a,c,d,p]:[r,a,d,p]:options?.delete?[a,c,d]:[a,d],s.addComponents(t),0);
//Creating the MessageActionRow
o.push(s);let e;!msgOrint.commandId||(e=msgOrint).deferred||await e.deferReply({fetchReply:!0});let i;const y=options?.embeds;var m=msgOrint,u=msgOrint;e?(options?.count?await m.followUp({embeds:[y[0].setFooter({text:"Page 1/"+y.length})],components:o,allowedMentions:{repliedUser:!1},fetchReply:!0}):await m.followUp({embeds:[y[0]],components:o,allowedMentions:{repliedUser:!1},fetchReply:!0}),i=await m.fetchReply()):e||(i=options?.count?await u.reply({embeds:[y[0].setFooter({text:"Page 1/"+y.length})],components:o,allowedMentions:{repliedUser:!1}}):await u.reply({embeds:[y[0]],components:o,allowedMentions:{repliedUser:!1}}));const _=i.createMessageComponentCollector({time:options?.timeout||(0,misc_1.ms)("2m"),filter:m=>m.user.id===(msgOrint.user||msgOrint.author).id,componentType:discord_js_1.ComponentType.Button});_.on("collect",async b=>{var e,t;b.isButton()&&b.message.id===i.id&&(await b.deferUpdate(),"back_button_embed"==b.customId?n-1<0?n=y.length-1:--n:"forward_button_embed"==b.customId?n+1==y.length?n=0:n+=1:"last_embed"==b.customId?n=y.length-1:"first_embed"==b.customId&&(n=0),options?.dynamic&&(0===n?((e=o[0].components[0]).setDisabled(!0),options?.skips&&((t=o[0].components[1]).setDisabled(!0),o[0].components[1]=t),o[0].components[0]=e):((t=o[0].components[0]).setDisabled(!1),options?.skips&&((e=o[0].components[1]).setDisabled(!1),o[0].components[1]=e),o[0].components[0]=t),n===y.length-1?options?.skips?(e=o[0].components[3],(t=o[0].components[4]).setDisabled(!0),e.setDisabled(!0),o[0].components[3]=e,o[0].components[4]=t):((e=o[0].components[2]).setDisabled(!0),o[0].components[2]=e):options?.skips?(t=o[0].components[3],(e=o[0].components[4]).setDisabled(!1),t.setDisabled(!1),o[0].components[3]=t,o[0].components[4]=e):((t=o[0].components[2]).setDisabled(!1),o[0].components[2]=t)),"delete_embed"!==b.customId?options?.count?i.edit({embeds:[y[n].setFooter({text:`Page: ${n+1}/`+y.length})],components:o,allowedMentions:{repliedUser:!1}}):i.edit({embeds:[y[n]],components:o,allowedMentions:{repliedUser:!1}}):"delete_embed"===b.customId&&_.stop("del"))}),_.on("end",async(_collected,reason)=>{if("del"===reason)await i.delete().catch(()=>{});else{const e=[];t.forEach(a=>{e.push(a.setDisabled(!0))}),s=(new discord_js_1.ActionRowBuilder).addComponents(e),i.edit({components:[s]})}})}catch(e){if(options?.strict)throw new error_1.SimplyError({function:"buttonPages",title:"An Error occured when running the function ",tip:e.stack});console.log("SimplyError - buttonPages | Error: "+e.stack)}})}exports.buttonPages=buttonPages;