"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.embedCreator=void 0;const discord_js_1=require("discord.js"),misc_1=require("./misc"),error_1=require("./error");
// ------------------------------
// ------ F U N C T I O N -------
// ------------------------------
/**
 * ## embedCreator
 * ### Lets you create embeds with **an interactive builder**
 *
 * @async
 * @param {ExtendedMessage | ExtendedInteraction} msgOrint [`ExtendedMessage`](https://simplyd.js.org/docs/typedef/extendedmessage) | [`ExtendedInteraction`](https://simplyd.js.org/docs/typedef/extendedinteraction)
 * @param {embedCreatorOptions} options [`embedCreatorOptions`](https://simplyd.js.org/docs/general/embedCreator#embedcreatoroptions)
 * @returns {Promise<APIEmbed>} [`APIEmbed`](https://discord-api-types.dev/api/discord-api-types-v10/interface/APIEmbed)
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/general/embedCreator)
 * @example simplydjs.embedCreate(interaction)
 */
async function embedCreator(msgOrint,options={strict:!1}){return new Promise(async resolve=>{try{var s=(new discord_js_1.ButtonBuilder).setLabel("Finish").setStyle(discord_js_1.ButtonStyle.Primary).setCustomId("setDone"),o=(new discord_js_1.ButtonBuilder).setLabel("Cancel").setStyle(discord_js_1.ButtonStyle.Danger).setCustomId("setDelete"),i=[{label:"Message",description:"Message that is outside of the embed",value:"setMessage"},{label:"Author",description:"Set an author in the embed",value:"setAuthor"},{label:"Title",description:"Set a title in the embed",value:"setTitle"},{label:"URL",description:"Set an URL for the Title in the embed",value:"setURL"},{label:"Description",description:"Set a description in the embed",value:"setDescription"},{label:"Color",description:"Pick a color of the embed",value:"setColor"},{label:"Image",description:"Set an image for the embed",value:"setImage"},{label:"Thumbnail",description:"Set a thumbnail image in the embed",value:"setThumbnail"},{label:"Field",description:"Add a field to the embed",value:"addField"},{label:"Footer",description:"Set a footer in the embed",value:"setFooter"},{label:"Timestamp",description:"Turn on the Timestamp of the embed",value:"setTimestamp"}],n=(options.embed||(options.embed={footer:{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"},color:(0,misc_1.toRgb)("#406DBC")}),(new discord_js_1.StringSelectMenuBuilder).setMaxValues(1).setCustomId("embed-creator").setPlaceholder("Embed Creator").addOptions(i)),r=(new discord_js_1.ActionRowBuilder).addComponents([s,o]),l=(new discord_js_1.ActionRowBuilder).addComponents([n]),a=(new discord_js_1.EmbedBuilder).setTitle(options.embed?.title||"Embed Generator").setDescription(options.embed?.description||"Select any option from the Select Menu in this message to create a custom embed for you.\n\nTake this image below as a reference.").setImage("https://i.postimg.cc/sXS767Gd/image.png").setColor(options.embed?.color||(0,misc_1.toRgb)("#406DBC")).setFooter(options.embed?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"});options?.embed?.author&&a.setAuthor(options.embed?.author),options?.embed?.image&&a.setImage(options.embed?.image),options?.embed?.thumbnail&&a.setThumbnail(options.embed?.thumbnail),options?.embed?.timestamp&&a.setTimestamp(options.embed?.timestamp),options?.embed?.title&&a.setTitle(options.embed?.title),options?.embed?.url&&a.setURL(options.embed?.url),options?.embed?.fields&&a.setFields(options.embed?.fields);let e;!msgOrint.commandId||(e=msgOrint).deferred||await e.deferReply({fetchReply:!0});let t;var d=msgOrint,c=msgOrint,u=(e?t=await d.followUp({embeds:[a],components:[l,r],fetchReply:!0}):e||(t=await c.reply({embeds:[a],components:[l,r]})),(new discord_js_1.EmbedBuilder).setFooter(options.embed?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"}).setColor((0,misc_1.toRgb)("#2F3136")));msgOrint.channel.send({content:"** **",embeds:[u]}).then(async preview=>{const d=m=>m.user.id===msgOrint.member.user.id||(m.reply({content:`Only <@!${msgOrint.member.user.id}> can use these buttons!`,ephemeral:!0}),!1),c=m=>msgOrint.member.user.id===m.author.id,u=m=>m.user.id===msgOrint.member.user.id||(m.reply({content:`Only <@!${msgOrint.member.user.id}> can use these buttons!`,ephemeral:!0}),!1);var e=t.createMessageComponentCollector({filter:d,componentType:discord_js_1.ComponentType.StringSelect,idle:(0,misc_1.ms)("5m")});t.createMessageComponentCollector({filter:d,componentType:discord_js_1.ComponentType.Button,idle:(0,misc_1.ms)("5m")}).on("collect",async button=>{"setDelete"===button.customId?(await button.reply({content:"Deleting your request.",ephemeral:!0}),preview.delete().catch(()=>{}),t.delete().catch(()=>{})):"setDone"===button.customId&&(msgOrint.member.permissions.has(discord_js_1.PermissionFlagsBits.Administrator)?(await button.reply({content:"Provide me a channel to send the embed.",ephemeral:!0}),button.channel.createMessageCollector({filter:c,time:(0,misc_1.ms)("1m"),max:1}).on("collect",async m=>{var e;m.mentions.channels.first()&&(e=m.mentions.channels.first(),await button.editReply({content:"Done 👍"}),e.send({content:preview.content,embeds:[preview.embeds[0]]}),preview.delete().catch(()=>{}),t.delete().catch(()=>{}),m.delete().catch(()=>{}),resolve(preview.embeds[0].toJSON()))})):msgOrint.member.permissions.has(discord_js_1.PermissionFlagsBits.Administrator)||(await button.reply({content:"Done 👍",ephemeral:!0}),msgOrint.channel.send({content:preview.content,embeds:[preview.embeds[0]]}),preview.delete().catch(()=>{}),t.delete().catch(()=>{}),resolve(preview.embeds[0].toJSON())))}),e.on("collect",async select=>{if("setTimestamp"===select.values[0]){var e=(new discord_js_1.ButtonBuilder).setLabel("Enable").setCustomId("timestamp-yes").setStyle(discord_js_1.ButtonStyle.Primary),t=(new discord_js_1.ButtonBuilder).setLabel("Disable").setCustomId("timestamp-no").setStyle(discord_js_1.ButtonStyle.Danger);await select.reply({content:"Do you want a Timestamp in the embed ?",ephemeral:!0,components:[(new discord_js_1.ActionRowBuilder).addComponents([e,t])]}),select.channel.createMessageComponentCollector({componentType:discord_js_1.ComponentType.Button,filter:u,idle:(0,misc_1.ms)("1m")}).on("collect",async button=>{"timestamp-yes"===button.customId&&(await select.editReply({components:[],content:"Enabled the Timestamp on the embed"}),preview.edit({content:preview.content,embeds:[discord_js_1.EmbedBuilder.from(preview.embeds[0]).setTimestamp(new Date)]}).catch(()=>{})),"timestamp-no"===button.customId&&(await select.editReply({components:[],content:"Disabled the Timestamp on the embed"}),preview.edit({content:preview.content,embeds:[discord_js_1.EmbedBuilder.from(preview.embeds[0]).setTimestamp(null)]}).catch(()=>{}))})}else if("setAuthor"===select.values[0]){e=(new discord_js_1.StringSelectMenuBuilder).setMaxValues(1).setCustomId("author-select").setPlaceholder("Author Options").addOptions([{label:"Author text",description:"Set the author text",value:"author-text"},{label:"Author icon",description:"Set the author icon",value:"author-icon"},{label:"Author URL",description:"Set the author url",value:"author-url"}]);await select.reply({content:'Select one from the "Author" options',ephemeral:!0,components:[(new discord_js_1.ActionRowBuilder).addComponents([e])]});const o=select.channel.createMessageComponentCollector({componentType:discord_js_1.ComponentType.StringSelect,filter:d,idle:(0,misc_1.ms)("1m")});o.on("collect",async menu=>{var e,t,s;"author-select"===menu.customId&&("author-text"===menu.values[0]&&(e=(new discord_js_1.TextInputBuilder).setLabel("Send me the author text").setCustomId("author").setStyle(discord_js_1.TextInputStyle.Short).setRequired(!1),e=(new discord_js_1.ActionRowBuilder).setComponents([e]),e=(new discord_js_1.ModalBuilder).setCustomId("author-text-modal").setTitle("Author text").addComponents(e),await menu.showModal(e),e=await menu.awaitModalSubmit({time:(0,misc_1.ms)("1m"),filter:i=>i.user.id===menu.user.id}))&&("cancel"===(s=e.fields.getTextInputValue("author")).toLowerCase()?await e.reply({content:"You have cancelled.",ephemeral:!0}):(await e.reply({content:"Done ! Setting the author text in your embed",ephemeral:!0}),preview.edit({content:preview.content,embeds:[discord_js_1.EmbedBuilder.from(preview.embeds[0]).setAuthor({name:s,iconURL:preview.embeds[0].author?.iconURL||null,url:preview.embeds[0].author?.url||null})]}).catch(()=>{}))),"author-icon"===menu.values[0]&&(await menu.reply({content:"Send me the Author icon (Attachment/Image URL)",ephemeral:!0,components:[]}),select.channel.createMessageCollector({filter:c,time:(0,misc_1.ms)("1m"),max:1}).on("collect",async m=>{null!=m.content.match(/(http[s]*:\/\/)([a-z\-_0-9\/.]+)\.([a-z.]{2,3})\/([a-z0-9\-_\/._~:?#\[\]@!$&'()*+,;=%]*)([a-z0-9]+\.)(jpg|jpeg|png)/i)||m.attachments.first()?.url||null||menu.followUp({content:"This is not a Image URL/Image Attachment. Please provide a valid image.",ephemeral:!0}),o.stop(),m.delete().catch(()=>{}),preview.edit({content:preview.content,embeds:[discord_js_1.EmbedBuilder.from(preview.embeds[0]).setAuthor({name:preview.embeds[0].author?.name||null,iconURL:m.content||m.attachments.first()?.url||null,url:preview.embeds[0].author?.url||null})]}).catch(()=>{})})),"author-url"===menu.values[0])&&(e=(new discord_js_1.TextInputBuilder).setLabel("Send me the author link url").setCustomId("link").setStyle(discord_js_1.TextInputStyle.Short).setRequired(!1),s=(new discord_js_1.ActionRowBuilder).setComponents([e]),e=(new discord_js_1.ModalBuilder).setCustomId("author-url-modal").setTitle("Author link URL").addComponents(s),await menu.showModal(e),t=await menu.awaitModalSubmit({time:(0,misc_1.ms)("1m"),filter:i=>i.user.id===menu.user.id}))&&("cancel"===(s=t.fields.getTextInputValue("link")).toLowerCase()?await t.reply({content:"You have cancelled.",ephemeral:!0}):s.startsWith("http")?(await t.reply({content:"Done ! Setting the author url link in your embed",ephemeral:!0}),preview.edit({content:preview.content,embeds:[discord_js_1.EmbedBuilder.from(preview.embeds[0]).setAuthor({name:preview.embeds[0].author?.name||null,iconURL:preview.embeds[0].author?.iconURL||null,url:s||null})]}).catch(()=>{})):await t.reply({content:"A URL should start with http/https protocol. Please give a valid URL.",ephemeral:!0}))})}else if("setMessage"===select.values[0]){var t=(new discord_js_1.TextInputBuilder).setLabel("Send me what message to set").setCustomId("message").setStyle(discord_js_1.TextInputStyle.Paragraph).setRequired(!1),e=(new discord_js_1.ActionRowBuilder).setComponents([t]),t=(new discord_js_1.ModalBuilder).setCustomId("set-message").setTitle("Set Message").addComponents(e),e=(await select.showModal(t),await select.awaitModalSubmit({time:(0,misc_1.ms)("1m"),filter:i=>i.user.id===select.user.id}));e&&("cancel"===(t=e.fields.getTextInputValue("message")).toLowerCase()?await e.reply({content:"You have cancelled.",ephemeral:!0}):(await e.reply({content:"Done ! Setting the content outside the embed",ephemeral:!0}),preview.edit({content:t,embeds:[preview.embeds[0]]}).catch(()=>{})))}else if("setThumbnail"===select.values[0]){await select.reply({content:"Send me an image for the embed thumbnail (small image at top right)",ephemeral:!0});const n=select.channel.createMessageCollector({filter:c,time:(0,misc_1.ms)("1m"),max:1});n.on("collect",async m=>{null!=m.content.match(/(http[s]*:\/\/)([a-z\-_0-9\/.]+)\.([a-z.]{2,3})\/([a-z0-9\-_\/._~:?#\[\]@!$&'()*+,;=%]*)([a-z0-9]+\.)(jpg|jpeg|png)/i)||m.attachments.first()?.url||null?(n.stop(),m.delete().catch(()=>{}),preview.edit({content:preview.content,embeds:[discord_js_1.EmbedBuilder.from(preview.embeds[0]).setThumbnail(m.content||m.attachments.first()?.url||null)]}).catch(()=>{})):select.followUp({content:"This is not a image url. Please provide a image url or attachment.",ephemeral:!0})})}else if("setColor"===select.values[0]){e=(new discord_js_1.TextInputBuilder).setLabel("Send me the hex code to set").setCustomId("color").setStyle(discord_js_1.TextInputStyle.Short).setRequired(!1),t=(new discord_js_1.ActionRowBuilder).setComponents([e]),e=(new discord_js_1.ModalBuilder).setCustomId("set-color").setTitle("Set Color").addComponents(t);await select.showModal(e);const r=await select.awaitModalSubmit({time:(0,misc_1.ms)("1m"),filter:i=>i.user.id===select.user.id});r&&("cancel"===(t=r.fields.getTextInputValue("color")).toLowerCase()?await r.reply({content:"You have cancelled.",ephemeral:!0}):/^#[0-9A-F]{6}$/i.test(t)?preview.edit({content:preview.content,embeds:[discord_js_1.EmbedBuilder.from(preview.embeds[0]).setColor((0,misc_1.toRgb)(t))]}).then(async()=>{await r.reply({content:"Done ! Setting the color on the embed",ephemeral:!0})}).catch(async()=>{await r.reply({content:"Please provide a valid hex code",ephemeral:!0})}):await r.reply({content:"Provide a valid hex code with `#` (Example: #406DBC)",ephemeral:!0}))}else if("setURL"===select.values[0]){e=(new discord_js_1.TextInputBuilder).setLabel("Send me the URL to set as hyperlink").setCustomId("url").setStyle(discord_js_1.TextInputStyle.Short).setRequired(!1),t=(new discord_js_1.ActionRowBuilder).setComponents([e]),e=(new discord_js_1.ModalBuilder).setCustomId("set-url").setTitle("Set URL").addComponents(t),t=(await select.showModal(e),await select.awaitModalSubmit({time:(0,misc_1.ms)("1m"),filter:i=>i.user.id===select.user.id}));t&&("cancel"===(e=t.fields.getTextInputValue("url")).toLowerCase()?await t.reply({content:"You have cancelled.",ephemeral:!0}):e.startsWith("http")?(await t.reply({content:"Done ! Setting the url hyperlink in embed",ephemeral:!0}),preview.edit({content:preview.content,embeds:[discord_js_1.EmbedBuilder.from(preview.embeds[0]).setURL(e)]}).catch(()=>{})):await t.reply({content:"A URL should start with http protocol. Please give a valid URL.",ephemeral:!0}))}else if("addField"==select.values[0]){e=(new discord_js_1.TextInputBuilder).setLabel("Send me the Field name").setCustomId("field-name").setStyle(discord_js_1.TextInputStyle.Short).setRequired(!0),t=(new discord_js_1.TextInputBuilder).setLabel("Send me the Field value").setCustomId("field-value").setStyle(discord_js_1.TextInputStyle.Short).setRequired(!0),e=(new discord_js_1.ActionRowBuilder).setComponents([e]),t=(new discord_js_1.ActionRowBuilder).setComponents([t]),e=(new discord_js_1.ModalBuilder).setCustomId("add-field").setTitle("Add field").addComponents(e,t),t=(await select.showModal(e),await select.awaitModalSubmit({time:(0,misc_1.ms)("1m"),filter:i=>i.user.id===select.user.id}));t&&(e=t.fields.getTextInputValue("field-name"),s=t.fields.getTextInputValue("field-value"),"cancel"===e.toLowerCase()?await t.reply({content:"You have cancelled.",ephemeral:!0}):(await t.reply({content:"Done ! Added the field in embed",ephemeral:!0}),preview.edit({content:preview.content,embeds:[discord_js_1.EmbedBuilder.from(preview.embeds[0]).addFields({name:e,value:s})]}).catch(()=>{})))}else if("setImage"===select.values[0]){await select.reply({content:"Send me the image you need for embed",ephemeral:!0});const l=select.channel.createMessageCollector({filter:c,time:(0,misc_1.ms)("1m"),max:1});l.on("collect",async m=>{null!=m.content.match(/(http[s]*:\/\/)([a-z\-_0-9\/.]+)\.([a-z.]{2,3})\/([a-z0-9\-_\/._~:?#\[\]@!$&'()*+,;=%]*)([a-z0-9]+\.)(jpg|jpeg|png)/i)||m.attachments.first()?.url||null?(m.delete().catch(()=>{}),l.stop(),preview.edit({content:preview.content,embeds:[discord_js_1.EmbedBuilder.from(preview.embeds[0]).setImage(m.content||m.attachments.first()?.url)]}).catch(()=>{})):await select.followUp("That is not a image url/image attachment. Please provide me a image url or attachment.")})}else if("setTitle"===select.values[0]){var t=(new discord_js_1.TextInputBuilder).setLabel("Send me the title to set in embed").setCustomId("title").setStyle(discord_js_1.TextInputStyle.Short).setRequired(!1),e=(new discord_js_1.ActionRowBuilder).setComponents([t]),s=(new discord_js_1.ModalBuilder).setCustomId("set-title").setTitle("Set Title").addComponents(e),t=(await select.showModal(s),await select.awaitModalSubmit({time:(0,misc_1.ms)("1m"),filter:i=>i.user.id===select.user.id}));t&&("cancel"===(e=t.fields.getTextInputValue("title")).toLowerCase()?await t.reply({content:"You have cancelled.",ephemeral:!0}):(await t.reply({content:"Done ! Setting the title in embed",ephemeral:!0}),preview.edit({content:preview.content,embeds:[discord_js_1.EmbedBuilder.from(preview.embeds[0]).setTitle(e)]}).catch(()=>{})))}else if("setDescription"===select.values[0]){s=(new discord_js_1.TextInputBuilder).setLabel("Send me the description to set in embed").setCustomId("description").setStyle(discord_js_1.TextInputStyle.Paragraph).setRequired(!1),t=(new discord_js_1.ActionRowBuilder).setComponents([s]),e=(new discord_js_1.ModalBuilder).setCustomId("set-description").setTitle("Set Description").addComponents(t),s=(await select.showModal(e),await select.awaitModalSubmit({time:(0,misc_1.ms)("1m"),filter:i=>i.user.id===select.user.id}));s&&("cancel"===(t=s.fields.getTextInputValue("description")).toLowerCase()?await s.reply({content:"You have cancelled.",ephemeral:!0}):(await s.reply({content:"Done ! Setting the description in embed",ephemeral:!0}),preview.edit({content:preview.content,embeds:[discord_js_1.EmbedBuilder.from(preview.embeds[0]).setDescription(t)]}).catch(()=>{})))}else if("setFooter"===select.values[0]){e=(new discord_js_1.StringSelectMenuBuilder).setMaxValues(1).setCustomId("footer-select").setPlaceholder("Footer Options").addOptions([{label:"Footer text",description:"Set the footer text",value:"footer-text"},{label:"Footer icon",description:"Set the footer icon",value:"footer-icon"}]);await select.reply({content:'Select one from the "Footer" options',ephemeral:!0,components:[(new discord_js_1.ActionRowBuilder).addComponents([e])]});const a=select.channel.createMessageComponentCollector({componentType:discord_js_1.ComponentType.StringSelect,filter:d,idle:(0,misc_1.ms)("1m")});a.on("collect",async menu=>{var e,t;"footer-select"===menu.customId&&("footer-text"===menu.values[0]&&(e=(new discord_js_1.TextInputBuilder).setLabel("Send me the Footer text").setCustomId("footer-text").setStyle(discord_js_1.TextInputStyle.Short).setRequired(!1),e=(new discord_js_1.ActionRowBuilder).setComponents([e]),e=(new discord_js_1.ModalBuilder).setCustomId("set-footer").setTitle("Set Footer text").addComponents(e),await menu.showModal(e),e=await menu.awaitModalSubmit({time:(0,misc_1.ms)("1m"),filter:i=>i.user.id===menu.user.id}))&&("cancel"===(t=e.fields.getTextInputValue("footer-text")).toLowerCase()?await e.reply({content:"You have cancelled.",ephemeral:!0}):(await e.reply({content:"Done ! Setting the footer text in embed",ephemeral:!0}),preview.edit({content:preview.content,embeds:[discord_js_1.EmbedBuilder.from(preview.embeds[0]).setFooter({text:t,iconURL:preview.embeds[0].footer?.iconURL||null})]}).catch(()=>{}))),"footer-icon"===menu.values[0])&&(await menu.reply({content:"Send me the Footer icon (Attachment/Image URL)",ephemeral:!0,components:[]}),select.channel.createMessageCollector({filter:c,time:(0,misc_1.ms)("1m"),max:1}).on("collect",async m=>{null!=m.content.match(/(http[s]*:\/\/)([a-z\-_0-9\/.]+)\.([a-z.]{2,3})\/([a-z0-9\-_\/._~:?#\[\]@!$&'()*+,;=%]*)([a-z0-9]+\.)(jpg|jpeg|png)/i)||m.attachments.first()?.url||null?(a.stop(),m.delete().catch(()=>{}),preview.edit({content:preview.content,embeds:[discord_js_1.EmbedBuilder.from(preview.embeds[0]).setFooter({text:preview.embeds[0].footer?.text||null,iconURL:m.content||m.attachments.first()?.url||null})]}).catch(()=>{})):menu.followUp({content:"This is not a Image URL/Image Attachment. Please provide a valid image.",ephemeral:!0})}))})}}),e.on("end",async(_collected,reason)=>{"time"===reason&&(reason=(new discord_js_1.ButtonBuilder).setLabel("Timed Out").setStyle(discord_js_1.ButtonStyle.Danger).setCustomId("timeout-embedcreator").setDisabled(!0),reason=(new discord_js_1.ActionRowBuilder).addComponents([reason]),await t.edit({embeds:[t.embeds[0]],components:[reason]}))})})}catch(e){if(options?.strict)throw new error_1.SimplyError({function:"embedCreator",title:"An Error occured when running the function ",tip:e.stack});console.log("SimplyError - embedCreator | Error: "+e.stack)}})}exports.embedCreator=embedCreator;