"use strict";var __importDefault=this&&this.__importDefault||function(mod){return mod&&mod.__esModule?mod:{default:mod}};Object.defineProperty(exports,"__esModule",{value:!0}),exports.giveaway=void 0;const discord_js_1=require("discord.js"),giveaway_1=__importDefault(require("./model/giveaway")),misc_1=require("./misc"),error_1=require("./error");
// ------------------------------
// ------ F U N C T I O N -------
// ------------------------------
/**
 * ## giveaway
 * ### A **Powerful** yet simple giveaway system | *Requires: [**manageGiveaway()**](https://simplyd.js.org/docs/handler/manageGiveaway)*
 *
 * @async
 * @param {ExtendedMessage | ExtendedInteraction} msgOrint  [`ExtendedMessage`](https://simplyd.js.org/docs/typedef/extendedmessage) | [`ExtendedInteraction`](https://simplyd.js.org/docs/typedef/extendedinteraction)
 * @param {giveawayOptions} options [`giveawayOptions`](https://simplyd.js.org/docs/systems/giveway#giveawayoptions)
 * @returns {Promise<GiveawayResolve | EndResolve>} [`GiveawayResolve`](https://simplyd.js.org/docs/systems/giveaway#giveawayresolve)`|`[`EndResolve`](https://simplyd.js.org/docs/systems/giveaway#endresolve)
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/systems/giveway)
 * @example simplydjs.giveaway(interaction)
 */
async function giveaway(msgOrint,options={strict:!1}){return new Promise(async resolve=>{try{var d=msgOrint["client"];let i;msgOrint.commandId&&(i=msgOrint);const f=msgOrint,j=msgOrint,B=Date.now();let e;if(options?.manager?e=options.manager:options?.manager&&(e=await msgOrint.member.roles.cache.find(r=>r.id===options.manager)),!(e||msgOrint?.member?.permissions?.has(discord_js_1.PermissionFlagsBits.ManageEvents)||msgOrint?.member?.permissions?.has(discord_js_1.PermissionFlagsBits.ManageGuild)||msgOrint?.member?.permissions?.has(discord_js_1.PermissionFlagsBits.Administrator)))return i?f.reply({content:"You must have • `Administrator`/`Manage Guild`/`Manage Events` Permission or • Giveaway Manager Role to perform this action",ephemeral:!0}):j.reply({content:"You must have • `Administrator`/`Manage Guild`/`Manage Events` Permission or • Giveaway Manager Role to perform this action"});msgOrint.commandId&&!i.deferred&&await i.deferReply({fetchReply:!0}),options.winners??=1;var u={enter:{style:options.buttons?.enter?.style||discord_js_1.ButtonStyle.Success,label:options.buttons?.enter?.label||"0",emoji:options.buttons?.enter?.emoji||"🎁"},end:{style:options.buttons?.end?.style||discord_js_1.ButtonStyle.Danger,label:options.buttons?.end?.label||"End",emoji:options.buttons?.end?.emoji||"⛔"},reroll:{style:options.buttons?.reroll?.style||discord_js_1.ButtonStyle.Primary,label:options.buttons?.reroll?.label||"Reroll",emoji:options.buttons?.reroll?.emoji||"🔁"}};options.embed||(options.embed={giveaway:{footer:{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"},color:(0,misc_1.toRgb)("#406DBC"),title:"Giveaway !"}});let t,s,n,r,l={type:"None",value:null},o="** **";if(options?.pingRole?o=options.pingRole.toString():options?.pingRole&&(o=(await msgOrint.member.roles.cache.find(r=>r.id===options.pingRole)).toString()),"Role"===options?.requirements?.type){var p=await msgOrint.guild.roles.fetch(options.requirements?.id,{force:!0});l={type:"Role",value:p}}else if("Guild"===options?.requirements?.type){var c=await d.guilds.cache.get(options.requirements?.id);if(!c)return j.channel.send({content:"Please add me to that server so I can set the requirement."});l={type:"Guild",value:c}}if(i)t=options.channel||f.options.get("channel")?.channel||i.channel,s=options.time||f.options.get("time")?.value.toString()||"1h",n=options.winners||Number(f.options.get("winners")?.value),r=options.prize||f.options.get("prize")?.value?.toString();else if(!i){var[...b]=j.content.split(/ +/g);if(!Number(b[2]))return j.reply({content:"Please provide a number for winners argument"});t=options.channel||j.mentions?.channels?.first()||j.channel,s=options.time||b[1]||"1h",n=Number(b[2])||options.winners,r=options.prize||b.slice(3)?.join(" ")}u?.enter?.style&&(u.enter.style=(0,misc_1.toButtonStyle)(u?.enter?.style)),u?.end?.style&&(u.end.style=(0,misc_1.toButtonStyle)(u?.end?.style)),u?.reroll?.style&&(u.reroll.style=(0,misc_1.toButtonStyle)(u?.reroll?.style));var g=(new discord_js_1.ButtonBuilder).setCustomId("enter_giveaway").setStyle(u?.enter?.style||discord_js_1.ButtonStyle.Success),y=("Emoji"===options?.type?g.setEmoji(u?.enter?.emoji||"🎁"):("Label"===options?.type?g:g.setEmoji(u?.enter?.emoji||"🎁")).setLabel(u?.enter?.label||"0"),(new discord_js_1.ButtonBuilder).setCustomId("end_giveaway").setStyle(u?.end?.style||discord_js_1.ButtonStyle.Danger)),w=("Emoji"===options?.type?y.setEmoji(u?.end?.emoji||"⛔"):("Label"===options?.type?y:y.setEmoji(u?.end?.emoji||"⛔")).setLabel(u?.end?.label||"End"),(new discord_js_1.ButtonBuilder).setCustomId("reroll_giveaway").setStyle(u?.reroll?.style||discord_js_1.ButtonStyle.Primary).setDisabled(!0)),h=("Emoji"===options?.type?w.setEmoji(u?.reroll?.emoji||"🔁"):("Label"===options?.type?w:w.setEmoji(u?.reroll?.emoji||"🔁")).setLabel(u?.reroll?.label||"Reroll"),(new discord_js_1.ActionRowBuilder).addComponents([g,w,y]));const R=(0,misc_1.ms)(s),A=Number((Date.now()+R).toString().slice(0,-3)),E=options?.embed?.giveaway?.fields||[{name:"Prize",value:"{prize}"},{name:"Hosted By",value:"{hosted}",inline:!0},{name:"Ends at",value:"{endsAt}",inline:!0},{name:"Winner(s)",value:"{winCount}",inline:!0},{name:"Requirements",value:"{requirements}"}];let m;function v(str){return str.replaceAll("{hosted}",`<@${msgOrint.member.user.id}>`).replaceAll("{endsAt}",`<t:${A}:f>`).replaceAll("{prize}",r).replaceAll("{requirements}","None"===l.type?"None":l.type+" | "+("Guild"===l.type?""+m:""+l.value)).replaceAll("{winCount}",n.toString()).replaceAll("{entered}","0")}"Guild"==l.type&&await l.value.invites.fetch().then(a=>{m="https://discord.gg/"+a.first()}),E?.forEach(a=>{a.value=v(a?.value)});var _=(new discord_js_1.EmbedBuilder).setTitle(v(options?.embed?.giveaway?.title||"Giveaway Time!")).setColor(options?.embed?.giveaway?.color||(0,misc_1.toRgb)("#406DBC")).setTimestamp(Number(Date.now()+R)).setFooter(options?.embed?.giveaway?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"}).setDescription(v(options?.embed?.giveaway?.description||"Interact with the giveaway using the buttons below.")).setFields(options?.embed?.giveaway?.fields);options?.embed?.giveaway?.author&&_.setAuthor(options.embed?.giveaway?.author),options?.embed?.giveaway?.image&&_.setImage(options.embed?.giveaway?.image),options?.embed?.giveaway?.thumbnail&&_.setThumbnail(options.embed?.giveaway?.thumbnail),options?.embed?.giveaway?.timestamp&&_.setTimestamp(options.embed?.giveaway?.timestamp),options?.embed?.giveaway?.title&&_.setTitle(options.embed?.giveaway?.title),options?.embed?.giveaway?.url&&_.setURL(options.embed?.giveaway?.url),await t.send({content:o,embeds:[_],components:[h]}).then(async msg=>{var e=Number(Date.now()+R),t=(resolve({message:msg,winners:n,prize:r,endsAt:e,requirements:l}),(new discord_js_1.ButtonBuilder).setLabel("View Giveaway.").setStyle(discord_js_1.ButtonStyle.Link).setURL(msg.url)),t=(new discord_js_1.ActionRowBuilder).addComponents([t]);i?await f.followUp({content:"Giveaway has started.",components:[t]}):await j.channel.send({content:"Giveaway has started.",components:[t]}),options.embed.giveaway.fields=E,await new giveaway_1.default({message:msg.id,entered:0,winCount:n,description:options.embed?.giveaway?.description||null,embeds:options.embed,requirements:{type:"None"===l?.type?"none":l?.type?.toLowerCase(),id:l?.value?.id},started:B,prize:r,entry:[],endTime:e,host:msgOrint.member.user.id}).save();const o=setInterval(async()=>{if(msg){const n=discord_js_1.ActionRowBuilder.from(msg?.components[0]),r=await giveaway_1.default.findOne({message:msg.id});if(r.endTime&&Number(r.endTime)<Date.now()){var e=(new discord_js_1.EmbedBuilder).setTitle(r?.embeds?.load?.title||"Processing Tickets...").setColor(r?.embeds?.load?.color||(0,misc_1.toRgb)("#cc0000")).setDescription(r?.embeds?.load?.description||"Please wait.. We are shuffling the members to pick a winner.").setFooter(r?.embeds?.load?.footer||{text:"Ending the Giveaway, Choosing a winner..."});r?.embeds?.load?.fields&&e.setFields(r?.embeds?.load?.fields),r?.embeds?.load?.author&&e.setAuthor(r?.embeds?.load?.author),r?.embeds?.load?.image&&e.setImage(r?.embeds?.load?.image),r?.embeds?.load?.thumbnail&&e.setThumbnail(r?.embeds?.load?.thumbnail),r?.embeds?.load?.timestamp&&e.setTimestamp(r?.embeds?.load?.timestamp),r?.embeds?.load?.title&&e.setTitle(r?.embeds?.load?.title),r?.embeds?.load?.url&&e.setURL(r?.embeds?.load?.url),clearInterval(o),await msg.edit({embeds:[e],components:[]}).catch(()=>{});const l=[],m=[];var t=r.winCount;const d=r.entry;for(let e=0;e<t;e++){var s=Math.floor(Math.random()*r.entered);0!=d.length&&m.push(d[s])}const u=msg.embeds[0].fields,p=[];setTimeout(()=>{m.forEach(async name=>{await i.guild.members.fetch(name?.userId).then(member=>{p.push(member),l.push(`<@${member.user.id}>`);var e=(new discord_js_1.EmbedBuilder).setTitle("You, Won the Giveaway!").setDescription(`You just won \`${r.prize}\` in the Giveaway at \`${member.guild.name}\` Go claim it fast !`).setColor("DarkGreen").setFooter(r?.embeds?.result?.footer||{text:"GG winner."}),t=(new discord_js_1.ButtonBuilder).setLabel("View Giveaway").setStyle(discord_js_1.ButtonStyle.Link).setURL(msg.url),t=(new discord_js_1.ActionRowBuilder).addComponents([t]);return member.send({embeds:[e],components:[t]}).catch(()=>{})}).catch(()=>{})})},(0,misc_1.ms)("2s")),setTimeout(async()=>{if(!r)return msg.delete();if(r){var e=discord_js_1.EmbedBuilder.from(msg.embeds[0]);const o=Number(r.endTime),i=[];if(r?.embeds?.result?.fields.forEach(a=>{"Requirements"!==a.name&&(a.value=a.value.replaceAll("{hosted}",`<@${r.host}>`).replaceAll("{endsAt}",`<t:${o}:f>`).replaceAll("{prize}",r.prize.toString()).replaceAll("{winCount}",r.winCount.toString()).replaceAll("{entered}",r.entered.toString()),i.push(a))}),r.entered<=0||0==d.length||!m[0])return e.setTitle("No one entered").setFields(i||u).setColor((0,misc_1.toRgb)("#cc0000")).setFooter({text:"Ohh man, Its ok lets get another giveaway goin."}),msg.edit({embeds:[e],components:(0,misc_1.disableButtons)([n])});var e=discord_js_1.ButtonBuilder.from(n.components[0]).setDisabled(!0),t=discord_js_1.ButtonBuilder.from(n.components[1]).setDisabled(!1),s=discord_js_1.ButtonBuilder.from(n.components[2]).setDisabled(!0),e=(new discord_js_1.ActionRowBuilder).setComponents([e,t,s]),t=(new discord_js_1.EmbedBuilder).setTitle(r?.embeds?.result?.title||"And the winner is,").setColor(r?.embeds?.result?.color||"DarkGreen").setDescription(r?.embeds?.result?.description.replaceAll("{winners}",l.join(", "))||l.join(", ")+` won the prize !
Get in touch with the staff members to collect your prize.`).setFooter(r?.embeds?.result?.footer||{text:"GG winner."}).setFields(i||u);r?.embeds?.result?.author&&t.setAuthor(r?.embeds?.result?.author),r?.embeds?.result?.image&&t.setImage(r?.embeds?.result?.image),r?.embeds?.result?.thumbnail&&t.setThumbnail(r?.embeds?.result?.thumbnail),r?.embeds?.result?.timestamp&&t.setTimestamp(r?.embeds?.result?.timestamp),r?.embeds?.result?.title&&t.setTitle(r?.embeds?.result?.title),r?.embeds?.result?.url&&t.setURL(r?.embeds?.result?.url),await msg.edit({embeds:[t],components:[e]}),resolve({type:"End",url:msg.url,user:p})}},(0,misc_1.ms)("6s"))}}},R)})}catch(e){if(options?.strict)throw new error_1.SimplyError({function:"giveaway",title:"An Error occured when running the function ",tip:e.stack});console.log("SimplyError - giveaway | Error: "+e.stack)}})}exports.giveaway=giveaway;