"use strict";var __importDefault=this&&this.__importDefault||function(mod){return mod&&mod.__esModule?mod:{default:mod}};Object.defineProperty(exports,"__esModule",{value:!0}),exports.manageGiveaway=void 0;const discord_js_1=require("discord.js"),giveaway_1=__importDefault(require("../model/giveaway")),error_1=require("../error"),misc_1=require("../misc");
// ------------------------------
// ------ F U N C T I O N -------
// ------------------------------
/**
 * ## manageGiveaway
 * ### A Giveaway Handler for **simplydjs giveaway system.**
 *
 * @async
 * @param {ButtonInteraction} button [`ButtonInteraction`](https://old.discordjs.dev/#/docs/discord.js/main/class/ButtonInteraction)
 * @param {manageGiveawayOptions} options [`manageGiveawayOptions`](https://simplyd.js.org/docs/handler/managegiveaway#managegiveawayoptions)
 * @returns {Promise<RerollResolve|EndResolve>} [`RerollResolve`](https://simplyd.js.org/docs/handler/managegiveaway#rerollresolve) | [`EndResolve`](https://simplyd.js.org/docs/handler/managegiveaway#endresolve)
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/handler/manageGiveaway)
 * @example simplydjs.manageGiveaway(interaction)
 */
async function manageGiveaway(button,options={}){return new Promise(async resolve=>{if(button.isButton())try{const l=button.member;
// ------------------------------
// ------ G I V E A W A Y -------
// ------------------------------
if("enter_giveaway"===button.customId){await button.deferUpdate();const m=await giveaway_1.default.findOne({message:button.message.id});if(Number(m.endTime)<Date.now())return await button.followUp({content:"Wait a second, This event has already ended",ephemeral:!0});var e=m.entry.find(id=>id?.userId===l.user.id);if(e)await giveaway_1.default.findOneAndUpdate({message:button.message.id},{$pull:{entry:{userId:l.user.id}}}),m.entered=m.entered-1,await m.save().then(async()=>button.followUp({content:"You've left the giveaway.",ephemeral:!0}));else if(!e){if("role"===m?.requirements?.type&&!button.member.roles.cache.find(r=>r.id===m?.requirements?.id))return await button.followUp({content:"You do not fall under the requirements. (You don't have the required role)",ephemeral:!0});if("guild"===m?.requirements?.type)if(!await button.client.guilds.cache.get(m?.requirements?.id).members.fetch(button.member.user.id))return await button.followUp({content:"You do not fall under the requirements. (You are not in the required guild)",ephemeral:!0});m.entry.push({userId:l.user.id,guildId:button.guild.id,messageId:button.message.id}),m.entered=m.entered+1,await m.save().then(async()=>{await button.followUp({content:"You've entered the giveaway.",ephemeral:!0})})}var t=button.message.embeds[0],s=discord_js_1.ActionRowBuilder.from(button.message.components[0]);s.components[0].setLabel(m.entered.toString()),button.message.edit({embeds:[t],components:[s]})}if("end_giveaway"===button.customId||"reroll_giveaway"===button.customId){if(!button.member.permissions.has(discord_js_1.PermissionFlagsBits.Administrator)||!button.member.permissions.has(discord_js_1.PermissionFlagsBits.ManageEvents))return await button.reply({content:"You cannot end/reroll the giveaway. You do not have the required permissions. `Administrator` (or) `Manage Events`",ephemeral:!0});await button.deferUpdate();const u=button.message,c=discord_js_1.ActionRowBuilder.from(u.components[0]),b=await giveaway_1.default.findOne({message:u.id}),w=u.embeds[0].fields;var o=(new discord_js_1.EmbedBuilder).setTitle(b?.embeds?.load?.title||("reroll_giveaway"===button.customId?"Rerolling the giveaway":"Processing Giveaway...")).setColor(b?.embeds?.load?.color||(0,misc_1.toRgb)("#cc0000")).setDescription(b?.embeds?.load?.description||"Please wait.. We are shuffling the tickets to pick a winner.").setFooter(b?.embeds?.load?.footer||{text:"Ending the Giveaway, Choosing a winner..."});b?.embeds?.load?.fields&&o.setFields(b?.embeds?.load?.fields),b?.embeds?.load?.author&&o.setAuthor(b?.embeds?.load?.author),b?.embeds?.load?.image&&o.setImage(b?.embeds?.load?.image),b?.embeds?.load?.thumbnail&&o.setThumbnail(b?.embeds?.load?.thumbnail),b?.embeds?.load?.timestamp&&o.setTimestamp(b?.embeds?.load?.timestamp),b?.embeds?.load?.title&&o.setTitle(b?.embeds?.load?.title),b?.embeds?.load?.url&&o.setURL(b?.embeds?.load?.url),await u.edit({embeds:[o],components:[]}).catch(()=>{});const p=[],h=(b.endTime=void 0,await b.save().catch(()=>{}),[]);var i=b.winCount,n=b.entry;if(0<b.entered)for(let e=0;e<i;e++){var d=Math.floor(Math.random()*b.entered);h.push(n[d])}const f=[];setTimeout(()=>{h.forEach(async name=>{await button.guild.members.fetch(name.userId).then(member=>{f.push(member),p.push(`<@${member.user.id}>`);var e=(new discord_js_1.EmbedBuilder).setTitle("You, Won the Giveaway!").setDescription(`You just won \`${b.prize}\` in the Giveaway at \`${member.guild.name}\` Go claim it fast !`).setColor("DarkGreen").setFooter({text:"GG winner."}),t=(new discord_js_1.ButtonBuilder).setLabel("View Giveaway").setStyle(discord_js_1.ButtonStyle.Link).setURL(u.url),t=(new discord_js_1.ActionRowBuilder).addComponents([t]);return member.send({embeds:[e],components:[t]}).catch(()=>{})}).catch(()=>{})})},(0,misc_1.ms)("2s")),setTimeout(async()=>{if(!b)return u.delete();if(b){var e=discord_js_1.EmbedBuilder.from(button.message.embeds[0]);const o=Number(b.endTime),r=[];if(b?.embeds?.result?.fields&&b?.embeds?.result?.fields.forEach(a=>{"Requirements"!==a.name&&(a.value=a.value.replaceAll("{hosted}",`<@${b.host}>`).replaceAll("{endsAt}",`<t:${o}:f>`).replaceAll("{prize}",b.prize.toString()).replaceAll("{winCount}",b.winCount.toString()).replaceAll("{entered}",b.entered.toString()),r.push(a))}),b.entered<=0||!h[0])return e.setTitle("No one entered").setFields(r||w).setColor((0,misc_1.toRgb)("#cc0000")).setFooter({text:"Ohh man, Its ok lets get another giveaway goin."}),u.edit({embeds:[e],components:(0,misc_1.disableButtons)([c])});var e=discord_js_1.ButtonBuilder.from(c.components[0]).setDisabled(!0),t=discord_js_1.ButtonBuilder.from(c.components[1]).setDisabled(!1),s=discord_js_1.ButtonBuilder.from(c.components[2]).setDisabled(!0),e=(new discord_js_1.ActionRowBuilder).setComponents([e,t,s]),t=(new discord_js_1.EmbedBuilder).setTitle(b?.embeds?.result?.title||"And the winner is,").setColor(b?.embeds?.result?.color||"DarkGreen").setDescription(b?.embeds?.result?.description.replaceAll("{winners}",p.join(", "))||p.join(", ")+` won the prize!
Get in touch with the staff members to collect your prize.`).setFooter(b?.embeds?.result?.footer||{text:"GG winner."}).setFields(r||w);b?.embeds?.result?.author&&t.setAuthor(b?.embeds?.result?.author),b?.embeds?.result?.image&&t.setImage(b?.embeds?.result?.image),b?.embeds?.result?.thumbnail&&t.setThumbnail(b?.embeds?.result?.thumbnail),b?.embeds?.result?.timestamp&&t.setTimestamp(b?.embeds?.result?.timestamp),b?.embeds?.result?.title&&t.setTitle(b?.embeds?.result?.title),b?.embeds?.result?.url&&t.setURL(b?.embeds?.result?.url),await u.edit({embeds:[t],components:[e]}),"reroll_giveaway"===button.customId?resolve({type:"Reroll",url:u.url,user:f}):resolve({type:"End",url:u.url,user:f})}},(0,misc_1.ms)("6s"))}}catch(e){if(options?.strict)throw new error_1.SimplyError({function:"manageGiveaway",title:"An Error occured when running the function ",tip:e.stack});console.log("SimplyError - manageGiveaway | Error: "+e.stack)}})}exports.manageGiveaway=manageGiveaway;