"use strict";var __importDefault=this&&this.__importDefault||function(mod){return mod&&mod.__esModule?mod:{default:mod}};Object.defineProperty(exports,"__esModule",{value:!0}),exports.manageSuggest=void 0;const discord_js_1=require("discord.js"),suggest_1=__importDefault(require("../model/suggest")),misc_1=require("../misc"),error_1=require("../error");
// ------------------------------
// ------ F U N C T I O N -------
// ------------------------------
/**
 * ## manageSuggest
 * ### A **Suggestion** handler which handles all sugestions from the package
 *
 * @param {ButtonInteraction} button [`ButtonInteraction`](https://old.discordjs.dev/#/docs/discord.js/main/class/ButtonInteraction)
 * @param {manageSuggestOptions} options [`manageSuggestOptions`](https://simplyd.js.org/docs/handler/managesuggest#managesuggestoptions)
 * @returns {Promise<void>} `void`
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/handler/manageSuggest)
 * @example simplydjs.manageSuggest(interaction)
 */
async function manageSuggest(button,options={}){return new Promise(async()=>{if(button.isButton())try{if(options.embed={deny:{title:options?.embed?.deny?.title||"Suggestion denied",color:options?.embed?.deny?.color||"Red"},accept:{title:options?.embed?.accept?.title||"Suggestion accepted",color:options?.embed?.accept?.color||"Green"}},"minus-suggestion"===button.customId){let o=await suggest_1.default.findOne({message:button.message.id});o||await(o=new suggest_1.default({message:button.message.id})).save().catch(()=>{});const $=button.message.embeds[0];function s(){return o.votes}function n(){return s().filter(val=>"up"===val.vote)}function a(){return s().filter(val=>"down"===val.vote)}var e=n(),t=a(),r=e.length,d=t.length;if(($.fields[1].value.includes("%")||isNaN(r))&&($.fields[1].value.includes("%")||isNaN(d))||(o.votes=e.concat(t),await o.save().catch(()=>{}),await T($,button.message)),button.member.permissions.has(discord_js_1.PermissionFlagsBits.Administrator)){var u=(new discord_js_1.ButtonBuilder).setStyle(discord_js_1.ButtonStyle.Primary).setLabel("Downvote").setCustomId("downvote-suggestion"),m=(new discord_js_1.ButtonBuilder).setStyle(discord_js_1.ButtonStyle.Danger).setLabel("Deny").setCustomId("deny-suggestion"),c=(new discord_js_1.ActionRowBuilder).addComponents([u,m]),l=await button.reply({content:"Do you want to Deny the suggestion (or) Vote?",components:[c],ephemeral:!0,fetchReply:!0});l.createMessageComponentCollector({filter:b=>button.user.id===b.user.id,componentType:discord_js_1.ComponentType.Button,time:(0,misc_1.ms)("30s")}).on("collect",async btn=>{if("downvote-suggestion"===btn.customId){var t=o.votes.find(m=>m.userId.toString()===btn.user.id);let e=o.votes.filter(m=>m.userId.toString()!==btn.user.id)||[];Array.isArray(e)||(e=[e]),t&&null!==t.vote?t&&("down"===t.vote?(o.votes=e,await o.save().catch(()=>{}),await T($,button.message),await button.editReply({content:"Removing your **downvote**",components:[]})):"up"===t.vote&&(t={userId:btn.user.id,vote:"down"},e.push(t),o.votes=e,await o.save().catch(()=>{}),await T($,button.message),await button.editReply({content:"You **downvoted** the suggestion. | Suggestion ID: "+`\`${button.message.id}\``,components:[]}))):(t={userId:btn.user.id,vote:"down"},e.push(t),o.votes=e,await o.save().catch(()=>{}),await T($,button.message),await button.editReply({content:"You **downvoted** the suggestion. | Suggestion ID: "+`\`${button.message.id}\``,components:[]}))}else{var e;"deny-suggestion"===btn.customId&&button.member.permissions.has(discord_js_1.PermissionFlagsBits.Administrator)&&(t=(new discord_js_1.TextInputBuilder).setLabel('Tell a reason | Say "cancel" to cancel.').setCustomId("deny-reason").setStyle(discord_js_1.TextInputStyle.Paragraph).setRequired(!1).setMaxLength(128),t=(new discord_js_1.ActionRowBuilder).setComponents([t]),t=(new discord_js_1.ModalBuilder).setCustomId("reason-modal").setTitle("Declining the suggestion").addComponents(t),await btn.showModal(t),(t=await btn.awaitModalSubmit({time:(0,misc_1.ms)("2m"),filter:i=>i.user.id===btn.user.id}))?"cancel"===(e=t.fields.getTextInputValue("deny-reason")).toLowerCase()?await t.reply({content:"You have cancelled to deny.",ephemeral:!0}):""==e?(await t.reply({content:"You denied the suggestion for reason: `No Reason`",ephemeral:!0}),N("No Reason",$,button.message,t.user)):(await t.reply({content:`You denied the suggestion for reason: \`${e}\``,ephemeral:!0}),N(e,$,button.message,t.user)):N("No Reason",$,button.message,t.user))}})}else if(!button.member.permissions.has(discord_js_1.PermissionFlagsBits.Administrator)){var p,g,b=o.votes.find(m=>m.userId.toString()===button.user.id);let e=o.votes.filter(m=>m.userId.toString()!==button.user.id)||[];Array.isArray(e)||(e=[e]),b&&null!==b.vote?b&&("down"===b.vote?(o.votes=e,await o.save().catch(()=>{}),await T($,button.message),await button.reply({content:"Removing your **downvote**",ephemeral:!0,components:[]})):"up"===b.vote&&(p={userId:button.user.id,vote:"down"},e.push(p),o.votes=e,await o.save().catch(()=>{}),await T($,button.message),await button.reply({content:"You **downvoted** the suggestion. | Suggestion ID: "+`\`${button.message.id}\``,ephemeral:!0,components:[]}))):(g={userId:button.user.id,vote:"down"},e.push(g),o.votes=e,await o.save().catch(()=>{}),await T($,button.message),await button.reply({content:"You **downvoted** the suggestion. | Suggestion ID: "+`\`${button.message.id}\``,ephemeral:!0,components:[]}))}}if("plus-suggestion"===button.customId){let o=await suggest_1.default.findOne({message:button.message.id});o||await(o=new suggest_1.default({message:button.message.id})).save().catch(()=>{});const M=button.message.embeds[0];function s(){return o.votes}function n(){return s().filter(val=>"up"===val.vote)}function a(){return s().filter(val=>"down"===val.vote)}var v=n(),w=a(),_=v.length,y=w.length;if((M.fields[1].value.includes("%")||isNaN(_))&&(M.fields[1].value.includes("%")||isNaN(y))||(o.votes=v.concat(w),await o.save().catch(()=>{}),await T(M,button.message)),button.member.permissions.has(discord_js_1.PermissionFlagsBits.Administrator)){var h=(new discord_js_1.ButtonBuilder).setStyle(discord_js_1.ButtonStyle.Primary).setLabel("Upvote").setCustomId("upvote-suggestion"),f=(new discord_js_1.ButtonBuilder).setStyle(discord_js_1.ButtonStyle.Success).setLabel("Accept").setCustomId("accept-suggestion"),B=(new discord_js_1.ActionRowBuilder).addComponents([h,f]),S=await button.reply({content:"Do you want to Accept suggestion (or) Vote?",components:[B],ephemeral:!0,fetchReply:!0});S.createMessageComponentCollector({filter:b=>button.user.id===b.user.id,componentType:discord_js_1.ComponentType.Button,time:(0,misc_1.ms)("30s")}).on("collect",async btn=>{if("upvote-suggestion"===btn.customId){var t=o.votes.find(m=>m.userId.toString()===btn.user.id);let e=o.votes.filter(m=>m.userId.toString()!==btn.user.id)||[];Array.isArray(e)||(e=[e]),t&&null!==t.vote?t&&("up"===t.vote?(o.votes=e,await o.save().catch(()=>{}),await T(M,button.message),await button.editReply({content:"Removing your **upvote**",components:[]})):"down"===t.vote&&(t={userId:btn.user.id,vote:"up"},e.push(t),o.votes=e,await o.save().catch(()=>{}),await T(M,button.message),await button.editReply({content:"You **upvoted** the suggestion. | Suggestion ID: "+`\`${button.message.id}\``,components:[]}))):(t={userId:btn.user.id,vote:"up"},e.push(t),o.votes=e,await o.save().catch(()=>{}),await T(M,button.message),await button.editReply({content:"You **upvoted** the suggestion. | Suggestion ID: "+`\`${button.message.id}\``,components:[]}))}else{var e;"accept-suggestion"===btn.customId&&button.member.permissions.has(discord_js_1.PermissionFlagsBits.Administrator)&&(t=(new discord_js_1.TextInputBuilder).setLabel('Tell a reason | Say "cancel" to cancel.').setCustomId("accept-reason").setStyle(discord_js_1.TextInputStyle.Paragraph).setRequired(!1).setMaxLength(128),t=(new discord_js_1.ActionRowBuilder).setComponents([t]),t=(new discord_js_1.ModalBuilder).setCustomId("reason-modal").setTitle("Accepting the suggestion").addComponents(t),await btn.showModal(t),(t=await btn.awaitModalSubmit({time:(0,misc_1.ms)("2m"),filter:i=>i.user.id===btn.user.id}))?"cancel"===(e=t.fields.getTextInputValue("accept-reason")).toLowerCase()?await t.reply({content:"You have cancelled to accept.",ephemeral:!0}):""==e?(await t.reply({content:"You accepted the suggestion for reason: `No Reason`",ephemeral:!0}),L("No Reason",M,button.message,t.user)):(await t.reply({content:`You accepted the suggestion for reason: \`${e}\``,ephemeral:!0}),L(e,M,button.message,t.user)):L("No Reason",M,button.message,t.user))}})}else if(!button.member.permissions.has(discord_js_1.PermissionFlagsBits.Administrator)){var j,I,R=o.votes.find(m=>m.userId.toString()===button.user.id);let e=o.votes.filter(m=>m.userId.toString()!==button.user.id)||[];Array.isArray(e)||(e=[e]),R&&null!==R.vote?R&&("up"===R.vote?(o.votes=e,await o.save().catch(()=>{}),await T(M,button.message),await button.reply({content:"Removing your **upvote**",ephemeral:!0,components:[]})):"down"===R.vote&&(j={userId:button.user.id,vote:"up"},e.push(j),o.votes=e,await o.save().catch(()=>{}),await T(M,button.message),await button.reply({content:"You **upvoted** the suggestion. | Suggestion ID: "+`\`${button.message.id}\``,ephemeral:!0,components:[]}))):(I={userId:button.user.id,vote:"up"},e.push(I),o.votes=e,await o.save().catch(()=>{}),await T(M,button.message),await button.reply({content:"You **upvoted** the suggestion. | Suggestion ID: "+`\`${button.message.id}\``,ephemeral:!0,components:[]}))}}if("who-voted-suggestion"===button.customId){let e=await suggest_1.default.findOne({message:button.message.id});function s(){return e.votes}function n(){return s().filter(val=>"up"===val.vote)}function a(){return s().filter(val=>"down"===val.vote)}function o(array){let e="";return array.forEach(val=>{e+=`<@${val.userId}>
`}),e}function C(array){let e="";return array.forEach(val=>{e+=button.client.users.cache.get(val.userId.toString()).username+`
`}),e}e||await(e=new suggest_1.default({message:button.message.id})).save().catch(()=>{});let t=(new discord_js_1.EmbedBuilder).setColor((0,misc_1.toRgb)("#406DBC")).addFields({name:"Upvoters",value:""+(o(n())||"Nobody Has Upvoted This Suggestion")},{name:"Downvoters",value:""+(o(a())||"Nobody Has Downvoted This Suggestion")});var D=(new discord_js_1.ButtonBuilder).setLabel("Show User Tags").setEmoji("#️⃣").setStyle(discord_js_1.ButtonStyle.Secondary).setCustomId("tag"),A=(new discord_js_1.ButtonBuilder).setLabel("Show User Mentions").setEmoji("🔢").setStyle(discord_js_1.ButtonStyle.Secondary).setCustomId("id");const P=(new discord_js_1.ActionRowBuilder).addComponents([D]),Y=(new discord_js_1.ActionRowBuilder).addComponents([A]);var x=await button.reply({embeds:[t],components:[P],ephemeral:!0,fetchReply:!0});x.createMessageComponentCollector({filter:b=>button.user.id===b.user.id,componentType:discord_js_1.ComponentType.Button,idle:(0,misc_1.ms)("30s")}).on("collect",async i=>{i.deferUpdate(),"tag"===i.customId?(t=(new discord_js_1.EmbedBuilder).setColor((0,misc_1.toRgb)("#406DBC")).addFields({name:"Upvoters",value:""+(C(n())||"Nobody Has Upvoted This Suggestion")},{name:"Downvoters",value:""+(C(a())||"Nobody Has Downvoted This Suggestion")}),button.editReply({embeds:[t],components:[Y]})):"id"===i.customId&&(t=(new discord_js_1.EmbedBuilder).setColor((0,misc_1.toRgb)("#406DBC")).addFields({name:"Upvoters",value:""+(o(n())||"Nobody Has Upvoted This Suggestion")},{name:"Downvoters",value:""+(o(a())||"Nobody Has Downvoted This Suggestion")}),button.editReply({embeds:[t],components:[P]}))})}async function T(embed,message){const e=await suggest_1.default.findOne({message:button.message.id});function t(){return e.votes}var o=t().filter(val=>"up"===val.vote),s=t().filter(val=>"down"===val.vote);let n=o.length,i=s.length;n<=0&&(n=0),i<=0&&(i=0);o=e.votes.length;let a=100*n/o,r=100*i/o,d=(a=parseInt(a.toPrecision(3))||0,r=parseInt(r.toPrecision(3))||0,(e?.progress?.blank||"⬛").repeat(10));a/10+r/10!=0||0!=o?d=(e?.progress?.up||"🟩").repeat(a/10)+(e?.progress?.down||"🟥").repeat(r/10):0!=o&&"NaN"!==a.toString()||(d=(e?.progress?.blank||"⬛").repeat(10),a=0,r=0);var s=discord_js_1.ActionRowBuilder.from(message.components[0]),o=discord_js_1.ButtonBuilder.from(s.components[0]),message=discord_js_1.ButtonBuilder.from(s.components[1]),u=discord_js_1.ButtonBuilder.from(s.components[2]);o.setLabel(n.toString()),message.setLabel(i.toString()),embed.fields[1].value=`${d} [${a||0}% - ${r||0}%]`,s.setComponents([o,message,u]),button.message.edit({embeds:[embed],components:[s]})}async function N(reason,oldemb,msg,user){oldemb.fields[0].value=`Denied

**Reason:** \`\`\`${reason}\`\`\``;reason=discord_js_1.EmbedBuilder.from(oldemb).setColor(options?.embed?.deny?.color||"Red").setFooter(options?.embed?.deny?.footer||{text:"Denied by "+user.username}).setTitle(options.embed?.deny?.title||"Suggestion denied"),options?.embed?.deny?.author&&reason.setAuthor(options.embed?.deny?.author),options?.embed?.deny?.image&&reason.setImage(options.embed?.deny?.image),options?.embed?.deny?.thumbnail&&reason.setThumbnail(options.embed?.deny?.thumbnail),options?.embed?.deny?.timestamp&&reason.setTimestamp(options.embed?.deny?.timestamp),options?.embed?.deny?.title&&reason.setTitle(options.embed?.deny?.title),options?.embed?.deny?.url&&reason.setURL(options.embed?.deny?.url),options?.embed?.deny?.description&&reason.setDescription(options.embed?.deny?.description),oldemb=discord_js_1.ActionRowBuilder.from(msg.components[0]),user=discord_js_1.ButtonBuilder.from(oldemb.components[0]),msg=discord_js_1.ButtonBuilder.from(oldemb.components[1]),oldemb=discord_js_1.ButtonBuilder.from(oldemb.components[2]),user.setDisabled(!0),msg.setDisabled(!0),oldemb.setDisabled(!1),user=(new discord_js_1.ActionRowBuilder).setComponents([user,msg,oldemb]);button.message.edit({embeds:[reason],components:[user]})}async function L(reason,oldemb,msg,user){oldemb.fields[0].value=`Accepted

**Reason:** \`\`\`${reason}\`\`\``;reason=discord_js_1.EmbedBuilder.from(oldemb).setColor(options?.embed?.accept?.color||"Green").setFooter(options?.embed?.accept?.footer||{text:"Accepted by "+user.username}).setTitle(options.embed?.accept?.title||"Suggestion accepted"),options?.embed?.accept?.author&&reason.setAuthor(options.embed?.accept?.author),options?.embed?.accept?.image&&reason.setImage(options.embed?.accept?.image),options?.embed?.accept?.thumbnail&&reason.setThumbnail(options.embed?.accept?.thumbnail),options?.embed?.accept?.timestamp&&reason.setTimestamp(options.embed?.accept?.timestamp),options?.embed?.accept?.title&&reason.setTitle(options.embed?.accept?.title),options?.embed?.accept?.url&&reason.setURL(options.embed?.accept?.url),options?.embed?.accept?.description&&reason.setDescription(options.embed?.accept?.description),oldemb=discord_js_1.ActionRowBuilder.from(msg.components[0]),user=discord_js_1.ButtonBuilder.from(oldemb.components[0]),msg=discord_js_1.ButtonBuilder.from(oldemb.components[1]),oldemb=discord_js_1.ButtonBuilder.from(oldemb.components[2]),user.setDisabled(!0),msg.setDisabled(!0),oldemb.setDisabled(!1),user=(new discord_js_1.ActionRowBuilder).setComponents([user,msg,oldemb]);button.message.edit({embeds:[reason],components:[user]})}}catch(e){if(options?.strict)throw new error_1.SimplyError({function:"manageSuggest",title:"An Error occured when running the function",tip:e.stack});console.log("SimplyError - manageSuggest | Error: "+e.stack)}})}exports.manageSuggest=manageSuggest;