"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.rps=void 0;const discord_js_1=require("discord.js"),misc_1=require("./misc"),SimplyError_1=require("./error/SimplyError"),combinations={rock:"scissors",scissors:"paper",paper:"rock"};
/**
 * ## rps
 * ### A classic RPS game, except this time it's on Discord to play with your pals, how cool is that ?
 *
 * @async
 * @param {ExtendedMessage | ExtendedInteraction} msgOrint [`ExtendedMessage`](https://simplyd.js.org/docs/typedef/extendedmessage) | [`ExtendedInteraction`](https://simplyd.js.org/docs/typedef/extendedinteraction)
 * @param {rpsOptions} options [`rpsOptions`](https://simplyd.js.org/docs/fun/rps#rpsOptions)
 * @returns {Promise<User>} [`User`](https://discord.js.org/#/docs/discord.js/stable/class/User)
 *
 * ---
 *
 * @link [`Documentation`](https://simplyd.js.org/docs/Fun/rps)
 * @example simplydjs.rps(interaction)
 */
async function rps(msgOrint,options={strict:!1}){return new Promise(async resolve=>{var e=(new discord_js_1.ButtonBuilder).setLabel("Accept").setStyle(discord_js_1.ButtonStyle.Success).setCustomId("accept"),t=(new discord_js_1.ButtonBuilder).setLabel("Deny").setStyle(discord_js_1.ButtonStyle.Danger).setCustomId("decline"),e=(new discord_js_1.ActionRowBuilder).addComponents([e,t]);const m={rock:{style:options?.buttons?.rock?.style||discord_js_1.ButtonStyle.Primary,label:options?.buttons?.rock?.label||"Rock",emoji:options?.buttons?.rock?.emoji||"🪨"},paper:{style:options?.buttons?.paper?.style||discord_js_1.ButtonStyle.Success,label:options?.buttons?.paper?.label||"Paper",emoji:options?.buttons?.paper?.emoji||"📄"},scissor:{style:options?.buttons?.scissor?.style||discord_js_1.ButtonStyle.Danger,label:options?.buttons?.scissor?.label||"Scissor",emoji:options?.buttons?.scissor?.emoji||"✂️"}};m?.rock?.style&&(m.rock.style=(0,misc_1.toButtonStyle)(m?.rock?.style)),m?.paper?.style&&(m.paper.style=(0,misc_1.toButtonStyle)(m?.paper?.style)),m?.scissor?.style&&(m.scissor.style=(0,misc_1.toButtonStyle)(m?.scissor?.style));var t=(new discord_js_1.ButtonBuilder).setLabel(m?.rock?.label).setCustomId("rock").setStyle(m?.rock?.style||discord_js_1.ButtonStyle.Primary).setEmoji(m?.rock?.emoji),o=(new discord_js_1.ButtonBuilder).setLabel(m?.paper?.label).setCustomId("paper").setStyle(m?.paper?.style||discord_js_1.ButtonStyle.Success).setEmoji(m?.paper?.emoji),s=(new discord_js_1.ButtonBuilder).setLabel(m?.scissor?.label).setCustomId("scissors").setStyle(m?.scissor?.style||discord_js_1.ButtonStyle.Danger).setEmoji(m?.scissor?.emoji);const a=(new discord_js_1.ActionRowBuilder).addComponents([t,o,s]),p=(new discord_js_1.EmbedBuilder).setTitle(options?.embed?.timeout?.title||"Game Timed Out!").setColor(options?.embed?.timeout?.color||"Red").setDescription(options?.embed?.timeout?.description||"The opponent didnt respond in time (30s)").setFooter(options?.embed?.timeout?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"});
//Embeds
options?.embed?.timeout?.fields&&p.setFields(options.embed?.timeout?.fields),options?.embed?.timeout?.author&&p.setAuthor(options.embed?.timeout?.author),options?.embed?.timeout?.image&&p.setImage(options.embed?.timeout?.image),options?.embed?.timeout?.thumbnail&&p.setThumbnail(options.embed?.timeout?.thumbnail),options?.embed?.timeout?.timestamp&&p.setTimestamp(options.embed?.timeout?.timestamp),options?.embed?.timeout?.url&&p.setURL(options.embed?.timeout?.url);try{let i,n;i=msgOrint.commandId?((n=msgOrint).deferred||await n.deferReply({fetchReply:!0}),options.opponent||n.options.getUser("user")):msgOrint.mentions.members.first()?.user;const c=msgOrint;var d=msgOrint;if(n){if(n){if(!i)return await c.followUp({content:"No opponent mentioned!",ephemeral:!0});if(i.bot)return await c.followUp({content:"You can't play against bots",ephemeral:!0});if(i.id===msgOrint.member.user.id)return await c.followUp({content:"You cannot play with yourself!",ephemeral:!0})}}else{if(!i)return d.reply("No opponent mentioned!");if(i.bot)return d.reply("You cannot play against bots");if(i.id===msgOrint.member.user.id)return d.reply("You cannot play with yourself!")}var l=(new discord_js_1.EmbedBuilder).setTitle(options.embed?.request?.title||`Request for ${i.username} !`).setAuthor(options.embed?.request?.author||{name:msgOrint.member.user.username,iconURL:msgOrint.member.user.displayAvatarURL({forceStatic:!1})}).setDescription(options.embed?.request?.description||"You are invited to play Rock Paper Scissors").setColor(options.embed?.request?.color||(0,misc_1.toRgb)("#406DBC")).setFooter(options.embed?.request?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"});options?.embed?.request?.fields&&l.setFields(options.embed?.request?.fields),options?.embed?.request?.author&&l.setAuthor(options.embed?.request?.author),options?.embed?.request?.image&&l.setImage(options.embed?.request?.image),options?.embed?.request?.thumbnail&&l.setThumbnail(options.embed?.request?.thumbnail),options?.embed?.request?.timestamp&&l.setTimestamp(options.embed?.request?.timestamp),options?.embed?.request?.url&&l.setURL(options.embed?.request?.url);let r;n?r=await c.followUp({content:`<@${i.id}>. You got a Rock Paper Scissor invitation !`,embeds:[l],components:[e]}):n||(r=await d.reply({content:`<@${i.id}>. You got a Rock Paper Scissor invitation !`,embeds:[l],components:[e]}));const u=r.createMessageComponentCollector({componentType:discord_js_1.ComponentType.Button,time:(0,misc_1.ms)("30s")});u.on("collect",async button=>{if(button.user.id!==i.id)await button.reply({content:`Only <@!${i.id}> can use these buttons!`,ephemeral:!0});else if(await button.deferUpdate(),"decline"==button.customId)u.stop("decline");else{button=(new discord_js_1.EmbedBuilder).setTitle(options.embed?.game?.title||msgOrint.member.user.username+" VS. "+i.username).setAuthor(options.embed?.game?.author||{name:msgOrint.member.user.username,iconURL:msgOrint.member.user.displayAvatarURL({forceStatic:!1})}).setDescription(options.embed?.game?.description||"Select 🪨, 📄, or ✂️").setColor(options.embed?.game?.color||(0,misc_1.toRgb)("#406DBC")).setFooter(options.embed?.game?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"});options?.embed?.game?.fields&&button.setFields(options.embed?.game?.fields),options?.embed?.game?.author&&button.setAuthor(options.embed?.game?.author),options?.embed?.game?.image&&button.setImage(options.embed?.game?.image),options?.embed?.game?.thumbnail&&button.setThumbnail(options.embed?.game?.thumbnail),options?.embed?.game?.timestamp&&button.setTimestamp(options.embed?.game?.timestamp),options?.embed?.game?.url&&button.setURL(options.embed?.game?.url),n?await c.editReply({content:"**Its time.. for RPS.**",embeds:[button],components:[a]}):n||await r.edit({content:"**Its time.. for RPS.**",embeds:[button],components:[a]}),u.stop();const o=new Set;o.add(msgOrint.member.user.id),o.add(i.id);let e,t;const s=r.createMessageComponentCollector({componentType:discord_js_1.ComponentType.Button,time:(0,misc_1.ms)("30s")});s.on("collect",async b=>{await b.deferUpdate(),o.has(b.user.id)?(o.delete(b.user.id),b.user.id===i.id&&(e=b.customId),b.user.id===msgOrint.member.user.id&&(t=b.customId),setTimeout(()=>{0==o.size&&s.stop()},500)):await b.followUp({content:"You cannot play the game.",ephemeral:!0})}),s.on("end",async(_collected,reason)=>{"time"===reason?n?await n.editReply({content:"** **",embeds:[p],components:[]}):n||await r.edit({content:"** **",embeds:[p],components:[]}):e===t?(e=e.replace("scissors",m?.scissor?.emoji+" "+m?.scissor?.label).replace("paper",m?.paper?.emoji+" "+m?.paper?.label).replace("rock",m?.rock?.emoji+" "+m?.rock?.label),reason=(new discord_js_1.EmbedBuilder).setTitle(options.embed?.draw?.title||"Draw!").setColor(options.embed?.draw?.color||(0,misc_1.toRgb)("#406DBC")).setDescription(options.embed?.draw?.description||`Both players chose **${e}**`).setFooter(options.embed?.draw?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"}),options?.embed?.draw?.fields&&reason.setFields(options.embed?.draw?.fields),options?.embed?.draw?.author&&reason.setAuthor(options.embed?.draw?.author),options?.embed?.draw?.image&&reason.setImage(options.embed?.draw?.image),options?.embed?.draw?.thumbnail&&reason.setThumbnail(options.embed?.draw?.thumbnail),options?.embed?.draw?.timestamp&&reason.setTimestamp(options.embed?.draw?.timestamp),options?.embed?.draw?.url&&reason.setURL(options.embed?.draw?.url),n&&await n.editReply({content:"** **",embeds:[reason],components:[]}),n||await r.edit({content:"** **",embeds:[reason],components:[]})):combinations[e]===t?(e=e.replace("scissors",m?.scissor?.emoji+" "+m?.scissor?.label).replace("paper",m?.paper?.emoji+" "+m?.paper?.label).replace("rock",m?.rock?.emoji+" "+m?.rock?.label),t=t.replace("scissors",m?.scissor?.emoji+" "+m?.scissor?.label).replace("paper",m?.paper?.emoji+" "+m?.paper?.label).replace("rock",m?.rock?.emoji+" "+m?.rock?.label),reason=(new discord_js_1.EmbedBuilder).setTitle(options.embed?.win?.title||i.username+" Won !").setColor(options.embed?.win?.color||"Green").setDescription(options.embed?.win?.description||`**${e}** defeats **${t}**`).setFooter(options.embed?.win?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"}),options?.embed?.win?.fields&&reason.setFields(options.embed?.win?.fields),options?.embed?.win?.author&&reason.setAuthor(options.embed?.win?.author),options?.embed?.win?.image&&reason.setImage(options.embed?.win?.image),options?.embed?.win?.thumbnail&&reason.setThumbnail(options.embed?.win?.thumbnail),options?.embed?.win?.timestamp&&reason.setTimestamp(options.embed?.win?.timestamp),options?.embed?.win?.url&&reason.setURL(options.embed?.win?.url),
//p1 - won
n?(await n.editReply({content:"** **",embeds:[reason],components:[]}),resolve(i)):n||(await r.edit({content:"** **",embeds:[reason],components:[]}),resolve(i))):(e=e.replace("scissors",m?.scissor?.emoji+" "+m?.scissor?.label).replace("paper",m?.paper?.emoji+" "+m?.paper?.label).replace("rock",m?.rock?.emoji+" "+m?.rock?.label),t=t.replace("scissors",m?.scissor?.emoji+" "+m?.scissor?.label).replace("paper",m?.paper?.emoji+" "+m?.paper?.label).replace("rock",m?.rock?.emoji+" "+m?.rock?.label),reason=(new discord_js_1.EmbedBuilder).setTitle(options.embed?.win?.title||msgOrint.member.user.username+" Won !").setColor(options.embed?.win?.color||"Green").setDescription(options.embed?.win?.description||`**${t}** defeats **${e}**`).setFooter(options.embed?.win?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"}),options?.embed?.win?.fields&&reason.setFields(options.embed?.win?.fields),options?.embed?.win?.author&&reason.setAuthor(options.embed?.win?.author),options?.embed?.win?.image&&reason.setImage(options.embed?.win?.image),options?.embed?.win?.thumbnail&&reason.setThumbnail(options.embed?.win?.thumbnail),options?.embed?.win?.timestamp&&reason.setTimestamp(options.embed?.win?.timestamp),options?.embed?.win?.url&&reason.setURL(options.embed?.win?.url),
//p2 - won
n?(await n.editReply({content:"** **",embeds:[reason],components:[]}),resolve(msgOrint.member.user)):n||await r.edit({content:"** **",embeds:[reason],components:[]}),resolve(msgOrint.member.user))})}}),u.on("end",async(_collected,reason)=>{"time"===reason?await r.edit({content:"** **",embeds:[p],components:[]}):"decline"==reason&&(reason=(new discord_js_1.EmbedBuilder).setColor(options.embed?.decline?.color||"Red").setFooter(options.embed?.decline?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"}).setTitle(options.embed?.decline?.title||"Game Declined!").setDescription(options.embed?.decline?.description||i.username+" has declined your game request!"),options?.embed?.decline?.fields&&reason.setFields(options.embed?.decline?.fields),options?.embed?.decline?.author&&reason.setAuthor(options.embed?.decline?.author),options?.embed?.decline?.image&&reason.setImage(options.embed?.decline?.image),options?.embed?.decline?.thumbnail&&reason.setThumbnail(options.embed?.decline?.thumbnail),options?.embed?.decline?.timestamp&&reason.setTimestamp(options.embed?.decline?.timestamp),options?.embed?.decline?.url&&reason.setURL(options.embed?.decline?.url),await r.edit({content:"** **",embeds:[reason],components:[]}))})}catch(e){if(options?.strict)throw new SimplyError_1.SimplyError({function:"rps",title:"An Error occured when running the function ",tip:e.stack});console.log("SimplyError - rps | Error: "+e.stack)}})}exports.rps=rps;