"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.tictactoe=void 0;const discord_js_1=require("discord.js"),misc_1=require("./misc"),error_1=require("./error"),limiter=[],combinations=[[0,1,2],[3,4,5],[6,7,8],[0,3,6],[1,4,7],[2,5,8],[0,4,8],[2,4,6]];
/**
 * ## tictactoe
 * ### One line implementation of a super enjoyable **tictactoe game**.
 *
 * @async
 * @param {ExtendedMessage | ExtendedInteraction} msgOrint [`ExtendedMessage`](https://simplyd.js.org/docs/typedef/extendedmessage) | [`ExtendedInteraction`](https://simplyd.js.org/docs/typedef/extendedinteraction)
 * @param {tictactoeOptions} options [`tictactoeOptions`](https://simplyd.js.org/docs/fun/tictactoe#tictactoeoptions)
 * @returns {Promise<User>} [`User`](https://discord.js.org/#/docs/discord.js/stable/class/User)
 *
 * ---
 *
 * @link `Documentation:` https://simplyd.js.org/docs/Fun/tictactoe
 * @example simplydjs.tictactoe(interaction)
 */
async function tictactoe(msgOrint,options={max:6,strict:!1}){return new Promise(async resolve=>{try{const D=msgOrint["client"];let e;!msgOrint.commandId||(e=msgOrint).deferred||await e.deferReply({fetchReply:!0});let U;var o=msgOrint,i=msgOrint;let O=limiter.findIndex(a=>a.guild==msgOrint.guild.id);if(limiter[O]&&limiter[O].guild||(limiter.push({guild:msgOrint.guild.id,limit:0}),O=limiter.findIndex(a=>a.guild==msgOrint.guild.id)),limiter[O].limit>=(options?.max||6)){if(e)return o.followUp({content:"Sorry, There is a game happening right now. Please try later."});if(!e)return i.reply({content:"Sorry, There is a game happening right now. Please try later."})}const C=options.buttons?.X?.emoji?.id||options.buttons?.X?.emoji||"❌",S=options.buttons?.O?.emoji?.id||options.buttons?.O?.emoji||"⭕",a=options.buttons?.blank?.emoji||"➖",l=(options?.buttons?.blank?.style&&(options.buttons.blank.style=(0,misc_1.toButtonStyle)(options?.buttons?.blank?.style)),options?.buttons?.X?.style&&(options.buttons.X.style=(0,misc_1.toButtonStyle)(options?.buttons?.X?.style)),options?.buttons?.O?.style&&(options.buttons.O.style=(0,misc_1.toButtonStyle)(options?.buttons?.O?.style)),options.buttons?.blank?.style||discord_js_1.ButtonStyle.Secondary),E=options.buttons?.X?.style||discord_js_1.ButtonStyle.Danger,v=options.buttons?.O?.style||discord_js_1.ButtonStyle.Success;if(e){if(!(U=options.user||o.options.getUser("user")))return ai(msgOrint,{max:options?.max||6,blank_emoji:a,x_emoji:C,o_emoji:S,x_style:E,o_style:v,emptyStyle:l,embed:options.embed,buttons:options.buttons,type:options.type,hard:options.hard||!1});if(U.bot)return o.followUp({content:"You cannot play with bots!",ephemeral:!0});if(U.id==msgOrint.user.id)return o.followUp({content:"You cannot play with yourself!",ephemeral:!0})}else if(!e){if(!(U=i.mentions.users.first()))return ai(msgOrint,{max:options?.max||6,blank_emoji:a,x_emoji:C,o_emoji:S,x_style:E,o_style:v,emptyStyle:l,embed:options.embed,buttons:options.buttons,type:options.type});if(U.bot)return i.reply({content:"You can't play with bots!"});if(U.id===msgOrint.member.user.id)return i.reply({content:"You cannot play with yourself!"})}var s=(new discord_js_1.EmbedBuilder).setTitle(options?.embed?.request?.title||"Tictactoe with "+U.username).setDescription(options?.embed?.request?.description||"Waiting for the opponent to accept/deny").setAuthor(options?.embed?.request?.author||{name:msgOrint.member.user.username,iconURL:msgOrint.member.user.displayAvatarURL({forceStatic:!1})}).setColor(options.embed?.request?.color||(0,misc_1.toRgb)("#406DBC")).setFooter(options.embed?.request?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"}),n=(options?.embed?.request?.fields&&s.setFields(options.embed?.request?.fields),options?.embed?.request?.author&&s.setAuthor(options.embed?.request?.author),options?.embed?.request?.image&&s.setImage(options.embed?.request?.image),options?.embed?.request?.thumbnail&&s.setThumbnail(options.embed?.request?.thumbnail),options?.embed?.request?.timestamp&&s.setTimestamp(options.embed?.request?.timestamp),options?.embed?.request?.title&&s.setTitle(options.embed?.request?.title),options?.embed?.request?.url&&s.setURL(options.embed?.request?.url),(new discord_js_1.ButtonBuilder).setLabel("Accept").setStyle(discord_js_1.ButtonStyle.Success).setCustomId("accept-ttt")),r=(new discord_js_1.ButtonBuilder).setLabel("Deny").setStyle(discord_js_1.ButtonStyle.Danger).setCustomId("deny-ttt"),d=(new discord_js_1.ActionRowBuilder).addComponents([n,r]);let t;e?t=await o.followUp({content:`<@${U.id}>, You got a tictactoe request from `+msgOrint.member.user.username,embeds:[s],components:[d]}):e||(t=await i.reply({content:`<@${U.id}>, You got a tictactoe request from `+msgOrint.member.user.username,embeds:[s],components:[d]})),limiter[O].limit+=1;const p=t.createMessageComponentCollector({componentType:discord_js_1.ComponentType.Button,time:(0,misc_1.ms)("30s")});p.on("collect",async button=>{if(button.user.id!==U.id)await button.reply({content:`Only <@!${U.id}> can use these buttons!`,ephemeral:!0});else if("deny-ttt"==button.customId)await button.deferUpdate(),p.stop("decline");else if("accept-ttt"==button.customId){await button.deferUpdate(),p.stop();const A=[msgOrint.member.user.id,U.id].sort(()=>.5<Math.random()?1:-1),I=(new discord_js_1.EmbedBuilder).setTitle(options.embed?.game?.title||msgOrint.member.user.username+" VS "+U.username).setAuthor(options.embed?.game?.author||{name:msgOrint.member.user.username,iconURL:msgOrint.member.user.displayAvatarURL({forceStatic:!1})}).setColor(options.embed?.game?.color||(0,misc_1.toRgb)("#406DBC")).setFooter(options.embed?.game?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"});options?.embed?.game?.fields&&I.setFields(options.embed?.game?.fields),options?.embed?.game?.author&&I.setAuthor(options.embed?.game?.author),options?.embed?.game?.image&&I.setImage(options.embed?.game?.image),options?.embed?.game?.thumbnail&&I.setThumbnail(options.embed?.game?.thumbnail),options?.embed?.game?.timestamp&&I.setTimestamp(options.embed?.game?.timestamp),options?.embed?.game?.url&&I.setURL(options.embed?.game?.url);button=await button.message.edit({embeds:[I.setDescription(`Waiting for Input | <@!${A[0]}>, Your Emoji: `+(D.emojis.cache.get(S)||"⭕"))]});const R={user:0,userid:"",board:Array(9).fill({style:l,emoji:a,disabled:!1})};(async function e(m,styles={}){const t=styles["blank_emoji"];R.userid=A[R.user];const o={O:!1,X:!1};function i(emoji){return combinations.some(combination=>combination.every(index=>R.board[index].emoji==emoji))}function s(){return[...R.board].every(cell=>cell.emoji==C||cell.emoji==S)}const n=(new discord_js_1.ButtonBuilder).setStyle(R.board[0].style).setEmoji(R.board[0].emoji).setCustomId("0").setDisabled(R.board[0].disabled);const r=(new discord_js_1.ButtonBuilder).setStyle(R.board[1].style).setEmoji(R.board[1].emoji).setCustomId("1").setDisabled(R.board[1].disabled);const d=(new discord_js_1.ButtonBuilder).setStyle(R.board[2].style).setEmoji(R.board[2].emoji).setCustomId("2").setDisabled(R.board[2].disabled);const a=(new discord_js_1.ButtonBuilder).setStyle(R.board[3].style).setEmoji(R.board[3].emoji).setCustomId("3").setDisabled(R.board[3].disabled);const l=(new discord_js_1.ButtonBuilder).setStyle(R.board[4].style).setEmoji(R.board[4].emoji).setCustomId("4").setDisabled(R.board[4].disabled);const p=(new discord_js_1.ButtonBuilder).setStyle(R.board[5].style).setEmoji(R.board[5].emoji).setCustomId("5").setDisabled(R.board[5].disabled);const u=(new discord_js_1.ButtonBuilder).setStyle(R.board[6].style).setEmoji(R.board[6].emoji).setCustomId("6").setDisabled(R.board[6].disabled);const c=(new discord_js_1.ButtonBuilder).setStyle(R.board[7].style).setEmoji(R.board[7].emoji).setCustomId("7").setDisabled(R.board[7].disabled);const h=(new discord_js_1.ButtonBuilder).setStyle(R.board[8].style).setEmoji(R.board[8].emoji).setCustomId("8").setDisabled(R.board[8].disabled);const j=(new discord_js_1.ActionRowBuilder).addComponents([n,r,d]);const g=(new discord_js_1.ActionRowBuilder).addComponents([a,l,p]);const w=(new discord_js_1.ActionRowBuilder).addComponents([u,c,h]);const y=[j,g,w];const _=(new discord_js_1.EmbedBuilder).setTitle(options.embed?.win?.title||msgOrint.member.user.username+" VS "+U.username).setColor(options.embed?.win?.color||"DarkGreen").setFooter(options.embed?.win?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"});options?.embed?.win?.fields&&_.setFields(options.embed?.win?.fields);options?.embed?.win?.author&&_.setAuthor(options.embed?.win?.author);options?.embed?.win?.image&&_.setImage(options.embed?.win?.image);options?.embed?.win?.thumbnail&&_.setThumbnail(options.embed?.win?.thumbnail);options?.embed?.win?.timestamp&&_.setTimestamp(options.embed?.win?.timestamp);options?.embed?.win?.url&&_.setURL(options.embed?.win?.url);i(S)&&(o.O=!0);i(C)&&(o.X=!0);if(1==o.O){--limiter[O].limit,limiter[O].limit<0&&(limiter[O].limit=0);const B=await D.users.fetch(A[0===R.user?1:0]).catch(console.error);if(resolve(B),!options.type||"Button"===options.type)return m.edit({content:`<@${A[0===R.user?1:0]}> (${D.emojis.cache.get(S)||"⭕"}) won`,components:(0,misc_1.disableButtons)(y),embeds:[_.setAuthor(options.embed?.win?.author||{name:B.username,iconURL:B.displayAvatarURL({forceStatic:!1})}).setDescription(`<@!${A[0===R.user?1:0]}> (${D.emojis.cache.get(S)||"⭕"}) won, That was a nice game.`)]}).then(m=>{m.react(D.emojis.cache.get(S)||"⭕")});if("Embed"===options?.type)return m.edit({content:`<@${A[0===R.user?1:0]}> (${D.emojis.cache.get(S)||"⭕"}) won`,embeds:[_.setAuthor(options.embed?.win?.author||{name:B.username,iconURL:B.displayAvatarURL({forceStatic:!1})}).setDescription(`<@!${A[0===R.user?1:0]}> (${D.emojis.cache.get(S)||"⭕"}) won.. That was a nice game.
`+`\`\`\`
${R.board[0].emoji} | ${R.board[1].emoji} | ${R.board[2].emoji}
${R.board[3].emoji} | ${R.board[4].emoji} | ${R.board[5].emoji}
${R.board[6].emoji} | ${R.board[7].emoji} | ${R.board[8].emoji}
\`\`\``.replaceAll(t,"➖").replaceAll(S,"⭕").replaceAll(C,"❌"))],components:[]}).then(m=>{m.react(D.emojis.cache.get(S)||"⭕")})}else if(1==o.X){--limiter[O].limit,limiter[O].limit<0&&(limiter[O].limit=0);const x=await D.users.fetch(A[0===R.user?1:0]).catch(console.error);if(resolve(x),!options.type||"Button"===options.type)return m.edit({content:`<@${A[0===R.user?1:0]}> (${D.emojis.cache.get(C)||"❌"}) won`,components:(0,misc_1.disableButtons)(y),embeds:[_.setAuthor(options.embed?.win?.author||{name:x.username,iconURL:x.displayAvatarURL({forceStatic:!1})}).setDescription(`<@!${A[0===R.user?1:0]}> (${D.emojis.cache.get(C)||"❌"}) won, That was a nice game.`)]}).then(m=>{m.react(D.emojis.cache.get(C)||"❌")});if("Embed"===options?.type)return m.edit({content:`<@${A[0===R.user?1:0]}> (${D.emojis.cache.get(S)||"❌"}) won`,embeds:[_.setAuthor(options.embed?.win?.author||{name:x.username,iconURL:x.displayAvatarURL({forceStatic:!1})}).setDescription(`<@!${A[0===R.user?1:0]}> (${D.emojis.cache.get(C)||"❌"}) won.. That was a nice game.
`+`\`\`\`
${R.board[0].emoji} | ${R.board[1].emoji} | ${R.board[2].emoji}
${R.board[3].emoji} | ${R.board[4].emoji} | ${R.board[5].emoji}
${R.board[6].emoji} | ${R.board[7].emoji} | ${R.board[8].emoji}
\`\`\``.replaceAll(t,"➖").replaceAll(S,"⭕").replaceAll(C,"❌"))],components:[]}).then(m=>{m.react(D.emojis.cache.get(C)||"❌")})}if(s()){--limiter[O].limit,limiter[O].limit<0&&(limiter[O].limit=0);const T=(new discord_js_1.EmbedBuilder).setTitle(options.embed?.draw?.title||msgOrint.member.user.username+" VS "+U.username).setColor(options.embed?.draw?.color||"Grey").setFooter(options.embed?.draw?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"});return options?.embed?.draw?.fields&&T.setFields(options.embed?.draw?.fields),options?.embed?.draw?.author&&T.setAuthor(options.embed?.draw?.author),options?.embed?.draw?.image&&T.setImage(options.embed?.draw?.image),options?.embed?.draw?.thumbnail&&T.setThumbnail(options.embed?.draw?.thumbnail),options?.embed?.draw?.timestamp&&T.setTimestamp(options.embed?.draw?.timestamp),options?.embed?.draw?.url&&T.setURL(options.embed?.draw?.url),options.type&&"Button"!==options.type?m.edit({content:"Its a Tie !",embeds:[T.setDescription(`You have tied. Play again to see who wins.
`+`\`\`\`
${R.board[0].emoji} | ${R.board[1].emoji} | ${R.board[2].emoji}
${R.board[3].emoji} | ${R.board[4].emoji} | ${R.board[5].emoji}
${R.board[6].emoji} | ${R.board[7].emoji} | ${R.board[8].emoji}
\`\`\``.replaceAll(t,"➖").replaceAll(S,"⭕").replaceAll(C,"❌"))],components:[]}).then(m=>{m.react(t)}).catch(()=>{}):m.edit({content:"Its a Tie!",embeds:[T.setDescription("You have tied. Play again to see who wins.")],components:y}).then(m=>{m.react(t)})}const f=await D.users.fetch(A[R.user]);m.edit({content:`<@${R.userid}>`,embeds:[I.setAuthor(options.embed?.game?.author||{name:f.username,iconURL:f.displayAvatarURL({forceStatic:!1})}).setDescription(`Waiting for Input | <@!${R.userid}> | Your Emoji: `+(0==R.user?""+(D.emojis.cache.get(S)||"⭕"):""+(D.emojis.cache.get(C)||"❌")))],components:[j,g,w]});const $=m.createMessageComponentCollector({componentType:discord_js_1.ComponentType.Button,max:1,time:(0,misc_1.ms)("30s")});$.on("collect",async b=>{b.user.id!==R.userid&&b.user.id===msgOrint.member.user.id?b.reply({content:`It's <@!${U.id}>'s' turn!`,ephemeral:!0}):b.user.id!==R.userid&&b.user.id===U.id?b.reply({content:`It's <@!${msgOrint.member.user.id}>'s' turn!`,ephemeral:!0}):b.user.id!==R.userid&&b.user.id!==U.id&&b.user.id!==msgOrint.member.user.id?b.reply({content:"You cannot play this game!",ephemeral:!0}):b.user.id!==R.userid||b.user.id!==U.id&&b.user.id!==msgOrint.member.user.id||R.board[Number(b.customId)].emoji!==C?b.user.id!==R.userid||b.user.id!==U.id&&b.user.id!==msgOrint.member.user.id||R.board[Number(b.customId)].emoji!==S?(await b.deferUpdate(),0==R.user?(R.user=1,R.board[Number(b.customId)]={style:v,emoji:S,disabled:!0}):(R.user=0,R.board[Number(b.customId)]={style:E,emoji:C,disabled:!0})):b.reply({content:`That position is pre-occupied by ${D.emojis.cache.get(S)||"⭕"}!`,ephemeral:!0}):b.reply({content:`That position is pre-occupied by ${D.emojis.cache.get(C)||"❌"}!`,ephemeral:!0}),await e(m,{blank_emoji:t})});$.on("end",(collected,reason)=>{--limiter[O].limit,limiter[O].limit<0&&(limiter[O].limit=0);const e=(new discord_js_1.EmbedBuilder).setTitle(options.embed?.timeout?.title||"Game Timed Out!").setColor(options.embed?.timeout?.color||"Red").setDescription(options.embed?.timeout?.description||"The opponent didnt respond in time (30s)").setFooter(options.embed?.timeout?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"});options?.embed?.timeout?.fields&&e.setFields(options.embed?.timeout?.fields),options?.embed?.timeout?.author&&e.setAuthor(options.embed?.timeout?.author),options?.embed?.timeout?.image&&e.setImage(options.embed?.timeout?.image),options?.embed?.timeout?.thumbnail&&e.setThumbnail(options.embed?.timeout?.thumbnail),options?.embed?.timeout?.timestamp&&e.setTimestamp(options.embed?.timeout?.timestamp),options?.embed?.timeout?.url&&e.setURL(options.embed?.timeout?.url),0===collected.size&&"idle"==reason&&(options.type&&"Button"!==options.type?m.edit({content:"The opponent didnt respond in time (30s)",embeds:[e.setDescription(`<@!${R.userid}> didn't react in time! (30s)
`+`\`\`\`
${R.board[0].emoji} | ${R.board[1].emoji} | ${R.board[2].emoji}
${R.board[3].emoji} | ${R.board[4].emoji} | ${R.board[5].emoji}
${R.board[6].emoji} | ${R.board[7].emoji} | ${R.board[8].emoji}
\`\`\``.replaceAll(t,"➖").replaceAll(S,"⭕").replaceAll(C,"❌"))],components:[]}):m.edit({content:`<@!${R.userid}> didn't react in time! (30s)`,embeds:[e],components:(0,misc_1.disableButtons)(y)}))})})(button,{blank_emoji:a})}}),p.on("end",(_collected,reason)=>{var e;--limiter[O].limit,limiter[O].limit<0&&(limiter[O].limit=0),"time"==reason?(e=(new discord_js_1.EmbedBuilder).setTitle(options.embed?.timeout?.title||"Game Timed Out!").setColor(options.embed?.timeout?.color||"Red").setDescription(options.embed?.timeout?.description||"The opponent didnt respond in time (30s)").setFooter(options.embed?.timeout?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"}),options?.embed?.timeout?.fields&&e.setFields(options.embed?.timeout?.fields),options?.embed?.timeout?.author&&e.setAuthor(options.embed?.timeout?.author),options?.embed?.timeout?.image&&e.setImage(options.embed?.timeout?.image),options?.embed?.timeout?.thumbnail&&e.setThumbnail(options.embed?.timeout?.thumbnail),options?.embed?.timeout?.timestamp&&e.setTimestamp(options.embed?.timeout?.timestamp),options?.embed?.timeout?.url&&e.setURL(options.embed?.timeout?.url),t.edit({content:`<@${U.id}> did not accept in time!`,embeds:[e],components:[]})):"decline"==reason&&(e=(new discord_js_1.EmbedBuilder).setColor(options.embed?.decline?.color||"Red").setFooter(options.embed?.decline?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"}).setTitle(options.embed?.decline?.title||"Game Declined!").setDescription(options.embed?.decline?.description||U.username+" has declined your game request!"),options?.embed?.decline?.fields&&e.setFields(options.embed?.decline?.fields),options?.embed?.decline?.author&&e.setAuthor(options.embed?.decline?.author),options?.embed?.decline?.image&&e.setImage(options.embed?.decline?.image),options?.embed?.decline?.thumbnail&&e.setThumbnail(options.embed?.decline?.thumbnail),options?.embed?.decline?.timestamp&&e.setTimestamp(options.embed?.decline?.timestamp),options?.embed?.decline?.url&&e.setURL(options.embed?.decline?.url),t.edit({embeds:[e],components:[]}))})}catch(e){if(options?.strict)throw new error_1.SimplyError({function:"tictactoe",title:"An Error occured when running the function ",tip:e.stack});console.log("SimplyError - tictactoe | Error: "+e.stack)}})}async function ai(msgOrint,options={max:5}){const o=msgOrint["client"];let i=["","","","","","","","",""],s,e;msgOrint.commandId&&(e=msgOrint);var t=msgOrint,n=msgOrint;let r=limiter.findIndex(a=>a.guild==msgOrint.guild.id);if(limiter[r]&&limiter[r].guild||(limiter.push({guild:msgOrint.guild.id,limit:0}),r=limiter.findIndex(a=>a.guild==msgOrint.guild.id)),limiter[r].limit>=(options?.max||6)){if(e)return t.followUp({content:"Sorry, There is a game happening right now. Please try later."});if(!e)return n.reply({content:"Sorry, There is a game happening right now. Please try later."})}const l={board:Array(9).fill({style:options.emptyStyle,emoji:options.blank_emoji,disabled:!1})},d=msgOrint.client.user,p=(new discord_js_1.EmbedBuilder).setTitle(options.embed?.game?.title||msgOrint.member.user.username+" VS "+d.username).setAuthor(options.embed?.game?.author||{name:msgOrint.member.user.username,iconURL:msgOrint.member.user.displayAvatarURL({forceStatic:!1})}).setDescription(`Waiting for Input | <@!${msgOrint.member.user.id}> | Your Emoji: `+(o.emojis.cache.get(options.x_emoji)||"❌")).setColor(options.embed?.game?.color||(0,misc_1.toRgb)("#406DBC")).setFooter(options.embed?.game?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"});options?.embed?.game?.fields&&p.setFields(options.embed?.game?.fields),options?.embed?.game?.author&&p.setAuthor(options.embed?.game?.author),options?.embed?.game?.image&&p.setImage(options.embed?.game?.image),options?.embed?.game?.thumbnail&&p.setThumbnail(options.embed?.game?.thumbnail),options?.embed?.game?.timestamp&&p.setTimestamp(options.embed?.game?.timestamp),options?.embed?.game?.url&&p.setURL(options.embed?.game?.url);var b=h();function u(emoji){return combinations.some(combination=>combination.every(index=>l.board[index].emoji==emoji))}function c(){return[...l.board].every(cell=>cell.emoji==options.x_emoji||cell.emoji==options.o_emoji)}function h(){var e=(new discord_js_1.ButtonBuilder).setStyle(l.board[0].style).setEmoji(l.board[0].emoji).setCustomId("0").setDisabled(l.board[0].disabled),t=(new discord_js_1.ButtonBuilder).setStyle(l.board[1].style).setEmoji(l.board[1].emoji).setCustomId("1").setDisabled(l.board[1].disabled),o=(new discord_js_1.ButtonBuilder).setStyle(l.board[2].style).setEmoji(l.board[2].emoji).setCustomId("2").setDisabled(l.board[2].disabled),i=(new discord_js_1.ButtonBuilder).setStyle(l.board[3].style).setEmoji(l.board[3].emoji).setCustomId("3").setDisabled(l.board[3].disabled),s=(new discord_js_1.ButtonBuilder).setStyle(l.board[4].style).setEmoji(l.board[4].emoji).setCustomId("4").setDisabled(l.board[4].disabled),n=(new discord_js_1.ButtonBuilder).setStyle(l.board[5].style).setEmoji(l.board[5].emoji).setCustomId("5").setDisabled(l.board[5].disabled),m=(new discord_js_1.ButtonBuilder).setStyle(l.board[6].style).setEmoji(l.board[6].emoji).setCustomId("6").setDisabled(l.board[6].disabled),r=(new discord_js_1.ButtonBuilder).setStyle(l.board[7].style).setEmoji(l.board[7].emoji).setCustomId("7").setDisabled(l.board[7].disabled),d=(new discord_js_1.ButtonBuilder).setStyle(l.board[8].style).setEmoji(l.board[8].emoji).setCustomId("8").setDisabled(l.board[8].disabled);return[(new discord_js_1.ActionRowBuilder).addComponents([e,t,o]),(new discord_js_1.ActionRowBuilder).addComponents([i,s,n]),(new discord_js_1.ActionRowBuilder).addComponents([m,r,d])]}e?s=await t.followUp({embeds:[p],components:b}):e||(s=await n.reply({embeds:[p],components:b})),limiter[r].limit+=1;const j=s.createMessageComponentCollector({componentType:discord_js_1.ComponentType.Button,idle:3e4,filter:interaction=>interaction.user.id===msgOrint.member.user.id||(interaction.reply({content:"You cannot play this game!",ephemeral:!0}),!1)});let g=!1;j.on("collect",async button=>{if((c()||u(options.x_emoji)||u(options.o_emoji))&&j.stop(),button.deferred||await button.deferUpdate(),g)await button.followUp({content:`It's <@!${d.id}>'s turn!`,ephemeral:!0});else if(l.board[Number(button.customId)].emoji===options.x_emoji)await button.followUp({content:`That position is pre-occupied by ${o.emojis.cache.get(options.x_emoji)||"❌"}!`,ephemeral:!0});else{if(l.board[Number(button.customId)].emoji!==options.o_emoji){g=!0,i[Number(button.customId)]="x";var e=h();await s.edit({components:e});for(let e=0;e<i.length;e++)"x"==i[e]&&(l.board[e]={style:options.x_style,emoji:options.x_emoji,disabled:!0});e=h();c()||u(options.x_emoji)||u(options.o_emoji)||s.edit({embeds:[p.setDescription(`AI is Thinking.. | <@!${d.id}> | Your Emoji: `+(o.emojis.cache.get(options.o_emoji)||"⭕")).setColor("DarkerGrey")],components:e}),c()||u(options.x_emoji)||u(options.o_emoji)||(j.resetTimer(),i=await aiEngine(i,options.hard||!1));for(let e=0;e<i.length;e++)"o"==i[e]&&(l.board[e]={style:options.o_style,emoji:options.o_emoji,disabled:!0});g=!1;var t,e=h();return c()||u(options.x_emoji)||u(options.o_emoji)||s.edit({embeds:[p.setDescription(`Waiting for Input | <@!${msgOrint.member.user.id}> | Your Emoji: `+(o.emojis.cache.get(options.x_emoji)||"❌")).setColor((0,misc_1.toRgb)("#406DBC"))],components:e}),u(options.x_emoji)?(j.stop(),--limiter[r].limit,limiter[r].limit<0&&(limiter[r].limit=0),e=(new discord_js_1.EmbedBuilder).setTitle(options.embed?.win?.title||msgOrint.member.user.username+" VS "+d.username).setColor(options.embed?.win?.color||"DarkGreen").setFooter(options.embed?.win?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"}),options?.embed?.win?.fields&&e.setFields(options.embed?.win?.fields),options?.embed?.win?.author&&e.setAuthor(options.embed?.win?.author),options?.embed?.win?.image&&e.setImage(options.embed?.win?.image),options?.embed?.win?.thumbnail&&e.setThumbnail(options.embed?.win?.thumbnail),options?.embed?.win?.timestamp&&e.setTimestamp(options.embed?.win?.timestamp),options?.embed?.win?.url&&e.setURL(options.embed?.win?.url),t=h(),options.type&&"Button"!==options.type?"Embed"===options?.type?s.edit({embeds:[e.setDescription(`<@!${msgOrint.member.user.id}> (${o.emojis.cache.get(options.o_emoji)||"❌"}) won, That was a nice game. GG
`+`\`\`\`
${l.board[0].emoji} | ${l.board[1].emoji} | ${l.board[2].emoji}
${l.board[3].emoji} | ${l.board[4].emoji} | ${l.board[5].emoji}
${l.board[6].emoji} | ${l.board[7].emoji} | ${l.board[8].emoji}
\`\`\``.replaceAll(options.blank_emoji,"➖").replaceAll(options.o_emoji,"⭕").replaceAll(options.x_emoji,"❌"))],components:[]}).then(m=>{m.react(options.x_emoji)}):void 0:s.edit({components:(0,misc_1.disableButtons)(t),embeds:[e.setDescription(`<@!${msgOrint.member.user.id}> (${o.emojis.cache.get(options.x_emoji)||"❌"}) won, That was a nice game. GG`)]}).then(m=>{m.react(options.x_emoji)})):u(options.o_emoji)?(j.stop(),--limiter[r].limit,limiter[r].limit<0&&(limiter[r].limit=0),t=(new discord_js_1.EmbedBuilder).setTitle(options.embed?.win?.title||msgOrint.member.user.username+" VS "+d.username).setColor(options.embed?.win?.color||"DarkGreen").setFooter(options.embed?.win?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"}),options?.embed?.win?.fields&&t.setFields(options.embed?.win?.fields),options?.embed?.win?.author&&t.setAuthor(options.embed?.win?.author),options?.embed?.win?.image&&t.setImage(options.embed?.win?.image),options?.embed?.win?.thumbnail&&t.setThumbnail(options.embed?.win?.thumbnail),options?.embed?.win?.timestamp&&t.setTimestamp(options.embed?.win?.timestamp),options?.embed?.win?.url&&t.setURL(options.embed?.win?.url),e=h(),options.type&&"Button"!==options.type?"Embed"===options?.type?s.edit({embeds:[t.setDescription(`<@!${d.id}> (${o.emojis.cache.get(options.o_emoji)||"⭕"}) won, That was a nice game. GG
`+`\`\`\`
${l.board[0].emoji} | ${l.board[1].emoji} | ${l.board[2].emoji}
${l.board[3].emoji} | ${l.board[4].emoji} | ${l.board[5].emoji}
${l.board[6].emoji} | ${l.board[7].emoji} | ${l.board[8].emoji}
\`\`\``.replaceAll(options.blank_emoji,"➖").replaceAll(options.o_emoji,"⭕").replaceAll(options.x_emoji,"❌"))],components:[]}).then(m=>{m.react(options.o_emoji)}):void 0:s.edit({components:(0,misc_1.disableButtons)(e),embeds:[t.setDescription(`<@!${d.id}> (${o.emojis.cache.get(options.o_emoji)||"⭕"}) won, That was a nice game. GG`)]}).then(m=>{m.react(options.o_emoji)})):c()?(j.stop(),--limiter[r].limit,limiter[r].limit<0&&(limiter[r].limit=0),e=(new discord_js_1.EmbedBuilder).setTitle(options.embed?.draw?.title||msgOrint.member.user.username+" VS "+d.username).setDescription(options.embed?.draw?.description||"Thats a draw. Try again").setColor(options.embed?.draw?.color||"Grey").setFooter(options.embed?.draw?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"}),options?.embed?.draw?.fields&&e.setFields(options.embed?.draw?.fields),options?.embed?.draw?.author&&e.setAuthor(options.embed?.draw?.author),options?.embed?.draw?.image&&e.setImage(options.embed?.draw?.image),options?.embed?.draw?.thumbnail&&e.setThumbnail(options.embed?.draw?.thumbnail),options?.embed?.draw?.timestamp&&e.setTimestamp(options.embed?.draw?.timestamp),options?.embed?.draw?.url&&e.setURL(options.embed?.draw?.url),t=h(),options.type&&"Button"!==options.type?s.edit({content:"Its a Tie!",embeds:[e.setDescription(`You have tied. Play again to see who wins.
`+`\`\`\`
${l.board[0].emoji} | ${l.board[1].emoji} | ${l.board[2].emoji}
${l.board[3].emoji} | ${l.board[4].emoji} | ${l.board[5].emoji}
${l.board[6].emoji} | ${l.board[7].emoji} | ${l.board[8].emoji}
\`\`\``.replaceAll(options.blank_emoji,"➖").replaceAll(options.o_emoji,"⭕").replaceAll(options.x_emoji,"❌"))],components:[]}).then(m=>{m.react(options.blank_emoji)}).catch(()=>{}):s.edit({content:"Its a Tie!",embeds:[e.setDescription("You have tied. Play again to see who wins.")],components:t}).then(m=>{m.react(options.blank_emoji)})):void 0}await button.followUp({content:`That position is pre-occupied by ${o.emojis.cache.get(options.o_emoji)||"⭕"}!`,ephemeral:!0})}}),j.on("end",async(_collected,reason)=>{var e;--limiter[r].limit,limiter[r].limit<0&&(limiter[r].limit=0),"idle"===reason&&(reason=h(),e=(new discord_js_1.EmbedBuilder).setTitle(options.embed?.timeout?.title||"Game Timed Out!").setColor(options.embed?.timeout?.color||"Red").setDescription(options.embed?.timeout?.description||"The opponent didn't respond in time (30s)").setFooter(options.embed?.timeout?.footer||{text:"©️ Rahuletto. npm i simply-djs",iconURL:"https://i.imgur.com/XFUIwPh.png"}),options?.embed?.timeout?.fields&&e.setFields(options.embed?.timeout?.fields),options?.embed?.timeout?.author&&e.setAuthor(options.embed?.timeout?.author),options?.embed?.timeout?.image&&e.setImage(options.embed?.timeout?.image),options?.embed?.timeout?.thumbnail&&e.setThumbnail(options.embed?.timeout?.thumbnail),options?.embed?.timeout?.timestamp&&e.setTimestamp(options.embed?.timeout?.timestamp),options?.embed?.timeout?.url&&e.setURL(options.embed?.timeout?.url),1!=g?options.type&&"Button"!==options.type?s.edit({content:`<@${msgOrint.member.user.id}> did not respond in time!`,embeds:[e.setDescription(`The opponent didnt respond in time (30s)
`+`\`\`\`
${l.board[0].emoji} | ${l.board[1].emoji} | ${l.board[2].emoji}
${l.board[3].emoji} | ${l.board[4].emoji} | ${l.board[5].emoji}
${l.board[6].emoji} | ${l.board[7].emoji} | ${l.board[8].emoji}
\`\`\``.replaceAll(options.blank_emoji,"➖").replaceAll(options.o_emoji,"⭕").replaceAll(options.x_emoji,"❌"))],components:[]}):s.edit({content:`<@${msgOrint.member.user.id}> did not respond in time!`,embeds:[e],components:(0,misc_1.disableButtons)(reason)}):options.type&&"Button"!==options.type?s.edit({content:`<@${d.id}> did not respond in time!`,embeds:[e.setDescription(`The opponent didnt respond in time (30s)
`+`\`\`\`
${l.board[0].emoji} | ${l.board[1].emoji} | ${l.board[2].emoji}
${l.board[3].emoji} | ${l.board[4].emoji} | ${l.board[5].emoji}
${l.board[6].emoji} | ${l.board[7].emoji} | ${l.board[8].emoji}
\`\`\``.replaceAll(options.blank_emoji,"➖").replaceAll(options.o_emoji,"⭕").replaceAll(options.x_emoji,"❌"))],components:[]}):s.edit({content:`<@${d.id}> did not respond in time!`,embeds:[e],components:(0,misc_1.disableButtons)(reason)}))})}
// The AI Engine code is from this article https://medium.com/@alialaa/tic-tac-toe-with-javascript-es2015-ai-player-with-minimax-algorithm-59f069f46efa
// Modified for discord.js usage
async function aiEngine(boardArray,hard=!1){var e=new Board(boardArray),t=(new Player).getBestMove(e,!1),e=e.getAvailableMoves();const o=[];return boardArray.forEach(a=>{o.push(a)}),hard?o[Number(t)]="o":o[Number(e[Math.floor(Math.random()*Math.floor(e.length))])]="o",o}exports.tictactoe=tictactoe;class Board{constructor(state=["","","","","","","","",""]){this.state=state}isEmpty(){return this.state.every(cell=>!cell)}isFull(){return this.state.every(cell=>cell)}insert(symbol,position){if(![0,1,2,3,4,5,6,7,8].includes(position))throw new Error("Cell index does not exist!");if(["x","o"].includes(symbol))return!this.state[position]&&(this.state[position]=symbol,!0);throw new Error("The symbol can only be x or o!")}isTerminal(){
//Return False if board in empty
return!this.isEmpty()&&(
//Checking Horizontal Wins
this.state[0]===this.state[1]&&this.state[0]===this.state[2]&&this.state[0]?{winner:this.state[0],direction:"H"}:this.state[3]===this.state[4]&&this.state[3]===this.state[5]&&this.state[3]?{winner:this.state[3],direction:"H"}:this.state[6]===this.state[7]&&this.state[6]===this.state[8]&&this.state[6]?{winner:this.state[6],direction:"H"}:
//Checking Vertical Wins
this.state[0]===this.state[3]&&this.state[0]===this.state[6]&&this.state[0]?{winner:this.state[0],direction:"V"}:this.state[1]===this.state[4]&&this.state[1]===this.state[7]&&this.state[1]?{winner:this.state[1],direction:"V"}:this.state[2]===this.state[5]&&this.state[2]===this.state[8]&&this.state[2]?{winner:this.state[2],direction:"V"}:
//Checking Diagonal Wins
this.state[0]===this.state[4]&&this.state[0]===this.state[8]&&this.state[0]?{winner:this.state[0],direction:"D"}:this.state[2]===this.state[4]&&this.state[2]===this.state[6]&&this.state[2]?{winner:this.state[2],direction:"D"}:
//If no winner but the board is full, then it's a draw
!!this.isFull()&&{winner:"draw"})}getAvailableMoves(){const e=[];return this.state.forEach((cell,index)=>{cell||e.push(index)}),e}}class Player{constructor(maxDepth=-1){this.maxDepth=maxDepth,this.nodesMap=new Map}getBestMove(board,maximizing=!0,depth=0){if(0==depth&&this.nodesMap.clear(),board.isTerminal()||depth===this.maxDepth)return"x"===board.isTerminal().winner?100-depth:"o"===board.isTerminal().winner?-100+depth:0;if(maximizing){
//Initialize best to the lowest possible value
let t=-100;
//Loop through all empty cells
//If it's the main call, return the index of the best move or a random index if multiple indices have the same value
if(board.getAvailableMoves().forEach(index=>{
//Initialize a new board with a copy of our current state
var e=new Board([...board.state]),e=(
//Create a child node by inserting the maximizing symbol x into the current empty cell
e.insert("x",index),this.getBestMove(e,!1,depth+1));
//Updating best value
t=Math.max(t,e),
//If it's the main function call, not a recursive one, map each heuristic value with it's moves indices
0==depth&&(index=this.nodesMap.has(e)?this.nodesMap.get(e)+","+index:index,this.nodesMap.set(e,index))}),0!=depth)
//If not main call (recursive) return the heuristic value for next calculation
return t;{let e;return e="string"==typeof this.nodesMap.get(t)?(o=this.nodesMap.get(t).split(","))[Math.floor(Math.random()*o.length)]:this.nodesMap.get(t)}}if(!maximizing){
//Initialize best to the highest possible value
let t=100;
//Loop through all empty cells
//If it's the main call, return the index of the best move or a random index if multiple indices have the same value
if(board.getAvailableMoves().forEach(index=>{
//Initialize a new board with a copy of our current state
var e=new Board([...board.state]),e=(
//Create a child node by inserting the minimizing symbol o into the current empty cell
e.insert("o",index),this.getBestMove(e,!0,depth+1));
//Updating best value
t=Math.min(t,e),
//If it's the main function call, not a recursive one, map each heuristic value with it's moves indices
0==depth&&(index=this.nodesMap.has(e)?this.nodesMap.get(e)+","+index:index,this.nodesMap.set(e,index))}),0!=depth)
//If not main call (recursive) return the heuristic value for next calculation
return t;{let e;var o;return e="string"==typeof this.nodesMap.get(t)?(o=this.nodesMap.get(t).split(","))[Math.floor(Math.random()*o.length)]:this.nodesMap.get(t)}}}}